function getObjectByInfo(info) {
	var arr = [];
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		if(stage.objects[i].info == info) arr.push(stage.objects[i]);
	};
	if (arr.length == 1) return arr[0];
	else return arr;
}

function getObjectByCustomInfo(info) {
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		if(stage.objects[i].custom == info) return stage.objects[i];
	};
	return {};
}

function attachMouseEvents() {
	this.onmouseover = function(e) {
		e.target.gotoAndStop(1);
	}	
	
	this.onmouseout = function(e) {
		e.target.gotoAndStop(0);
	}	
	
	this.onmousedown = function(e) {
		e.target.gotoAndStop(2);
	}	
	
	this.onmouseup = function(e) {
		e.target.gotoAndStop(1);
	}
}

function addLiftHandlers(arr) {
	var lift = this,
		bob = field.bob;
	arr[0].gotoAndStop(0);
	arr[1].gotoAndStop(1);
	addHint.call(arr[0], arr[0].x, arr[0].y);
	arr[1].locked = true;
	arr.forEach(function(el){
		el.onclick = function(e) {
			if (!e.target.locked) {
				e.target.gotoAndStop(1);
				e.target.locked = true;
				
				if (e.target === arr[0]) {
					if (isSoundOn) mixer.play('snd_button');
					arr[0].hint.removeHint();
					addHint.call(arr[1], arr[1].x, arr[1].y);
					arr[1].locked = false;
					arr[1].gotoAndStop(0);
				}
				else {
					if (isSoundOn) mixer.play('snd_button_ground_on');
					arr[1].hint.removeHint();
					addHint.call(arr[0], arr[0].x, arr[0].y);
					arr[0].locked = false;
					arr[0].gotoAndStop(0);
				}
				
				// Перемещение лифта
				if (lift.GetCenterPosition().y <= 115) return;
				lift.sprite.setStatic(false);
				var limit = lift.GetCenterPosition().y - 13;	
				var bob_pos;
				var int = stage.setInterval(function(){
					pos = lift.GetCenterPosition();
					pos.y -= 2;
					lift.SetCenterPosition(pos, 0);

					if (checkIfBobOnLift(lift.sprite)) {
						bob_pos = bob.box2dBody.GetCenterPosition();
						bob_pos.y -= 2;
						bob.box2dBody.SetCenterPosition(bob_pos, 0);
					}

					if (pos.y <= limit) {
						stage.clearInterval(int);
						stage.setTimeout(function(){lift.sprite.setStatic(true);},1);
					}
				},1);
			}
		};			
	});
}

function moveLift(direction) {
	var b = this.box2dBody,
		pos,
		bob_pos,
		bob = field.bob.box2dBody,
		self = this;
	
	if (moveLift.int) stage.clearInterval(moveLift.int);

	this.setStatic(false);
	this.cover.setStatic(false);
	
	switch (direction) {
		case 'up':
			moveLift.int = stage.setInterval(function(){
				pos = b.GetCenterPosition();
				pos.y -= 1;
				b.SetCenterPosition(pos, 0);

				if (checkIfBobOnLift(self)) {
					bob_pos = bob.GetCenterPosition();
					bob_pos.y -= 1;
					bob.SetCenterPosition(bob_pos, 0);
				}
				
				if (pos.y == 200) {
					stage.clearInterval(moveLift.int);
					
					self.setStatic(true);
					self.cover.setStatic(true);
				}
			},1);
			break;
			
		case 'down':
			moveLift.int = stage.setInterval(function(){
				pos = b.GetCenterPosition();
				pos.y += 1;
				b.SetCenterPosition(pos, 0);

				if (pos.y == 247) {
					stage.clearInterval(moveLift.int);
					
					self.setStatic(true);
					self.cover.setStatic(true);					
				}
			},1);		
			break;
			
		default:
			console.log('unknown direction');
	}
}

function checkIfBobOnLift(lift) {
	var bob = field.bob;
	if (!stage.hitTest(bob, lift)) return false;
	if (bob.y > lift.y) return false;
	if ((lift.x - lift.width/2) <= bob.x && 
		(lift.x + lift.width/2) >= bob.x) {
		return true;
	}
}


//для поворота боба на барабане(3,7,18,20 уровни)		
function turnBob(platform) {
	var bob = field.bob;
	if (stage.hitTest(bob, platform)) {
		//было, что при вращении Боба, если переключить скорость - он идёт задом 
		field.turning = true;
		if(bob.state != 'hide') bob.forceSleep();
		bob.direction = (bob.direction == 'right') ? 'left' : 'right';
		if (bob.state == 'hide') {
			bob.changeState('BobHideTurn');
			bob.BobHideTurn.gotoAndPlay(0);
		} else {

			bob.changeState('BobTurns');
			bob.BobTurns.gotoAndPlay(0);
		}
	}	
}

function processSlider(platform) {
	var bob = field.bob;
	var BobTurns = addBobState('BobTurns', 47, 561/14, 14);
	BobTurns.scaleX = -1;
	BobTurns.onenterframe = function(e) {
		if (e.target.currentFrame == 13 && e.target.animated) {
			bob.forceWakeUp();
			bob.speed *= -1;
			e.target.stop();
			setStateAfterTurn();
		}
	};

	var BobHideTurn = addBobState('BobHideTurn', 56, 504/14, 14);
	BobHideTurn.scaleX = -1;
	BobHideTurn.onenterframe = function(e) {
		if (e.target.currentFrame == 13 && e.target.animated) {
			bob.temp_speed *= -1;
			e.target.stop();
			setStateAfterTurn();
		}
	};

	var slider = this;
	addHint.call(slider, slider.x, slider.y);
	slider.static = true;
	slider.onclick = function(e) {
		if (slider.locked || bob.state == 'show' || field.turning) return;
		if(isSoundOn) mixer.play('snd_turn_around', false);
		slider.locked = true;
		if (bob.direction == 'left') {
			platform.gotoAndPlay(0);
			platform.onenterframe = function(e) {
				if (e.target.currentFrame == 13) {
					e.target.gotoAndStop(0);
					slider.locked = false;
					platform.onenterframe = null;
				}
			}
			turnBob(platform);
		} else {
			platform.rewindAndStop(13);
			
			platform.onenterframe = function(e) {
				if (e.target.currentFrame == 0) {
					e.target.stop();
					slider.locked = false;
					platform.onenterframe = null;
				}
			}
			turnBob(platform);
		}
	}		
}
function setStateAfterTurn(){
	var bob = field.bob;
	switch (Math.abs(bob.speed)){
		case SPEED_WALK: 
			bob.changeState('walk');
		break;
		case SPEED_RUN: 
			bob.changeState('run');
		break;
		case 0: 
			bob.changeState('hide');
		break;
		default:
			console.log('bob.speed = '+ bob.speed);
		break;
	}
	stage.setTimeout(function(){field.turning = false;}, Math.ceil(fps*0.4));
}

function rotateHandler(but, restriction, earth){
	var bridge = this,
		bob = field.bob,
		block,
		left,
		int;
	
	var pos = bridge.GetCenterPosition();
	but.onmousedown = function(){
		if (but.info.indexOf('left') != -1) left = true;
		if (block) return;
		var oldRot = bridge.GetRotation();

		if ((left && oldRot <= restriction) ||
		 (!left && oldRot >= restriction)) return;

		block = true;
		bridge.sprite.setStatic(false);
		if (earth) earth.setStatic(false);
			int = stage.setInterval(function(){
			var rot = bridge.GetRotation();
			if (left) rot -= 0.05;
			else rot += 0.05;
			bridge.SetCenterPosition(pos, rot);

			if ( (left && rot <= restriction) || (!left && rot >= restriction)) stopRotate();
		}, 1);
	}
	but.onmouseup = stopRotate;
	but.onmouseout = stopRotate;

	function stopRotate(){
		if (block) {
			stage.setTimeout(function(){
				bridge.sprite.setStatic(true);
				if (earth) earth.setStatic(true);
			}, 1);
			stage.clearInterval(int);
			block = false;
		}
	}
}
function latchMove(distance){
	var obj = this,
		left,
		pos = obj.box2dBody.GetCenterPosition();
	
	obj.onclick = function(e){
		var obj = e.target;

		if (obj.position == 'left') {
			obj.position = 'right';
			obj.hint.x += distance;
			pos.x += distance;
			obj.box2dBody.SetCenterPosition(pos, 0);
		} else {
			obj.position = 'left';
			obj.hint.x -= distance;
			pos.x -= distance;
			obj.box2dBody.SetCenterPosition(pos, 0);
		}
	}
};
function moveMechanism(mechanism, stone){
	var obj = this;
	obj.onclick = function(){
		if (isSoundOn) mixer.play('snd_lever_double', false);

		obj.setStatic(false);
		obj.gotoAndPlay(0);
		obj.onenterframe = function(e) { 
			var obj = e.target;
			if (obj.currentFrame == 5) {
				obj.gotoAndStop(5);
				obj.hint.removeHint();
				obj.setStatic(true);
			}
		}
		mechanism.setStatic(false);
		mechanism.gotoAndPlay(0);
		stone.box2dBody.WakeUp();
		
		obj.onclick = null;	
	}	
}
function moveBridge(but, restriction, earth, earth2, switchStatic){
// function moveBridge(but, restriction){
		var bridge = this,
		bob = field.bob,
		block,
		left,
		int;
	
	var pos = bridge.GetCenterPosition();
	but.onmousedown = function(){
		if (but.info.indexOf('left') != -1) left = true;
		if (block) return;
		var oldPos = bridge.GetCenterPosition();

		if ((left && oldPos.x <= restriction) ||
		 (!left && oldPos.x >= restriction)) return;

		block = true;
		if (switchStatic) {
			bridge.sprite.setStatic(false);
			if (earth) earth.setStatic(false);
			if (earth2) earth2.setStatic(false);
		};
		int = stage.setInterval(function(){
			var pos = bridge.GetCenterPosition();
			if (left) pos.x -= 4;
			else pos.x += 4;
			bridge.SetOriginPosition(pos, 0);

			if ( (left && pos.x <= restriction) || (!left && pos.x >= restriction)) stopRotate();
		}, 1);
	}
	but.onmouseup = stopRotate;
	but.onmouseout = stopRotate;

	function stopRotate(){
		if (block) {	
			if (switchStatic) {	
				stage.setTimeout(function(){
					bridge.sprite.setStatic(true);
					if (earth) earth.setStatic(true);
					if (earth2) earth2.setStatic(true);
				}, 1);
			};
			stage.clearInterval(int);
			block = false;
		}
	}
}

