var KINDLE_VERSION = false;
var stage;
var world;
var GET;
var LANDSCAPE_MODE = true;
var bitmaps;
var width = 480;
var height = 320;
var fps = 24;

var gameState;
var STATE_SPLASH = 0;
var STATE_GAME = 1;
var STATE_MENU = 2;
var STATE_SELECT_LEVEL = 3;
var STATE_VICTORY = 4;
var STATE_GAME_OVER = 5;
var STATE_COMICS = 6;
var STATE_FINAL = 7;
var STATE_CREDITS = 8;
var comics;

var field;
var pause = false;
var currentLevel;
var screenWidthCoef;
var screenHeightCoef;
var	gameScore, totalScore;

var SPEED_WALK = fps*1.5;
var SPEED_RUN = fps*3;
var MORE_GAMES_URL = 'http://hunter-hamster.com/';

var mixer;
var isMusicOn;
var isSoundOn/*, loopSound*/;
var playingMusic;

var console = {log: function(){}};

var editorLevel = 13;

var stageProps = {width: 480, height: 320};
var SPRITE_OFFSET_X;
window.onload = function() {
	GET = Utils.parseGet();
	Utils.addMobileListeners(LANDSCAPE_MODE);
	Utils.mobileCorrectPixelRatio();
	Utils.addFitLayoutListeners();
	setTimeout(startLoad, 600);
}

function startLoad() {
	var resolution = Utils.getMobileScreenResolution(LANDSCAPE_MODE);
	if (GET["debug"] == 1) resolution = Utils.getScaleScreenResolution(1, LANDSCAPE_MODE);

	resolution = Utils.getScaleScreenResolution(1.5, LANDSCAPE_MODE);
	Utils.globalScale = resolution.scale;
	
	// Определение коэфициента ширины для нестандартных экранов
	var ratioCoefs = [1.5];
	var ratioWidth = [1];
	var ratioHeight = [1];

	if(window.innerWidth > window.innerHeight) var coef = window.innerWidth/window.innerHeight;
	else var coef = window.innerHeight/window.innerWidth;
		
	var min = 100000, minPos = -1, diff;
	for(var i=0; i<ratioCoefs.length-1; i++)
	{
		diff = Math.abs(coef - ratioCoefs[i]);
		if(diff < min)
		{
			min = diff;
			minPos = i;
		}
	}
	
	minPos = 0;
	screenWidthCoef = ratioWidth[minPos];
	screenHeightCoef = ratioHeight[minPos];
	screenWidthRatioPos = minPos;
	
	// resolution.width = Math.floor(resolution.width*1.1375);
		/////////////////////////////////////////
	SPRITE_OFFSET_X = 0;
	var rect = Utils.getWindowRect();
	
	var c1 = stageProps.width / stageProps.height;
	var c2 = rect.width / rect.height;
	if(c2 > c1) {
		if (c2 > 1092/640) c2 = 1092/640;
		stageProps.width = Math.ceil(stageProps.height * c2);
		resolution.width = Math.ceil(resolution.height * c2);
		SPRITE_OFFSET_X = (stageProps.width-480)/2;
	}
	initializeLevels();
	// /////////////////////////////////////////
	// 
	Utils.createLayout(document.getElementById("main_container"), resolution);
	Utils.addEventListener("fitlayout", function() {
		if (stage) {
			stage.drawScene(document.getElementById("screen"));
			buildBackground();
		}
	});
	Utils.addEventListener("lockscreen", function()	{ if (stage && stage.started) stage.stop(); });
	Utils.addEventListener("unlockscreen", function() { if (stage && !stage.started) stage.start(); });
	
	Utils.mobileHideAddressBar();
	
	if (GET["debug"] != 1) Utils.checkOrientation(LANDSCAPE_MODE);
	
	var preloader = new ImagesPreloader();
	var data = [];
	var path = Utils.imagesRoot + "/" + Utils.globalScale + "/";

	console.log('Scale = ' + Utils.globalScale);
	data.push({name: "hourglass", src: path+"hourglass.png"});

	// Menu
	data.push({name: 'LevelsMap', src: path + 'menu/' + 'LevelsMap.png'});
	data.push({name: 'Lvl_locked', src: path + 'menu/' + 'Lvl_locked.png'});
	data.push({name: 'LvlN', src: path + 'menu/' + 'LvlN.png'});
	data.push({name: 'numb', src: path + 'menu/' + 'numb.png'});
	data.push({name: 'addToWebsite', src: path + 'menu/' + 'addToWebsite.png'});
	data.push({name: 'bobMenu1', src: path + 'menu/' + 'bobMenu1.png'});
	data.push({name: 'bobMenu2', src: path + 'menu/' + 'bobMenu2.png'});
	data.push({name: 'bobMenu3', src: path + 'menu/' + 'bobMenu3.png'});
	data.push({name: 'bobMenu4', src: path + 'menu/' + 'bobMenu4.png'});
	data.push({name: 'credits', src: path + 'menu/' + 'credits.png'});
	data.push({name: 'highscores', src: path + 'menu/' + 'highscores.png'});
	// data.push({name: 'intro', src: path + 'menu/' + 'intro.png'});
	data.push({name: 'menuBack', src: path + 'menu/' + 'menuBack.png'});
	data.push({name: 'moreGames', src: path + 'menu/' + 'moreGames.png'});
	// data.push({name: 'musicButton', src: path + 'menu/' + 'musicButton.png'});
	data.push({name: 'play', src: path + 'menu/' + 'play.png'});
	data.push({name: 'soundButton', src: path + 'menu/' + 'soundButton.png'});
	data.push({name: 'num_lvl_map_up', src: path + 'menu/' + 'num_lvl_map_up.png'});
	data.push({name: 'lvl_numbs', src: path + 'menu/' + 'lvl_numbs.png'});
	data.push({name: 'score_num', src: path + 'menu/' + 'score_num.png'});
	data.push({name: 'menu_btn', src: path + 'menu/' + 'menu_btn.png'});
	for(var i = 1; i<21; i++){
		data.push({name: 'smallLvl'+i, src: path + 'menu/' + 'smallLvl' + i + '.png'});	
	}

	data.push({name: 'flies', src: path + 'menu/' + 'flies.png'});
	data.push({name: 'Preloader', src: path + 'menu/' + 'Preloader.jpg'});
	data.push({name: 'SnailBob1BtnMc', src: path + 'menu/' + 'SnailBob1BtnMc.png'});
	data.push({name: 'fly_final', src: path + 'menu/' + 'fly_final.png'});


	//credits
	data.push({name: 'creditsBack', src: path + 'credits/' + 'creditsBack.png'});
	data.push({name: 'Facebook', src: path + 'credits/' + 'Facebook.png'});
	data.push({name: 'logo', src: path + 'credits/' + 'logo.png'});
	data.push({name: 'x0001', src: path + 'credits/' + 'x0001.png'});

	//comics
	data.push({name: 'Skip_btn', src: path + 'comics/' + 'Skip_btn.png'});
	
	for (var i = 1; i < 9; i++) {
		data.push({name: 'comics'+i, src: path + 'comics/comics'+i+'.jpg'});	
	};

	// General
	data.push({name: 'Bob', src: path + 'Bob.png'});	
	data.push({name: 'BobGo', src: path + 'BobGo.png'});	
	data.push({name: 'BobRun', src: path + 'BobRun.png'});	
	data.push({name: 'BobShow', src: path + 'BobShow.png'});	
	data.push({name: 'BobHide', src: path + 'BobHide.png'});		
	data.push({name: 'tube1', src: path + 'tube1.png'});	
	data.push({name: 'tube2', src: path + 'tube2.png'});	
	data.push({name: 'invisible_wall_small', src: path + 'invisible_wall_small.png'});	
	data.push({name: 'invisible_wall_big', src: path + 'invisible_wall_big.png'});	
	data.push({name: 'BackTube', src: path + 'BackTube.png'});	
	data.push({name: 'TubeCoverMc', src: path + 'TubeCoverMc.png'});	
	data.push({name: 'SpeedBob', src: path + 'SpeedBob.png'});	
	data.push({name: 'SspeedStandardBtn', src: path + 'SspeedStandardBtn.png'});	
	data.push({name: 'SpeedFastBtn', src: path + 'SpeedFastBtn.png'});	
	data.push({name: 'SpeedIndicatorMc', src: path + 'SpeedIndicatorMc.png'});	
	data.push({name: 'Lvl', src: path + 'Lvl.png'});	
	data.push({name: 'LVL_map', src: path + 'LVL_map.png'});	
	data.push({name: 'restart', src: path + 'restart.png'});	
	data.push({name: 'score', src: path + 'score.png'});
	data.push({name: 'NextLeveButton', src: path + 'NextLeveButton.png'});	
	data.push({name: 'TryAgainButton', src: path + 'TryAgainButton.png'});	
	data.push({name: 'PanelLevelComplete', src: path + 'PanelLevelComplete.png'});	
	data.push({name: 'GameOver', src: path + 'GameOver.png'});	
	data.push({name: 'Hint', src: path + 'Hint.png'});
	data.push({name: 'LVL_map_new', src: path + 'LVL_map_new.png'});

	data.push({name: 'Baraban', src: path + 'Baraban.png'});		
	data.push({name: 'slider', src: path + 'slider.png'});
	data.push({name: 'BobTurns', src: path + 'BobTurns.png'});		
	data.push({name: 'BobHideTurn', src: path + 'BobHideTurn.png'});
	data.push({name: 'button_blue_left', src: path + 'button_blue_left.png'});
	data.push({name: 'button_blue_mid', src: path + 'button_blue_mid.png'});
	data.push({name: 'button_blue_right', src: path + 'button_blue_right.png'});
	data.push({name: 'button_red', src: path + 'button_red.png'});
	data.push({name: 'button_blue', src: path + 'button_blue.png'});
	data.push({name: 'BobGrowl', src: path + 'BobGrowl.png'});
	data.push({name: 'BobFall1', src: path + 'BobFall1.png'});
	data.push({name: 'BobFall2', src: path + 'BobFall2.png'});
	data.push({name: 'BobFall3', src: path + 'BobFall3.png'});
	data.push({name: 'lever_cover_down', src: path + 'lever_cover_down.png'});
	data.push({name: 'lever_cover_left', src: path + 'lever_cover_left.png'});
	data.push({name: 'lever_cover_right', src: path + 'lever_cover_right.png'});
	data.push({name: 'lever_cover_up', src: path + 'lever_cover_up.png'});
	data.push({name: 'mechanism', src: path + 'mechanism.png'});		
	data.push({name: 'button_blue_down', src: path + 'button_blue_down.png'});		
	data.push({name: 'button_blue_up', src: path + 'button_blue_up.png'});
	data.push({name: 'BobFlatten', src: path + 'BobFlattenAnimMc.png'});
	data.push({name: 'BobBurn', src: path + 'BobBurnAnimMc1.png'});
	data.push({name: 'BobBurnAnimMc2', src: path + 'BobBurnAnimMc2.png'});

	//transporant
	data.push({name: 'bob2', src: path + 'transporant/' + 'bob2.png'});	
	data.push({name: 'bob3', src: path + 'transporant/' + 'bob3.png'});	
	data.push({name: 'transporant2', src: path + 'transporant/' + 'transporant2.png'});	
	data.push({name: 'transporant3', src: path + 'transporant/' + 'transporant3.png'});	
	
	//final
	data.push({name: 'Bob_on_the_beach', src: path + 'final/' + 'Bob_on_the_beach.png'});	
	data.push({name: 'BobFoundHouse', src: path + 'final/' + 'BobFoundHouse.png'});	
	data.push({name: 'final_screen', src: path + 'final/' + 'final_screen.png'});	
	data.push({name: 'nicely_dine', src: path + 'final/' + 'nicely_dine.png'});	
	data.push({name: 'TotalScoreTextLocaliz0001', src: path + 'final/' + 'TotalScoreTextLocaliz0001.png'});	
	
	//general too
	data.push({name: 'Lever1', src: path + 'levels/01/' + 'Lever1.png'});		
	data.push({name: 'Lever2', src: path + 'levels/02/' + 'Lever2.png'});
	data.push({name: 'Lever4', src: path + 'levels/04/' + 'Lever4.png'});
	data.push({name: 'spring', src: path + 'levels/06/' + 'spring.png'});
	data.push({name: 'spring_up', src: path + 'levels/08/' + 'spring_up.png'});		
	data.push({name: 'btn02', src: path + 'levels/02/' + 'btn.png'});
	data.push({name: 'lantern_lvl18', src: path + 'levels/18/' + 'lantern_lvl18.png'});
	data.push({name: 'turnBtn_lvl18', src: path + 'levels/18/' + 'turnBtn_lvl18.png'});

	// Level 1
	data.push({name: 'Lvl1_back', src: path + 'levels/01/' + 'Lvl1_back.png'});	
	data.push({name: 'fly', src: path + 'levels/01/' + 'fly.png'});	
	data.push({name: 'DoorLevel01', src: path + 'levels/01/' + 'DoorLevel01.png'});		
	data.push({name: 'Spring', src: path + 'levels/01/' + 'Spring.png'});		
	data.push({name: 'yellow_element', src: path + 'levels/01/' + 'yellow_element.png'});	
	data.push({name: 'Hint1_Level10001', src: path + 'levels/01/' + 'Hint1_Level10001.png'});	
	data.push({name: 'Hint2_Level10001', src: path + 'levels/01/' + 'Hint2_Level10001.png'});	

	// Level 2
	data.push({name: 'Lvl2_back', src: path + 'levels/02/' + 'Lvl2_back.png'});
	data.push({name: 'conveyor', src: path + 'levels/02/' + 'conveyor.png'});
	data.push({name: 'crossbar', src: path + 'levels/02/' + 'perekladina.png'});
	data.push({name: 'electric_detail', src: path + 'levels/02/' + 'electric_detail.png'});
	data.push({name: 'electricity_10', src: path + 'levels/02/' + 'electricity_10.png'});
	data.push({name: 'shocked', src: path + 'levels/02/' + 'electroshock1.png'});
	data.push({name: 'shocked2', src: path + 'levels/02/' + 'electroshock2.png'});
	data.push({name: 'spirit', src: path + 'levels/02/' + 'spirit.png'});
	data.push({name: 'ArrowAnim_yellow0001', src: path + 'levels/02/' + 'ArrowAnim_yellow0001.png'});
	data.push({name: 'ArrowAnim0001', src: path + 'levels/02/' + 'ArrowAnim0001.png'});
	data.push({name: 'HintClickBob_Level20001', src: path + 'levels/02/' + 'HintClickBob_Level20001.png'});
	data.push({name: 'HintMc1_Level20001', src: path + 'levels/02/' + 'HintMc1_Level20001.png'});
	data.push({name: 'HintMc2_Level20001', src: path + 'levels/02/' + 'HintMc2_Level20001.png'});
	data.push({name: 'HintMc3_Level20001', src: path + 'levels/02/' + 'HintMc3_Level20001.png'});
	data.push({name: 'earth_lvl2', src: path + 'levels/02/' + 'earth_lvl2.png'});

	// Level 3
	data.push({name: 'Lvl3_back', src: path + 'levels/03/' + 'Lvl3_back.png'});		
	data.push({name: 'button_blue_mid_lvl3', src: path + 'levels/03/' + 'button-blue-mid-lvl3.png'});		
	data.push({name: 'Lift_lv3', src: path + 'levels/03/' + 'Lift_lv3.png'});		
	data.push({name: 'Hint1_Level30001', src: path + 'levels/03/' + 'Hint1_Level30001.png'});		
	data.push({name: 'HoldText0001', src: path + 'levels/03/' + 'HoldText0001.png'});		

	// Level 4
	data.push({name: 'Lvl4_back', src: path + 'levels/04/' + 'Lvl4_back.png'});
	data.push({name: 'Latch_lvl4', src: path + 'levels/04/' + 'Latch_lvl4.png'});
	data.push({name: 'stone_lvl4', src: path + 'levels/04/' + 'stone_lvl4.png'});
	data.push({name: 'wooden_cross_lvl4', src: path + 'levels/04/' + 'wooden_cross_lvl4.png'});

	// Level 5
	data.push({name: 'Lvl5_back', src: path + 'levels/05/' + 'Lvl5_back.png'});
	data.push({name: 'Bridge_lvl5', src: path + 'levels/05/' + 'Bridge_lvl5.png'});
	data.push({name: 'wagon_lvl5', src: path + 'levels/05/' + 'wagon_lvl5.png'});
	data.push({name: 'wagon_whel_lvl5', src: path + 'levels/05/' + 'wagon_whel_lvl5.png'});
	data.push({name: 'wood_on_rope_lvl5', src: path + 'levels/05/' + 'wood_on_rope_lvl5.png'});
	data.push({name: 'tube5', src: path + 'tube1.png'});	
	data.push({name: 'peregorodka_lvl5', src: path + 'levels/05/' + 'peregorodka_lvl5.png'});

	// Level 6
	data.push({name: 'Lvl6_back', src: path + 'levels/06/' + 'Lvl6_back.png'});
	data.push({name: 'brig', src: path + 'levels/06/' + 'brig.png'});
	data.push({name: 'btn_lvl6', src: path + 'levels/06/' + 'btn_lvl6.png'});
	data.push({name: 'cable_lvl6', src: path + 'levels/06/' + 'cable_lvl6.png'});
	data.push({name: 'tube_lvl6', src: path + 'levels/06/' + 'tube_lvl6.png'});
	data.push({name: 'BasketballDestroying', src: path + 'levels/06/' + 'BasketballDestroying.png'});
	data.push({name: 'stone_lvl6', src: path + 'levels/06/' + 'stone_lvl6.png'});
	data.push({name: 'ball_falls_lvl6', src: path + 'levels/06/' + 'ball_falls_lvl6.png'});
	data.push({name: 'earth_lvl6', src: path + 'levels/06/' + 'earth_lvl6.png'});

	// Level 7
	data.push({name: 'Lvl7_back', src: path + 'levels/07/' + 'Lvl7_back.png'});		
	data.push({name: 'BobFallsInLove', src: path + 'levels/07/' + 'BobFallsInLove.png'});		
	data.push({name: 'inLove', src: path + 'levels/07/' + 'inLove.png'});		
	data.push({name: 'BobFalls', src: path + 'levels/07/' + 'BobFalls.png'});		
	data.push({name: 'fence', src: path + 'levels/07/' + 'fence.png'});		
	data.push({name: 'Girlfriend', src: path + 'levels/07/' + 'Girlfriend.png'});		
	data.push({name: 'Stove', src: path + 'levels/07/' + 'Stove.png'});		
	data.push({name: 'ice', src: path + 'levels/07/' + 'ice.png'});		
	data.push({name: 'oven_lever', src: path + 'levels/07/' + 'oven_lever.png'});		
	data.push({name: 'Lift_lv7', src: path + 'levels/07/' + 'Lift_lv7.png'});		
	data.push({name: 'Btn_lv7', src: path + 'levels/07/' + 'Btn_lv7.png'});		

	// Level 8
	data.push({name: 'Lvl8_back', src: path + 'levels/08/' + 'Lvl8_back.png'});		
	data.push({name: 'before_bridge_lvl8', src: path + 'levels/08/' + 'before_bridge_lvl8.png'});		
	data.push({name: 'bridge_lvl8', src: path + 'levels/08/' + 'bridge_lvl8.png'});		
	data.push({name: 'latch_lvl8', src: path + 'levels/08/' + 'latch_lvl8.png'});		

	// Level 9
	data.push({name: 'Lvl9_back', src: path + 'levels/09/' + 'Lvl9_back.png'});		
	data.push({name: 'button_lvl9', src: path + 'levels/09/' + 'button_lvl9.png'});		
	data.push({name: 'earth1_lvl9', src: path + 'levels/09/' + 'earth1_lvl9.png'});		
	data.push({name: 'earth2_lvl9', src: path + 'levels/09/' + 'earth2_lvl9.png'});		
	data.push({name: 'earth3_lvl9', src: path + 'levels/09/' + 'earth3_lvl9.png'});		
	data.push({name: 'earth4_lvl9', src: path + 'levels/09/' + 'earth4_lvl9.png'});		
	data.push({name: 'lamp', src: path + 'levels/09/' + 'lamp.png'});		
	data.push({name: 'wire', src: path + 'levels/09/' + 'wire.png'});		
	data.push({name: 'bridge_lvl9', src: path + 'levels/09/' + 'bridge_lvl9.png'});		

	// Level 11
	data.push({name: 'Lvl10_back', src: path + 'levels/11/' + 'Lvl11_back.png'});		
	data.push({name: 'bridge_lvl11', src: path + 'levels/11/' + 'bridge_lvl11.png'});		
	data.push({name: 'button_lvl11', src: path + 'levels/11/' + 'button_lvl11.png'});		
	data.push({name: 'fire_lvl11', src: path + 'levels/11/' + 'fire_lvl11.png'});		
	data.push({name: 'lava', src: path + 'levels/11/' + 'lava.png'});		
	data.push({name: 'pliers_catch', src: path + 'levels/11/' + 'pliers_catch.png'});		
	data.push({name: 'pliers_down', src: path + 'levels/11/' + 'pliers_down.png'});		
	data.push({name: 'rope_lvl11', src: path + 'levels/11/' + 'rope_lvl11.png'});		
	data.push({name: 'smoke1_lvl11', src: path + 'levels/11/' + 'smoke1_lvl11.png'});		
	data.push({name: 'smoke2_lvl11', src: path + 'levels/11/' + 'smoke2_lvl11.png'});		
	data.push({name: 'tube_lvl11', src: path + 'levels/11/' + 'tube_lvl11.png'});		
	data.push({name: 'block_lvl11', src: path + 'levels/11/' + 'block_lvl11.png'});		

	// Level 12
	data.push({name: 'Lvl11_back', src: path + 'levels/12/' + 'Lvl12_back.png'});		
	data.push({name: 'bridge_lvl12', src: path + 'levels/12/' + 'bridge_lvl12.png'});		
	data.push({name: 'button_lvl12', src: path + 'levels/12/' + 'button_lvl12.png'});		
	data.push({name: 'circle_lvl12', src: path + 'levels/12/' + 'circle_lvl12.png'});		
	data.push({name: 'prop_lvl12', src: path + 'levels/12/' + 'prop_lvl12.png'});		

	// Level 13
	data.push({name: 'Lvl12_back', src: path + 'levels/13/' + 'Lvl13_back.png'});		
	data.push({name: 'bridge_lvl13', src: path + 'levels/13/' + 'bridge_lvl13.png'});		
	data.push({name: 'button_lvl13', src: path + 'levels/13/' + 'button_lvl13.png'});		
	data.push({name: 'press', src: path + 'levels/13/' + 'press.png'});		
	data.push({name: 'prop_lvl13', src: path + 'levels/13/' + 'prop_lvl13.png'});		
	data.push({name: 'sticks', src: path + 'levels/13/' + 'sticks.png'});			
	data.push({name: 'rope2', src: path + 'levels/13/' + 'rope2.png'});		
	data.push({name: 'rope3', src: path + 'levels/13/' + 'rope3.png'});		
	data.push({name: 'rope4', src: path + 'levels/13/' + 'rope4.png'});		
	data.push({name: 'rope5', src: path + 'levels/13/' + 'rope5.png'});		
	data.push({name: 'rope6', src: path + 'levels/13/' + 'rope6.png'});		
	data.push({name: 'smoke_lvl13', src: path + 'levels/13/' + 'smoke_lvl13.png'});		


	// Level 14
	data.push({name: 'Lvl13_back', src: path + 'levels/14/' + 'Lvl14_back.png'});		
	data.push({name: 'carriage1_lvl14', src: path + 'levels/14/' + 'carriage1_lvl14.png'});		
	data.push({name: 'carriage2_lvl14', src: path + 'levels/14/' + 'carriage2_lvl14.png'});		
	data.push({name: 'carriage3_lvl14', src: path + 'levels/14/' + 'carriage3_lvl14.png'});		
	data.push({name: 'carriage4_lvl14', src: path + 'levels/14/' + 'carriage4_lvl14.png'});		
	data.push({name: 'circle_exit', src: path + 'levels/14/' + 'circle_exit.png'});		
	data.push({name: 'circle_lvl14', src: path + 'levels/14/' + 'circle_lvl14.png'});		
	data.push({name: 'pc1', src: path + 'levels/14/' + 'pc1.png'});		
	data.push({name: 'pc2', src: path + 'levels/14/' + 'pc2.png'});		
	data.push({name: 'pc3', src: path + 'levels/14/' + 'pc3.png'});		
	data.push({name: 'pc4', src: path + 'levels/14/' + 'pc4.png'});

	// Level 15
	data.push({name: 'Lvl14_back', src: path + 'levels/15/' + 'Lvl15_back.png'});
	data.push({name: 'box_lvl15', src: path + 'levels/15/' + 'box_lvl15.png'});
	data.push({name: 'bridge_lvl15', src: path + 'levels/15/' + 'bridge_lvl15.png'});
	data.push({name: 'circle_lvl15', src: path + 'levels/15/' + 'circle_lvl15.png'});
	data.push({name: 'earth1_lvl15', src: path + 'levels/15/' + 'earth1_lvl15.png'});
	data.push({name: 'earth2_lvl15', src: path + 'levels/15/' + 'earth2_lvl15.png'});
	data.push({name: 'prop_lvl15', src: path + 'levels/15/' + 'prop_lvl15.png'});
	data.push({name: 'mechanism_lvl15', src: path + 'levels/15/' + 'mechanism_lvl15.png'});
	data.push({name: 'smoke_lvl15', src: path + 'levels/15/' + 'smoke_lvl15.png'});

	// Level 16
	data.push({name: 'Lvl15_back', src: path + 'levels/16/' + 'Lvl16_back.png'});
	data.push({name: 'bridge_lvl16', src: path + 'levels/16/' + 'bridge_lvl16.png'});
	data.push({name: 'latch_lvl16', src: path + 'levels/16/' + 'latch_lvl16.png'});
	data.push({name: 'pump_down', src: path + 'levels/16/' + 'pump_down.png'});
	data.push({name: 'pump_up', src: path + 'levels/16/' + 'pump_up.png'});
	data.push({name: 'ball1', src: path + 'levels/16/' + 'ball1.png'});
	data.push({name: 'ball2', src: path + 'levels/16/' + 'ball2.png'});
	data.push({name: 'ball3', src: path + 'levels/16/' + 'ball3.png'});
	data.push({name: 'ball4', src: path + 'levels/16/' + 'ball4.png'});
	data.push({name: 'ball5', src: path + 'levels/16/' + 'ball5.png'});
	data.push({name: 'ball6', src: path + 'levels/16/' + 'ball6.png'});
	data.push({name: 'ball7', src: path + 'levels/16/' + 'ball7.png'});
	data.push({name: 'circle_lvl16', src: path + 'levels/16/' + 'circle_lvl16.png'});

	// Level 17
	data.push({name: 'Lvl16_back', src: path + 'levels/17/' + 'Lvl17_back.png'});
	data.push({name: 'bridge_lvl17', src: path + 'levels/17/' + 'bridge_lvl17.png'});
	data.push({name: 'btn_Fire', src: path + 'levels/17/' + 'btn_Fire.png'});
	data.push({name: 'FireTimeAnim', src: path + 'levels/17/' + 'FireTimeAnim.png'});
	data.push({name: 'earth_lvl17', src: path + 'levels/17/' + 'earth_lvl17.png'});
	data.push({name: 'fire_lvl17', src: path + 'levels/17/' + 'fire_lvl17.png'});
	data.push({name: 'fire_small', src: path + 'levels/17/' + 'fire_small.png'});

		// Level 10
	data.push({name: 'Lvl17_back', src: path + 'levels/10/' + 'Lvl10_back.png'});		
	data.push({name: 'energy_box', src: path + 'levels/10/' + 'energy_box.png'});		
	data.push({name: 'lantern', src: path + 'levels/10/' + 'lantern.png'});		
	data.push({name: 'pillar_lvl10', src: path + 'levels/10/' + 'pillar_lvl10.png'});		
	data.push({name: 'Radiation1', src: path + 'levels/10/' + 'Radiation1.png'});		
	data.push({name: 'Radiation2', src: path + 'levels/10/' + 'Radiation2.png'});		
	data.push({name: 'small_tube_lvl10', src: path + 'levels/10/' + 'small_tube_lvl10.png'});		
	data.push({name: 'up_cover_lvl10', src: path + 'levels/10/' + 'up_cover_lvl10.png'});		
	data.push({name: 'bridge_lvl10', src: path + 'levels/10/' + 'bridge_lvl10.png'});		
	data.push({name: 'barrier_lvl10', src: path + 'levels/10/' + 'barrier_lvl10.png'});		
	data.push({name: 'minus_plus', src: path + 'levels/10/' + 'minus_plus.png'});
	data.push({name: 'radiationAnim1', src: path + 'levels/10/' + 'radiationAnim1.png'});
	data.push({name: 'radiationAnim2', src: path + 'levels/10/' + 'radiationAnim2.png'});
	data.push({name: 'radiationAnim3', src: path + 'levels/10/' + 'radiationAnim3.png'});

	// Level 18
	data.push({name: 'Lvl18_back', src: path + 'levels/18/' + 'Lvl18_back.png'});
	data.push({name: 'bridge1_lvl18', src: path + 'levels/18/' + 'bridge1_lvl18.png'});
	data.push({name: 'bridge2_lvl18', src: path + 'levels/18/' + 'bridge2_lvl18.png'});
	data.push({name: 'btnForTrans', src: path + 'levels/18/' + 'btnForTrans.png'});
	data.push({name: 'current_lvl18', src: path + 'levels/18/' + 'current_lvl18.png'});
	data.push({name: 'earth_lvl18', src: path + 'levels/18/' + 'earth_lvl18.png'});
	data.push({name: 'green_lvl18', src: path + 'levels/18/' + 'green_lvl18.png'});
	data.push({name: 'lift_lvl18', src: path + 'levels/18/' + 'lift_lvl18.png'});
	data.push({name: 'red_lvl18', src: path + 'levels/18/' + 'red_lvl18.png'});
	data.push({name: 'trans1', src: path + 'levels/18/' + 'trans1.png'});
	data.push({name: 'trans2', src: path + 'levels/18/' + 'trans2.png'});
	data.push({name: 'trans3', src: path + 'levels/18/' + 'trans3.png'});
	data.push({name: 'trans4', src: path + 'levels/18/' + 'trans4.png'});
	data.push({name: 'zemlaUp', src: path + 'levels/18/' + 'zemlaUp.png'});

	// Level 19
	data.push({name: 'Lvl19_back', src: path + 'levels/19/' + 'Lvl19_back.png'});
	data.push({name: 'bridge_lvl19', src: path + 'levels/19/' + 'bridge_lvl19.png'});
	data.push({name: 'circle_lvl19', src: path + 'levels/19/' + 'circle_lvl19.png'});
	data.push({name: 'cover_lvl19', src: path + 'levels/19/' + 'cover_lvl19.png'});
	data.push({name: 'earth_lvl19', src: path + 'levels/19/' + 'earth_lvl19.png'});
	data.push({name: 'foundation', src: path + 'levels/19/' + 'foundation.png'});
	data.push({name: 'foundation2', src: path + 'levels/19/' + 'foundation2.png'});

	// Level 20
	data.push({name: 'Lvl20_back', src: path + 'levels/20/' + 'Lvl20_back.png'});
	data.push({name: 'boxGreen', src: path + 'levels/20/' + 'boxGreen.png'});
	data.push({name: 'boxRed', src: path + 'levels/20/' + 'boxRed.png'});
	data.push({name: 'bridgeDown_lvl20', src: path + 'levels/20/' + 'bridgeDown_lvl20.png'});
	data.push({name: 'bridgeUp_lvl20', src: path + 'levels/20/' + 'bridgeUp_lvl20.png'});
	data.push({name: 'earthDown_lvl20', src: path + 'levels/20/' + 'earthDown_lvl20.png'});
	data.push({name: 'earthUp_lvl20', src: path + 'levels/20/' + 'earthUp_lvl20.png'});
	data.push({name: 'lift_cover1', src: path + 'levels/20/' + 'lift_cover1.png'});
	data.push({name: 'lift_cover2', src: path + 'levels/20/' + 'lift_cover2.png'});
	data.push({name: 'lift_lvl20', src: path + 'levels/20/' + 'lift_lvl20.png'});
	data.push({name: 'minus_plus_green', src: path + 'levels/20/' + 'minus_plus_green.png'});
	data.push({name: 'minus_plus_red', src: path + 'levels/20/' + 'minus_plus_red.png'});
	data.push({name: 'tube_cover_lvl20', src: path + 'levels/20/' + 'tube_cover_lvl20.png'});
	
	//Прелоадер с Бэком
	var preloaderBack = new ImagesPreloader();
	var dataBack = [];
	dataBack.push({name: 'HunterHamster', src: path + 'SplashScreen_HunterHamster.jpg'});

	preloaderBack.load(dataBack, function(dataBack){
	    createLoadStage();
		
		var back = new Sprite(dataBack.HunterHamster, 546, 320);
		back.x = 240;
		back.y = 160;
		stage.addChild(back);

		preloader.load(data, loadImagesEnd, showCocoonLoader);
	});
}

function loadImagesEnd(data) {
	bitmaps = data;

	getLevelsScores();
    
    if(parseInt(Utils.getCookie("snail_bob_sound")) == 2) {
        isMusicOn = false;
    	isSoundOn = false;
    } else {
    	isMusicOn = true;
    	isSoundOn = true;
    }
	
	mixer = new AudioMixer("Music", 5);
	if(isMusicOn) playingMusic = mixer.play('game_music1', true, true, 0);			

	if(GET["debug"] != 1) {
		gameState = STATE_SPLASH;
		createScene();
	}
	
}
Sprite.prototype.rewindAndStop = function(frame) {
	var self = this;
	this.currentFrame = frame;
	var int = stage.setInterval(function(){
		self.prevFrame();
		if (self.currentFrame == 0) {
			self.stop();
			stage.clearInterval(int);
		}
	}, this.animDelay);
}

Sprite.prototype.prevFrame = function() {
	this.dispatchEvent("enterframe",
	{
		target: this
	});
	if(this.history && !this.history.created) this.updateHistory();

	if (this.currentFrame == 0) {
		this.currentFrame = this.totalFrames - 1;
	} else {
		this.currentFrame--;
	}
};

Sprite.prototype.setStatic = function(value) {
	if (this.static == value) return;
	this.static = value;
	field.rebuildBack = true;
}

function getStageWidth() {return Math.floor(480 * screenWidthCoef);}
function getStageHeight() {return Math.floor(320 * screenHeightCoef);}
function getStageCenter() {return getStageWidth()/2;}
function getStageHeightCenter() {return getStageHeight()/2;}

function createScene() {	
	createStage();
	if (gameState == STATE_SPLASH) {
		showSplash();
	};
	if (gameState == STATE_MENU) {
		showMenu();
	}	
	if (gameState == STATE_SELECT_LEVEL) {
		showLevelSelect();
	}	
	
	if (gameState == STATE_GAME) {
		field = new GameField();
		field.init(currentLevel - 1);
	}
	if (gameState == STATE_COMICS){
		showComics();
	}
	
	buildBackground();
	stage.start();	
};
function showSplash() {

	var back = new Sprite(bitmaps.Preloader, 546, 320);
	back.x = 240;
	back.y = 160;
	back.static = true;
	stage.addChild(back);

	var play = new Sprite(bitmaps.play, 88, 30, 4);
	play.x = 221;
	play.y = 223;
	play.stop();
	play.onclick = function(){
		gameState = STATE_MENU;
		createScene();
	};
	stage.addChild(play);
	attachMouseEvents.call(play);	

	if (KINDLE_VERSION) {
		var mc = new Sprite(bitmaps.SnailBob1BtnMc, 180, 155);
		mc.x = 50;
		mc.y = 250;
		mc.onclick = showSecondBob;
		stage.addChild(mc);
	} else {
		var part2 = new Sprite(bitmaps.bob2, 94, 100);
		part2.x = 65;
		part2.y = 250;
		part2.static = true;
		part2.onclick = showSecondBob;
		stage.addChild(part2);

		var trans2 = new TilesSprite(bitmaps.transporant2, 102, 42, 30, 10, 3);
		trans2.x = 68;
		trans2.y = 196;
		stage.addChild(trans2);

		var part3 = new Sprite(bitmaps.bob3, 92, 100);
		part3.x = 412;
		part3.y = 252;
		part3.static = true;
		part3.onclick = showThirdBob;
		stage.addChild(part3);

		var trans3 = new TilesSprite(bitmaps.transporant3, 100, 40, 29, 10, 3);
		trans3.x = 415;
		trans3.y = 195;
		stage.addChild(trans3);
	}

};

function addFly(transporant, x, y, sx){
	var fly = new Sprite(bitmaps.fly_final, 22, 22, 6);
	fly.x = x;
	fly.y = y;
	if (sx) fly.scaleX = -1;
	stage.addChild(fly);
	
	var flyTween = stage.createTween(fly, 'y', y, y+2.5, transporant.animDelay*14, Easing.linear.easeIn);
	var flyTween2 = stage.createTween(fly, 'y', y+2.5, y, transporant.animDelay*14, Easing.linear.easeIn);
	flyTween.onfinish = flyTween2.play;
	flyTween2.onfinish = flyTween.play;
	flyTween.play();

};
function showSecondBob(){
	CocoonJS.App.openURL('http://www.hunter-hamster.com/rdrct/googlePlay/worlds/SB_GooglePlay_SB_World2_Redirect.php');
};
function showThirdBob(){
	CocoonJS.App.openURL('http://www.hunter-hamster.com/rdrct/googlePlay/worlds/SB_GooglePlay_SB_World3_Redirect.php');
};
function showFinalScreen(){
	if (isMusicOn) mixer.play('snd_final', true, true, 0);
	var bg = new SpritesGroup(stage);
    bg.x = 240;
    bg.y = -160;
		var back = new Sprite(bitmaps.final_screen, 546, 320);
		back.gx = 0;
		back.gy = 0;
		bg.addChild(back, true);


	if (KINDLE_VERSION) {	
		var mc = new Sprite(bitmaps.SnailBob1BtnMc, 180, 155);
		mc.gx = -96;
		mc.gy = 20;
		mc.onclick = showSecondBob;
		bg.addChild(mc, true);
	} else {
		var part2 = new Sprite(bitmaps.bob2, 94, 100);
		part2.gx = -81;
		part2.gy = 44;
		part2.onclick = showSecondBob;
		bg.addChild(part2, true);

		var trans2 = new TilesSprite(bitmaps.transporant2, 102, 42, 30, 10, 3);
		trans2.gx = -79.5;
		trans2.gy = 16;
		bg.addChild(trans2, true);

		var part3 = new Sprite(bitmaps.bob3, 92, 100);
		part3.gx = 79.5;
		part3.gy = 44;
		part3.onclick = showThirdBob;
		bg.addChild(part3, true);

		var trans3 = new TilesSprite(bitmaps.transporant3, 100, 40, 29, 10, 3);
		trans3.gx = 81;
		trans3.gy = 16;
		bg.addChild(trans3, true);
	}

	var mc = new TilesSprite(bitmaps.Bob_on_the_beach, 281, 106, 11, 6, 2);
	mc.gx = 46;
	mc.gy = 25;
	mc.animDelay = 3;
	bg.addChild(mc, true);

	var tween = stage.createTween(bg, 'y', bg.y, 160, fps, Easing.circular.easeOut);
	tween.onfinish = function(){tween1.play();};
	tween.play();

	mc = new Sprite(bitmaps.BobFoundHouse, 323, 53);
	mc.x = -185;
	mc.y = 30;
	stage.addChild(mc);
	var tween1 = stage.createTween(mc, 'x', mc.x, 240, fps, Easing.quartic.easeOut);
	tween1.onfinish = function(){tween2.play();};

	mc = new Sprite(bitmaps.nicely_dine, 202, 64);
	mc.x = 615;
	mc.y = 65;
	stage.addChild(mc);
	var tween2 = stage.createTween(mc, 'x', mc.x, 240, fps, Easing.quartic.easeOut);
	tween2.onfinish = function(){tween3.play();};

    var group = new SpritesGroup(stage);
    group.x = -185;
    group.y = 110;

		var back = new Sprite(bitmaps.TotalScoreTextLocaliz0001, 162, 29);
		back.gx = 0; back.gy = 0;
		group.addChild(back, true); 
	
		var totalscore = getTotalLevelsScores();
	    
		var levelScoreText = new SimpleText(bitmaps.score_num, 8, 12);
		levelScoreText.align = levelScoreText.ALIGN_LEFT;
		levelScoreText.x = 26;
		levelScoreText.y = 0;
		levelScoreText.write(totalscore);
		levelScoreText.addToGroup(group);

	var tween3 = stage.createTween(group, 'x', group.x, 240, fps, Easing.quartic.easeOut);

	var mc = new Sprite(bitmaps.menu_btn, 84, 45);
	mc.x = 550;
	mc.y = 300;
	mc.rotation = -Math.PI/2;
	mc.onclick = function(){
	if (isMusicOn) playingMusic = mixer.play('game_music1', true, true, 0);
		gameState = STATE_MENU;
		createScene();
	}
	tween3.onfinish = function(){
		var int = stage.setInterval(function(){
			var vec = new Vector(-130, -20);
			mc.rotation += 0.1;
			vec.rotate(-mc.rotation);

			mc.x = 520 + vec.x;
			mc.y = 160 + vec.y;
			if (mc.rotation >= -0.1) {
				stage.clearInterval(int);
			}	
		},1);
	};
	stage.addChild(mc);

	function addSpriteToGroup(bm, w, h, f, x, y){
		var mc = new Sprite(bitmaps[bm], w, h, f);
		mc.gx = x;
		mc.gy = y;
		mc.animDelay = 2;
		bg.addChild(mc, true);
		return mc;
	};
	function addFlyToGroup(x, y, sx){
		var fly = addSpriteToGroup('fly_final', 22, 22, 6, x, y);
		fly.animDelay = 1;
		if (sx) fly.gscaleX = -1;
		var flyTween = stage.createTween(fly, 'gy', y, y+2.5, transporant.animDelay*14, Easing.linear.easeIn);
		var flyTween2 = stage.createTween(fly, 'gy', y+2.5, y, transporant.animDelay*14, Easing.linear.easeIn);
		flyTween.onfinish = flyTween2.play;
		flyTween2.onfinish = flyTween.play;
		flyTween.play();
	};

}

function showComics(){
	if(isMusicOn) mixer.play('snd_intro', true, true, 0);

	var back = new Sprite(null, 546, 320);
	back.x = 240;
	back.y = 160;
	back.fillColor = '#fff';
	back.static = true;
	stage.addChild(back);

	createComix(1);

    var skipBtn = new Sprite(bitmaps.Skip_btn, 70, 32);
    skipBtn.x = 440 + SPRITE_OFFSET_X;
    skipBtn.y = 300;
    skipBtn.onclick = function(){
		if (isMusicOn) playingMusic = mixer.play('game_music1', true, true, 0);
    	prepareLevel();
    	comics = false;
    }
    stage.addChild(skipBtn);

    buildBackground();
}
function createComix(num){
	var mc = new Sprite(bitmaps['comics'+ num], 546, 320);
	mc.x = 819;
	mc.y = 160;
	mc.setZIndex(1);
	stage.addChild(mc);

	var tween = stage.createTween(mc, "x", 819, 240, fps*2, Easing.exponential.easeOut);
	var tween2 = stage.createTween(mc, "x", 240, -273, fps*2, Easing.exponential.easeOut);
	tween.play();
	tween.onfinish = function(){
		num++;
		if (num>8) stage.setTimeout(function(){
			if (isMusicOn) playingMusic = mixer.play('game_music1', true, true, 0);
			prepareLevel();
			comics = false;
		}, fps*1.5);
		stage.setTimeout(function(){
			createComix(num);
			tween2.play();	
		}, fps);
	};
	tween2.onfinish = function(){mc.destroy = true;}

}
function createStage() {
	if (stage) {
		stage.destroy();
		stage.stop();
	}
	stage = new Stage('screen', stageProps.width, stageProps.height);
	stage.delay = 1000/fps;
	stage.showFPS = false;
	stage.onpretick = mainLoop;
	// stage.pixelMouseDownEvent = true;

	/**
	*	Для отладки физики
	*/	
	// stage.onposttick = debugDraw;

	/**
	*	Для отладки спрайтов
	*/
	// stage.allowDebugDrawing = true;
}
		
function step() {
	if (field.locked) return;

	field.bob.synchPosition();
	
	if (field.bob.state != 'fly' && !field.cancelSpeed && field.bob.box2dBody.GetContactList()) {
		field.bob.box2dBody.m_linearVelocity.x = field.bob.speed;	
	}

	checkIfWin();
}

function mainLoop() {
	if (gameState != STATE_GAME) return;
	if (pause && field.locked) return false;
	if (field.rebuildBack) {
		field.rebuildBack = false;
		buildBackground();
	}
	
	world.Step(1/(fps*2), 1);
	world.Step(1/(fps*2), 1);
	step();
	
	stage.box2dSync(world);
}

function showLevelSelect() {
	var back = new Sprite(bitmaps.LevelsMap, 546, 350);
	back.setPosition(getStageCenter(), getStageHeightCenter());
	back.static = true;
	stage.addChild(back);	

	var totalscore = getTotalLevelsScores();

	var levelScoreText = new SimpleText(bitmaps.score_num, 8, 12);
	levelScoreText.align = levelScoreText.ALIGN_LEFT;
	levelScoreText.x = 252;
	levelScoreText.y = 10;
	levelScoreText.static = true;
	levelScoreText.write(totalscore);


	for (var i = 0; i < levels.length; i++) {
		if (levelsScores[i-1]<0) var bm = bitmaps.Lvl_locked;
		else var bm = bitmaps.LvlN;

		var lvl_img = new Sprite(bm, 57, 46);
        var n = Math.floor(i/4);
        lvl_img.x = (i-n*4)*60+60;
        lvl_img.y = n*51 + 70;
		lvl_img.static = true;
		lvl_img.index = i+1;
		lvl_img.onmousedown = function(e) {
			if (e.target.index-1 == 0 || levelsScores[e.target.index-2] >= 0) {
				currentLevel = e.target.index;
				smallLvl.bitmap = bitmaps['smallLvl' + currentLevel];
				stage.setTimeout(prepareLevel, Math.floor(fps/4));
				return false;
			}		
		}
		stage.addChild(lvl_img);

		if(levelsScores[i] >= 0) {
			var levelScoreText = new SimpleText(bitmaps.num_lvl_map_up, 8, 10);
			levelScoreText.align = levelScoreText.ALIGN_LEFT;
			levelScoreText.x = (i-n*4)*60+40;;
			levelScoreText.y = n*51 + 50;
			levelScoreText.static = true;
			levelScoreText.write(levelsScores[i]);			
		}
		if (i == 0 || levelsScores[i-1] >= 0) {
			var t = new SimpleText(bitmaps.numb, 23, 20);
			t.align = t.ALIGN_CENTER;
			t.x = lvl_img.x;
			t.y = lvl_img.y+1;
			t.static = true;
			t.write(i+1);
		};
	}
	for (var i = 0; i < levels.length; i++) {
		if (levelsScores[i]<0 || i == levels.length-1) {
			var lastLevel = i+1;
			break;
		}
	};

	var mc = new Sprite(bitmaps.menu_btn, 84, 45);
	mc.x = 45-SPRITE_OFFSET_X;
	mc.y = 25;
	mc.onclick = function(){
		gameState = STATE_MENU;
		createScene();
	}
	stage.addChild(mc);

	var smallLvl = new Sprite(bitmaps['smallLvl'+ lastLevel], 133, 104);
	smallLvl.x = 395;
	smallLvl.y = 160;
	stage.addChild(smallLvl);
	
	mc = new Sprite(bitmaps.soundButton, 45, 45, 2);
	mc.x = 315;	
	mc.y = 295;
	if(isMusicOn) mc.gotoAndStop(0);
	else mc.gotoAndStop(1);
	mc.onclick = toggleSound;
	stage.addChild(mc);

	// var transporant = new TilesSprite(bitmaps.flies, 125, 38, 30, 15, 2);
	// transporant.x = 442;
	// transporant.y = 225;
	// stage.addChild(transporant);
	if (KINDLE_VERSION) {
		var mc = new Sprite(bitmaps.SnailBob1BtnMc, 180, 155);
		mc.x = 430;
		mc.y = 265;
		mc.scaleX = 0.9;
		mc.scaleY = 0.9;
		mc.onclick = showSecondBob;
		stage.addChild(mc);
	}


	// addFly(transporant, 384, 202);
	// addFly(transporant, 502, 206, true);

}
function getLevelsScores()
{
	levelsScores = [];
	var s = Utils.getCookie('snail_bob_levels_scores') + "";
	if(s != "null")	levelsScores = s.split(',');
	for(var i=0; i<levels.length; i++)
	{
		if(!levelsScores[i]) levelsScores[i] = -1;
		levelsScores[i] *= 1;
	}
}

function saveLevelsScores()
{
	Utils.setCookie('snail_bob_levels_scores', levelsScores.join(","));
}

function getTotalLevelsScores()
{
	var sum = 0;
	for(var i=0; i<levels.length; i++)
	{
		if(levelsScores[i] >= 0) sum += levelsScores[i];
	}
	return sum;
}

function showMenu() {
	var back = new Sprite(bitmaps.menuBack, 546, 320);
	back.setPosition(getStageCenter(), getStageHeightCenter());
	back.static = true;
	stage.addChild(back);	

	var playBtn = new Sprite(bitmaps.play, 88, 30, 4);
	playBtn.x = 133;	
	playBtn.y = 80;
	playBtn.rotation = -0.1;
	playBtn.stop();
	playBtn.onclick = function(){
		if (gameState != STATE_MENU) return;
		gameState = STATE_SELECT_LEVEL;
		createScene();
	}
	stage.addChild(playBtn);
	attachMouseEvents.call(playBtn);

	var mc = new Sprite(bitmaps.credits, 98, 30, 4);
	mc.x = 150;	
	mc.y = 130;
	mc.rotation = -0.06;
	mc.stop();
	mc.onclick = showCredits;
	stage.addChild(mc);
	attachMouseEvents.call(mc);

	var mc = new Sprite(bitmaps.moreGames, 140, 30, 4);
	mc.x = 175;	
	mc.y = 180;
	mc.rotation = -0.02;
	mc.stop();
	mc.onclick = function(){
		if (gameState != STATE_MENU) return;
		showMoreGames();
	} 
	stage.addChild(mc);
	attachMouseEvents.call(mc);

	var mc = new Sprite(bitmaps.bobMenu1, 80, 72, 13);
	mc.x = 93;
	mc.y = 255;
	mc.animDelay = 2;
	mc.num = 2;
	mc.onenterframe = function(e){
		var obj = e.target;
		if(obj.currentFrame == 12){
			obj.bitmap = bitmaps['bobMenu'+ obj.num];
			obj.gotoAndPlay(0);
			if (obj.num != 4) obj.num++;
			else obj.num = 1;
		}
	};
	stage.addChild(mc);

	if (KINDLE_VERSION) {	
		var mc = new Sprite(bitmaps.SnailBob1BtnMc, 180, 155);
		mc.x = 425;
		mc.y = 260;
		mc.onclick = showSecondBob;
		stage.addChild(mc);
	} else {
		var part2 = new Sprite(bitmaps.bob2, 94, 100);
		part2.x = 65;
		part2.y = 170;
		part2.static = true;
		part2.onclick = showSecondBob;
		stage.addChild(part2);

		var trans2 = new TilesSprite(bitmaps.transporant2, 102, 42, 30, 10, 3);
		trans2.x = 68;
		trans2.y = 116;
		stage.addChild(trans2);

		var part3 = new Sprite(bitmaps.bob3, 92, 100);
		part3.x = 412;
		part3.y = 162;
		part3.static = true;
		part3.onclick = showThirdBob;
		stage.addChild(part3);

		var trans3 = new TilesSprite(bitmaps.transporant3, 100, 40, 29, 10, 3);
		trans3.x = 415;
		trans3.y = 115;
		stage.addChild(trans3);
	}

	var mc = new Sprite(bitmaps.soundButton, 45, 45, 2);
	mc.x = 353;	
	mc.y = 175;	
	if(isMusicOn) mc.gotoAndStop(0);
	else mc.gotoAndStop(1);
	mc.onclick = toggleSound;
	stage.addChild(mc);
}
function showCredits(){
	if (gameState != STATE_MENU) return;
	gameState = STATE_CREDITS;
    var credits = new SpritesGroup(stage);
    credits.x = 93;
    credits.y = 255;
    // credits.x = 240;
    // credits.y = 160;
	credits.scaleX = 0.01;
	credits.scaleY = 0.01;

		var back = new Sprite(bitmaps.creditsBack, 250, 250);
		back.gx = 0; back.gy = 0;
		credits.addChild(back, true);

		var logo = new Sprite(bitmaps.logo, 150, 62);
		logo.gx = 10; logo.gy = -12;
		logo.onclick = showMoreGames;
		credits.addChild(logo, true);

		var fb = new Sprite(bitmaps.Facebook, 150, 24);
		fb.gx = 10; fb.gy = 27;
		fb.onclick = function(){
			CocoonJS.App.openURL('https://www.facebook.com/SnailBobGame');
		};
		credits.addChild(fb, true);

		var exit = new Sprite(bitmaps.x0001, 31, 30);
		exit.gx = 52; exit.gy = -50;
		exit.onclick = function(){
			stage.createTween(credits, 'scaleX', credits.scaleX, 0, fps, Easing.quartic.easeOut).play();
			stage.createTween(credits, 'scaleY', credits.scaleY, 0, fps, Easing.quartic.easeOut).play();
			stage.createTween(credits, 'x', credits.x, 93, fps, Easing.quartic.easeOut).play();
			stage.createTween(credits, 'y', credits.y, 255, fps, Easing.quartic.easeOut).play();
			gameState = STATE_MENU;
		};
		credits.addChild(exit, true);

	stage.createTween(credits, 'scaleX', 0.01, 1, fps, Easing.quartic.easeIn).play();
	stage.createTween(credits, 'scaleY', 0.01, 1, fps, Easing.quartic.easeIn).play();
	stage.createTween(credits, 'x', credits.x, 240, fps, Easing.quartic.easeIn).play();
	stage.createTween(credits, 'y', credits.y, 160, fps, Easing.quartic.easeIn).play();
}
function showMoreGames(){
	CocoonJS.App.openURL(MORE_GAMES_URL)
}
function checkIfWin() {
	if (stage.hitTest(field.bob, field.destination) && 
		getDistance(field.bob, field.destination) < 15) {
		showWinScreen();
	}
}

function showWinScreen() {
	if (gameState != STATE_GAME) return;
	mixer.stop(1); //остановка зацикленных звуков
	if (isSoundOn) mixer.play('snd_level_completed', false);

	if(levelsScores[currentLevel - 1] < gameScore){
		levelsScores[currentLevel - 1] = gameScore;
		saveLevelsScores();	
	}
	
	if(currentLevel == levels.length){
		gameState = STATE_FINAL;
		showFinalScreen();
		return;
	}
	gameState = STATE_VICTORY;
	var back_mal = new Sprite(null, 546, 320);
	back_mal.setPosition(getStageCenter(), getStageHeightCenter());
	back_mal.fillColor = '#FFFFFF';
	back_mal.opacity = 0.5;
	back_mal.onclick = function(){return false};
	stage.addChild(back_mal);	

    var popup = new SpritesGroup(stage);
    popup.x = 240;
    popup.y = 160;
	popup.scaleX = 0.01;
	popup.scaleY = 0.01;

	var back = new Sprite(bitmaps.PanelLevelComplete, 250, 248);
	back.gx = 0; back.gy = 0;
	popup.addChild(back, true); 

	var logoCleared = new Sprite(bitmaps.logoCleared, 93, 30);
	logoCleared.gx = -6; logoCleared.gy = -37;
	logoCleared.onclick = showMoreGames;
	popup.addChild(logoCleared, true);    
    
	var levelScoreText = new SimpleText(bitmaps.numb, 23, 20);;
	levelScoreText.align = levelScoreText.ALIGN_LEFT;
	levelScoreText.x = 0;
	levelScoreText.y = 3;
	levelScoreText.write(gameScore);
	levelScoreText.addToGroup(popup);

	// Анимация	
	var int = stage.setInterval(function(){
		popup.scaleX += 0.06;
		popup.scaleY += 0.06;
		
		if (popup.scaleX >= 1) {
			popup.scaleX = 1;
			popup.scaleY = 1;
			
			next_btn.opacity = lvl_map.opacity = 1;
			stage.clearInterval(int);
		}
	},1);
	
	var next_btn = new Sprite(bitmaps.NextLeveButton, 136, 44);
	next_btn.setPosition(getStageCenter() + 30, getStageHeightCenter() + 55);
	next_btn.opacity = 0;
	next_btn.onclick = function(){
		if (currentLevel == levels.length || !levels[currentLevel].objects.length) {
			gameState = STATE_SELECT_LEVEL;
			createScene();
		} else {
			currentLevel++;
			prepareLevel();
		}
		return false;
	};
	stage.addChild(next_btn);	
	
	var lvl_map = new Sprite(bitmaps.LVL_map, 40, 26);
	lvl_map.setPosition(getStageCenter() - 65, getStageHeightCenter() + 30);
	lvl_map.onclick = function(){
		gameState = STATE_SELECT_LEVEL;
		createScene();
		return false;
	};
	lvl_map.opacity = 0;
	stage.addChild(lvl_map);	
}

function showGameOverScreen() {
	if (gameState != STATE_GAME) return;
	stage.setTimeout(function(){
		gameState = STATE_GAME_OVER;
		
		mixer.stop(1);

		var back_mal = new Sprite(null, 546, 320);
		back_mal.setPosition(getStageCenter(), getStageHeightCenter());
		back_mal.fillColor = '#FFFFFF';
		back_mal.opacity = 0.5;
		back_mal.onclick = function(){return false};
		stage.addChild(back_mal);	

		var back = new Sprite(bitmaps.GameOver, 251, 242);
		back.setPosition(getStageCenter(), getStageHeightCenter());
		stage.addChild(back);	
		
		var try_btn = new Sprite(bitmaps.TryAgainButton, 83, 24);
		try_btn.setPosition(getStageCenter() + 14, getStageHeightCenter() + 40);
		try_btn.onclick = restartLevel;
		stage.addChild(try_btn);
	}, fps);
}

function buildBackground() {
    if (stage) stage.drawScene(document.getElementById("screen_background"), true);
    // console.log('buildBackground');
}

function findObject(name) {
	for (var i = 0; i < objects.length; i++) {
		if (objects[i].name == name) return objects[i];
	}
	return false;
}
function prepareLevel()
{
	if (currentLevel == 1 && !comics) {
		comics = true;
		gameState = STATE_COMICS;
		createScene();
		return;
	}
	if(stage){
		mc = new Sprite(bitmaps.hourglass, 100, 150, 1);
		mc.x = 240;
		mc.y = 130;
		stage.addChild(mc);
	}
	setTimeout(function(){
		gameState = STATE_GAME;
		createScene();
	}, (1000/fps)*2);
}
function deleteObject(sprite) {
	sprite.destroy = true;
	
	if (sprite.box2dBody) {
		world.DestroyBody(sprite.box2dBody);
	}
}

function debugDraw() {
	if (gameState != STATE_GAME || field.locked || pause) return false;
	
	if (world) drawWorld(world, stage);
}

// Функция для дизайнера уровней
function startLevel(n, data) {
	createStage();
	
	field = new GameField();
	field.init(n, data);

	buildBackground();
	stage.start();	
}

var cY;

function disableSpriteRotation(e)
{
	e.target.rotation = 0;
}

var SnailBob = function() {
	var self = this;
	
	var loc = getBobLocation();
	
	this.obj = createObject({type: "Bob", x: loc.x, y: loc.y, rotation: 0});
	
	var me = self.obj;
	
	// Массив состояний боба
	me.states = [];
	
	// Запрет на поворот тела
	// me.box2dBody.m_invI = 0;
	me.onbox2dsync = disableSpriteRotation;
	
	//me.box2dBody.m_invMass = 0;
	
	// Начальная скорость
	me.speed = SPEED_WALK;
	me.opacity = 0;

	me.direction = 'right';
	
	// Состояние перемещения
	me.state = 'walk';
	var walk = new Sprite(bitmaps.BobGo, 50, 40, 17);
	walk.setPosition(me.x, me.y);
	walk.setZIndex(15);
	walk.animDelay = 2;
	walk.gotoAndPlay(3);
	walk.onenterframe = function(e) {
		if (e.target.currentFrame == 16) {
			e.target.gotoAndPlay(3);
		}
	};
	me.walk = walk;
	me.states.push(walk);
	stage.addChild(walk);
	
	// Состояние "бега"
	var run = new Sprite(bitmaps.BobRun, 57, 50, 19);
	run.setPosition(me.x, me.y);
	run.animDelay = 1;
	run.setZIndex(15);
	run.opacity = 0;
	run.gotoAndPlay(3);
	run.onenterframe = function(e) {
		if (e.target.currentFrame == 15) {
			e.target.gotoAndPlay(3);
		}
	};
	me.run = run;
	me.states.push(run);	
	stage.addChild(run);

	// Состояние прятания
	var hide = new Sprite(bitmaps.BobHide, 57, 42, 11);
	hide.setPosition(me.x, me.y);
	hide.animDelay = 2;
	hide.opacity = 0;
	hide.setZIndex(15);
	hide.onenterframe = function(e) {
		if (e.target.currentFrame == 10) {
			e.target.gotoAndStop(10);
		}
	};
	me.hide = hide;
	me.states.push(hide);	
	stage.addChild(hide);	
	
	// Состояние появления
	var show = new Sprite(bitmaps.BobHide, 57, 42, 11);
	show.setPosition(me.x, me.y);
	show.animDelay = 2;
	show.opacity = 0;
	show.setZIndex(15);
	show.onenterframe = function(e) {
		if (e.target.currentFrame == 0) {
			e.target.gotoAndStop(0);
		}
	};
	me.show = show;
	me.states.push(show);	
	stage.addChild(show);
	
	// Изменение состояния
	me.changeState = function(state) {
		if (me.direction == 'left' && !me[state].forbidScale) {
			me[state].scaleX = -1;
		} else {
			me[state].scaleX = 1;
		}

		var currState = me.state;
		stage.setTimeout(function(){me[currState].opacity = 0;},1);

		me[state].opacity = 1;
		me.state = state;
	}
	
	// Запрет на "впадание" в спячку
	me.box2dBody.m_world.m_allowSleep = false;
	
	me.forceSleep = function() {
		me.temp_speed = me.speed;
		me.speed = 0;
		me.isAsleep = true;
	}
	
	me.forceWakeUp = function() {
		me.speed = me.temp_speed;
		me.box2dBody.WakeUp();
		me.isAsleep = false;
	}
	
	me.onclick = function(e) {
		if(field.turning) return;
		var func = me.onclick;
		delete me.onclick;
		if (!me.isAsleep) {
			e.target.changeState('hide');
			me.hide.gotoAndPlay(0);
			me.forceSleep();
			stage.setTimeout(function(){
				me.onclick = func;
			}, hide.animDelay * 12);
		} else {
			e.target.changeState('show');
			// me.show.gotoAndPlay(0);
			me.show.rewindAndStop(10);
			stage.setTimeout(function(){
				var state = (Math.abs(me.temp_speed) == SPEED_WALK) ? 'walk': 'run';
				e.target.changeState(state);
				me.forceWakeUp();
				me.onclick = func;
			}, show.animDelay * 12);
		}
	}
	
	me.switchState = function() {
		if (me.state == 'walk') {
			me.changeState('run');
		} else if (me.state == 'run') {
			me.changeState('walk');
		}
	}
	
	me.synchPosition = function() {
		
		// Синхронизация всех состояний спрайтов с объектом
		for (var i = 0, j = me.states.length; i < j; i++) {
			me.states[i].setPosition(me.x, me.y)
		}
		
		// Будить физическое тело
		if (!me.isAsleep && me.box2dBody.IsSleeping()) {
			var pos = me.box2dBody.GetCenterPosition();
			pos.y -= 0.1;
			me.box2dBody.SetCenterPosition(pos, 0);		
			me.box2dBody.WakeUp();
		}
	}
	
	return me;
}

// Добавление состояний Боба
function addBobState(name, w, h, f, l) {
	var me = field.bob;
	
	var state = new Sprite(bitmaps[name], w, h, f, l);
	state.setPosition(me.x, me.y);
	state.animDelay = 2;
	state.opacity = 0;
	state.gotoAndStop(0);
	me[name] = state;
	me.states.push(state);
	stage.addChild(state);
	
	return state;
}

// Определение места появления Боба
function getBobLocation() {
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		var obj = stage.objects[i];
		if (obj.info && obj.info.indexOf('entrance') != -1) {
			obj.setZIndex(20);
			
			if (obj.info.indexOf('invisible') == -1) {
			
				var vec1 = new Vector(38, 0);
				var vec2 = new Vector(39, 0);
				vec1.rotate(-obj.rotation);
				vec2.rotate(-obj.rotation);

				var tubeCover = new Sprite(bitmaps.TubeCoverMc, 8, 47);
				tubeCover.setPosition(obj.x + vec1.x, obj.y + vec1.y);
				tubeCover.rotation = obj.rotation;
				tubeCover.setZIndex(21);
				stage.addChild(tubeCover);

				var backTube = new Sprite(bitmaps.BackTube, 4, 47);
				backTube.setPosition(obj.x + vec2.x, obj.y + vec2.y);
				backTube.rotation = obj.rotation;
				stage.addChild(backTube);
				backTube.setZIndex(5);
			}
			if(!obj.custom){
				var int = stage.setInterval(function(){
					if (!stage.hitTest(field.bob, obj)) {
						if (tubeCover) tubeCover.setStatic(true);
						if (backTube) backTube.setStatic(true);
						obj.setStatic(true);
						stage.clearInterval(int);
					}
				}, fps);
			}
			return {x: obj.x, y: obj.y};
		}
	}
}

var GameField = function() {
	
	var self = this;
	this.init = function(id, data) {

		// if (isMusicOn && playingMusic) {
		// 	alert(playingMusic.getPosition());
		// };

		//для кокуна время нужно умножать на миллион
		//включаем заново, если проиграло 59 секунд или полностью(обнуляется)
		if (isMusicOn && (!playingMusic || playingMusic.getPosition()>=59000000
										|| playingMusic.getPosition()==0)) {
			playingMusic = mixer.play('game_music1', true, true, 0);
		};

		// Создание 2D мира
		world = box2DCreateWorld();
		b2Settings.b2_timeToSleep = 0.05;
		b2Settings.b2_linearSleepTolerance = 1;
		b2Settings.b2_angularSleepTolerance = 0.1;
		
		// createStage();
		
		pause = false;
		
		// Заполнение игрового фона
		self.fillGameBackground();
		
		// Создание игровых объектов на основе файла levels.js
		self.createLevelObjects(id, data);
		var levelJoints = levels[id].joints;
		if(levelJoints)
		{
			var j, joint, stack, body1, body2;
			for(var i=0; i<levelJoints.length; i++)
			{
				joint = levelJoints[i];
				body1 = getBodyByPoint(joint.point1);
				body2 = getBodyByPoint((joint.point2 ? joint.point2 : joint.point1), body1);
				
				if(joint.type == 0) j = box2DCreateRevoluteJoint(world, body1, body2, joint.point1, joint.custom);
				if(joint.type == 1) j = box2DCreateDistanceJoint(world, body1, body2, joint.point1, joint.point2);
				if(joint.type == 2) j = box2DCreatePrismaticJoint(world, body1, body2, joint.point2, joint.custom);
			}
		}
		hideInvisibleImg();
		stopAnimations();
		
		self.setBobDestination();
		self.bob = new SnailBob();
		
		gameScore = 301;
		// loopSound = false;
		// Загрузка особенностей уровня
		var script = (GET["debug"] != 1) ? 
					levelsScripts[currentLevel - 1] : levelsScripts[editorLevel-1];

		script.init();
		if (script.pretick) stage.addEventListener("pretick", script.pretick);	
		if (script.posttick) stage.addEventListener("posttick", script.posttick);	
		
		var t = new SimpleText(bitmaps.lvl_numbs, 15, 14);
		t.align = t.ALIGN_CENTER;
		t.x = getStageWidth() - 18 + SPRITE_OFFSET_X;
		t.y = 20;
		t.lvlNum = true;
		t.write(id+1);

		// любом случае переключает на 0 кадр

		var mc = new Sprite(bitmaps.soundButton, 45, 45, 2);
		mc.x = 115 - SPRITE_OFFSET_X;	
		mc.y = 295;
		if(isMusicOn) mc.gotoAndStop(0);
		else mc.gotoAndStop(1);
		mc.onclick = toggleSound;
		stage.addChild(mc);
		
		buildBackground();
		stage.start();
		drawScore();
	}
	
	this.fillGameBackground = function() {
		var background = new Sprite(bitmaps['Lvl' + currentLevel + '_back'], 546, 320);
		background.setPosition(getStageCenter(), getStageHeightCenter());
		background.static = true;
		stage.addChild(background);
		
		var speed1 = new Sprite(bitmaps.SspeedStandardBtn, 30, 30);
		speed1.setPosition(60 - SPRITE_OFFSET_X, 20);
		speed1.value = SPEED_WALK;
		speed1.onclick = speedHandler;
		speed1.locked = true;
		//чтоб кнопки отображались поверх объектов
		speed1.setZIndex(50);
		self.speedHandler = speed1;
		stage.addChild(speed1);		
		
		var speed2 = new Sprite(bitmaps.SpeedFastBtn, 30, 30);
		speed2.setPosition(speed1.x + 30, speed1.y);
		speed2.value = SPEED_RUN;
		speed2.onclick = speedHandler;
		stage.addChild(speed2);		

		var indicator = new Sprite(bitmaps.SpeedIndicatorMc, 33, 33);
		indicator.setPosition(speed1.x, speed1.y);
		stage.addChild(indicator);		
		
		var speed_icon = new Sprite(bitmaps.SpeedBob, 37, 32, 2);
		speed_icon.setPosition(speed1.x - 35, speed1.y);
		speed_icon.gotoAndStop(0);
		stage.addChild(speed_icon);	
		
		self.speedHandler = [speed1, speed2];

		function speedHandler() {
			if (this.locked || self.locked || field.turning) return;
			this.locked = true;
			if (this === speed1) {
				speed2.locked = false;
				speed_icon.gotoAndStop(0);
				if (isSoundOn) mixer.play('snd_speed_standard', false);
			}
			else {
				speed1.locked = false;
				speed_icon.gotoAndStop(1);
				if (isSoundOn) mixer.play('snd_speed_fast', false);
			
			}
			
			indicator.setPosition(this.x, this.y);
			
			if (!self.bob.isAsleep) {
				self.bob.switchState();
				self.bob.speed = (self.bob.direction == 'right') 
					? this.value: -this.value;
			} else {
				self.bob.temp_speed = (self.bob.direction == 'right') 
					? this.value: -this.value;
			}
		}

		var level = new Sprite(bitmaps.Lvl, 39, 29);
		level.setPosition(getStageWidth() - 18 + SPRITE_OFFSET_X, 15);
		level.lvlNum = true;
		level.static = true;
		stage.addChild(level);		

		var score_img = new Sprite(bitmaps.score, 90, 30);
		score_img.setPosition(getStageCenter() + 10, getStageHeight() - 14);
		score_img.setZIndex(35);
		score_img.score_img = true;
		stage.addChild(score_img);		
		
		var lvl_map = new Sprite(bitmaps.LVL_map_new, 45, 45);
		lvl_map.setPosition(25 - SPRITE_OFFSET_X, getStageHeight() - 25);
		lvl_map.onclick = function() {
			mixer.stop(1);
			gameState = STATE_SELECT_LEVEL;
			createScene();
			return false;	
		}
		stage.addChild(lvl_map);		
		
		var restart_btn = new Sprite(bitmaps.restart, 45, 45);
		restart_btn.setPosition(lvl_map.x + 45, getStageHeight() - 25);
		restart_btn.onclick = restartLevel;
		stage.addChild(restart_btn);		
	}

	this.sleepToMoveBob = function(state) {
		self.bob.changeState('show');
		self.bob.show.gotoAndPlay(0);
		
		stage.setTimeout(function(){
			self.bob.forceWakeUp();
			self.bob.changeState(state);
		}, show.animDelay * 12);		
	}
	
	// Создание объектов выборанного уровня
	this.createLevelObjects = function(id, data) {
		var levelObjs;
		if (data) {
			levelObjs = data.objects;
			levels = [data];
			gameState = STATE_GAME;
		}
		else levelObjs = levels[id].objects;
		for (var i = 0; i < levelObjs.length; i++) {
			createObject(levelObjs[i]);
		}
	}
	
	this.setBobDestination = function() {
		for (var i = 0, j = stage.objects.length; i < j; i++) {
			var obj = stage.objects[i];
			if (obj.info == 'destination') {
				stage.setZIndex(obj, 20);
				field.destination = obj;
				
				var vec1 = new Vector(-38, 0);
				var vec2 = new Vector(-39, 0);
				vec1.rotate(-obj.rotation);
				vec2.rotate(-obj.rotation);

				var tubeCover = new Sprite(bitmaps.TubeCoverMc, 8, 47);
				tubeCover.setPosition(obj.x + vec1.x, obj.y + vec1.y);
				tubeCover.rotation = obj.rotation;
				tubeCover.scaleX = -1;
				tubeCover.setZIndex(21);
				stage.addChild(tubeCover);

				var backTube = new Sprite(bitmaps.BackTube, 4, 47);
				backTube.setPosition(obj.x + vec2.x, obj.y + vec2.y);
				backTube.rotation = obj.rotation;
				stage.addChild(backTube);
				backTube.setZIndex(5);
				
				return;
			}
		}
	}
}
function restartLevel(){
	mixer.stop(1);
	if(stage){
		mc = new Sprite(bitmaps.hourglass, 100, 150, 1);
		mc.x = 240;
		mc.y = 130;
		stage.addChild(mc);
	}
	setTimeout(function(){
		gameState = STATE_GAME;
		createScene();
	}, (1000/fps)*2);
}
function getBodyByPoint(point, presentBody)
{
	var body = world.GetGroundBody();
	
	if(point)
	{
		stack = stage.getObjectsStackByCoord(point.x+SPRITE_OFFSET_X, point.y, false);
		if(stack.length > 0)
		{
			for(var i=stack.length-1; i >= 0; i--)
			{
				if(stack[i].box2dBody && stack[i].box2dBody != presentBody) body = stack[i].box2dBody;
			}
		}
	}
	
	return body;
}
// Создание игрового объекта
function createObject(obj, relative) {
	var lo, ob, body, points, density, restitution, friction, x, y, width, height;
	lo = obj;
	ob = findObject(lo.type);
	
	mc = new Sprite(bitmaps[ob.name], ob.width, ob.height, ob.frames);
	
	// Для огня, он - TilesSprite
	if (ob.name == 'fire_lvl17') {
		mc = new TilesSprite(bitmaps[ob.name], ob.width, ob.height, ob.frames, ob.rows, ob.columns);
	}

	var cX = (relative) ? 0: (getStageWidth() - 480)/2;
	cY = /*(relative) ? 0: */(getStageHeight() - 320);
	
	mc.x = lo.x + cX;
	mc.y = getStageHeight() - 320 + lo.y/* + 64 + cY*/;

	//mc.y = lo.y + cY;
	
	mc.custom = lo.custom;
	
	mc.rotation = lo.rotation;
	mc.setZIndex(10);
	stage.addChild(mc);
	
	density = lo.density ? lo.density : ob.density;
	restitution = lo.restitution ? lo.restitution : ob.restitution;
	friction = lo.friction ? lo.friction : ob.friction;
	
	width = ob.bodyWidth ? ob.bodyWidth : ob.width;
	height = ob.bodyHeight ? ob.bodyHeight : ob.height;
	
	x = lo.x + cX;
	y = lo.y + cY;
	
	if(ob.bodyPosCorrect) {
		x += ob.bodyPosCorrect.x;
		y += ob.bodyPosCorrect.y;
		mc.syncX = ob.bodyPosCorrect.x;
		mc.syncY = ob.bodyPosCorrect.y;
		mc.onbox2dsync = spritesSync;
	}
	
	if(ob.bodyType == BOX) body = box2DCreateBox(world, x, y, width/2, height/2, lo.rotation, ob.fixed, density, restitution, friction);
	if(ob.bodyType == CIRCLE) body = box2DCreateCircle(world, x, y, width/2, lo.rotation, ob.fixed, density, restitution, friction);
	if(ob.bodyType == POLY) body = box2DCreatePoly(world, x, y, ob.points, lo.rotation, ob.fixed, density, restitution, friction);

	if (ob.joints) {
		for(var n=0; n<ob.joints.length; n++)
		{
			if(ob.joints[n].type == "pivot")
			{
				var point = new Vector(ob.joints[n].x, ob.joints[n].y);
				if(lo.rotation != 0) point.rotate(-lo.rotation);
				point.x += lo.x;
				point.y += lo.y;
				var pivot = box2DCreateCircle(world, point.x+cX, point.y+cY, 1, 0, true, 0.01, 0, 0);
				box2DCreateRevoluteJoint(world, pivot, body, pivot.GetCenterPosition());
			}
		}
	}
	
	if (ob.info) {
		mc.info = ob.info;
	}
	
	if (body) body.sprite = mc;
	mc.box2dBody = body;

	//if(GET["debug"] != 1 && ob.fixed) mc.static = true;

	mc.obType = ob.type;

	mc.grav = false;
	
	return mc;
}

function stopAnimations() {
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		var obj = stage.objects[i];
		if (obj.totalFrames > 1) {
			obj.gotoAndStop(0);
		}
	}
}

function hideInvisibleImg() {
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		var obj = stage.objects[i];
		if (obj.info && obj.info.indexOf('invisible') != -1) {
			obj.visible = false;
		}
	}	
}

function addHint(x,y) {
	var self = this;
	
	var hint = new Sprite(bitmaps.Hint, 30, 30);
	hint.setPosition(x,y);
	hint.info = 'hint';
	hint.setZIndex(13);
	stage.addChild(hint);
	
	addRotation.call(hint);
	
	function addRotation() {
		var self = this;

		var int = stage.setInterval(function() {
				if (!field.locked) self.rotation += 0.05;
			}, 1);
		
		this.removeHint = function() {
			stage.clearInterval(int);
			var int2 = stage.setInterval(function(){
				self.opacity -= 0.1;
				if (self.opacity <= 0) {
					stage.clearInterval(int2);
					self.destroy = true;
				}
			}, 1)
		}
	}
	
	this.hint = hint;
}

function enableHints() {
	for (var i = 0, j = stage.objects.length; i < j; i++) {
		var obj = stage.objects[i];
		if (obj.info && obj.info == 'hint') {
			addRotation.call(obj);
		}
	}	
}

function getDistance(obj1, obj2) {
	return Math.sqrt((obj2.x - obj1.x) * (obj2.x - obj1.x) 
		+ (obj2.y - obj1.y) * (obj2.y - obj1.y));
}

function setBackColor(color) {
	document.getElementById("screen_background_container").style.background = color;
	document.body.style.background = color;
}

// Боб в яме
function addStateBobGrowl(){
	var counter = 0;
	var BobGrowl = addBobState('BobGrowl', 50, 42, 15);
	BobGrowl.onenterframe = function(e) {
		var bob = field.bob;
		if(isSoundOn && !bob.soundPlayed && e.target.animated){
			mixer.play('snd_bob_growl');
			bob.soundPlayed = true;
			field.turning = true; //для блокировка клика на Бобе
		}
		if (e.target.currentFrame == 14 && e.target.animated) {
			if (counter < 1) {
				e.target.gotoAndPlay(0);
				counter++;
			} else{
				e.target.stop();					
				if(bob.isAsleep) bob.forceWakeUp();
				var state = (Math.abs(bob.speed) == SPEED_WALK) ? 'walk': 'run';
				bob.changeState(state);
				bob[state].gotoAndPlay(0);
				bob.soundPlayed = false;
				field.turning = false;
			}
		}
	};
};
// раздавленный Боб
function addStateBobFlatten(){
	var BobFlatten = addBobState('BobFlatten', 78, 44, 16);
	BobFlatten.onenterframe = function(e) {
		if (!field.bob.flatten && e.target.animated) {
			if (isSoundOn) mixer.play('snd_bob_flatten');
			field.bob.flatten = true;
		};
		if (e.target.currentFrame == 15 && e.target.animated) {
			e.target.stop();
			showGameOverScreen();
		}
	};
	BobFlatten.animDelay = 1;
	BobFlatten.setZIndex(15);
};
function bobFalls(){
	if(field.bob.falls) return;
	if (isSoundOn) mixer.play('snd_fall', false);
	var bob = field.bob;
	bob[bob.state].opacity = 0;
	bob.falls = true;
	var mc = new Sprite(bitmaps.BobFall1, 50, 174, 5);
	mc.x = bob.x;
	mc.y = bob.y-40;
	mc.animDelay = 1;
	stage.addChild(mc);

	stage.setTimeout(function(){
		mc.bitmap = bitmaps.BobFall2;		
		stage.setTimeout(function(){
			mc.bitmap = bitmaps.BobFall3;
			stage.setTimeout(function(){
				mc.destroy = true;
				stage.setTimeout(showGameOverScreen, fps/2);
			}, mc.animDelay*4);
		}, mc.animDelay*5-1);
	}, mc.animDelay*5-1);

   	stage.createTween(mc, "y", mc.y, mc.y + 170, mc.animDelay*13, Easing.sine.easeIn).play();
}
function addStateBobShocked(){
	// Ударенный током Боб

	var shocked = addBobState('shocked', 94, 102, 4);
	var counter = 0;
	shocked.onenterframe = function(e) {
		if (e.target.currentFrame == 2) {
			if(counter<3){
				counter++;
				e.target.gotoAndPlay(1);
			} else e.target.gotoAndPlay(3);
			if (e.target.currentFrame == 3) {
				e.target.opacity = 0;
				e.target.stop();
				field.bob.changeState('shocked2');
				field.bob.shocked2.gotoAndPlay(0);
				e.target.onenterframe = null;

				var mc = new Sprite(bitmaps.spirit, 75, 100);
				mc.x = e.target.x;
				mc.y = e.target.y;
				stage.addChild(mc);

		        var tween = stage.createTween(mc, "y", e.target.y, -50, fps*1.5, Easing.linear.easeIn);
		        tween.play();
		        tween.onfinish = showGameOverScreen;
			};			
		}
	};

	shocked2 = addBobState('shocked2', 94, 102, 7);
	shocked2.onenterframe = function(e){
		if (e.target.currentFrame == 6) e.target.stop(0);
	}
	shocked2.animDelay = 3;
}
function bobBurns(fire){
	var bob = field.bob;
	if(bob.onFire) return;
	if (isSoundOn) mixer.play('snd_burn');
	bob.onclick = null;
	bob.onFire = true;
	bob[bob.state].opacity = 0;
	bob.box2dBody.Freeze();

	//не добавляю Бобу в states чтоб избежать синхронизацию и сместить чуть выше 
	var BobBurn = new Sprite(bitmaps.BobBurn, 50, 52, 7);
	BobBurn.setPosition(bob.x, bob.y-7);
	BobBurn.animDelay = 2;
	BobBurn.setZIndex(15);
	BobBurn.onenterframe = function(e) {
		if (e.target.currentFrame == 6 && e.target.animated) {
			e.target.stop();
			if(fire) {
				stage.setTimeout(function(){
					fire.destroy = true;
					mixer.stop(4);
					mixer.stop(3);
				}, 10);
			}
		}
	};
	stage.addChild(BobBurn);

	var mc = new Sprite(bitmaps.BobBurnAnimMc2, 60, 42, 15);
	mc.x = bob.x;
	mc.y = bob.y+3;
	mc.animDelay = 2;
	stage.addChild(mc);

	var tween = stage.createTween(mc, "x", mc.x, 560, (fps/250)*(560 - mc.x), Easing.linear.easeIn);
	stage.setTimeout(tween.play, 2*mc.animDelay);
	tween.onfinish = showGameOverScreen;
}

var tmScore;
var scoreText;

function drawScore(){
	if(gameState == STATE_MENU || gameState == STATE_SELECT_LEVEL || gameState == STATE_FINAL) return;
	if (gameState == STATE_GAME){

		clearTimeout(tmScore);
		gameScore--;
		if(gameScore < 0) gameScore = 0;
		if(scoreText){
			var ii;
			for(ii = 0; ii < scoreText.sprites.length; ii++){
				if (scoreText.sprites[ii]) scoreText.sprites[ii].destroy = true;
			}
		}
		scoreText = new SimpleText(bitmaps.score_num, 8, 12);
		scoreText.align = scoreText.ALIGN_LEFT;
		scoreText.x = 265;
		scoreText.y = 305;
		scoreText.write(gameScore);

		tmScore = setTimeout(function(){
				if(scoreText){
					var i;
					for(i = 0; i < scoreText.sprites.length; i++){
						if (scoreText.sprites[i]) scoreText.sprites[i].destroy = true;
					}
				}
			drawScore();
		}, 500);
	} else {
		scoreText = new SimpleText(bitmaps.score_num, 8, 12);
		scoreText.align = scoreText.ALIGN_LEFT;
		scoreText.x = 265;
		scoreText.y = 305;
		scoreText.write(gameScore);
		for (var j = 0; j < scoreText.sprites.length; j++) {
			scoreText.sprites[j].setZIndex(36);
		};
	}
}
function toggleSound(e){
	if(!mixer || gameState == STATE_CREDITS) return;
	if(isMusicOn){
		isSoundOn = false;
		isMusicOn = false;
		// loopSound = false;
		mixer.stop(0);
		// mixer.stop(1);
		// mixer.channels[1].pause();
		e.target.gotoAndStop(1);
        Utils.setCookie("snail_bob_sound", 2);
	} else {
		isMusicOn = true;
		// mixer.channels[1].resume();
		playingMusic = mixer.play('game_music1', true, true, 0);
		// if (loopSound) mixer.play(loopSound, true, true, 1);
		e.target.gotoAndStop(0);
        Utils.setCookie("snail_bob_sound", 1);
	}
	return false;
}