function SpritesGroup(stage)
{
	var self = this;
	
	this.stage = stage;
	
	this.x = 0;
	this.y = 0;
	this.rotation = 0;
	this.scaleX = 1;
	this.scaleY = 1;
	this.opacity = 1;
	
	this.sprites = [];
	
	this.addChild = function(obj, add)
	{
		if(typeof obj.gscaleX == "undefined") obj.gscaleX = 1;
		if(typeof obj.gscaleY == "undefined") obj.gscaleY = 1;
		if(typeof obj.grotation == "undefined") obj.grotation = 0;
		if(typeof obj.gopacity == "undefined") obj.gopacity = 1;
		
		this.sprites.push(obj);
		if(add) this.stage.addChild(obj);
		this.update();
	}
	
	this.removeChild = function(obj, destroy)
	{
		this.sprites = Utils.removeFromArray(this.sprites, obj);
		if(destroy) obj.destroy = true;
	}
	
	this.remove = function()
	{
		for(var i=0; i<this.sprites.length; i++)
		{
			this.sprites[i].destroy = true;
		}
		this.sprites = [];
	}
	
	this.update = function()
	{
		var obj;
		for(var i=0; i<self.sprites.length; i++)
		{
			obj = self.sprites[i];
			
			var x = obj.gx;
			var y = obj.gy;
			
			var p = new Vector(x, y);
			p.rotate(-self.rotation);
			x += p.x;
			y += p.y;
			
			x *= self.scaleX;
			y *= self.scaleY;
			
			x += self.x;
			y += self.y;
			
			obj.x = x;
			obj.y = y;
			obj.scaleX = obj.gscaleX * self.scaleX;
			obj.scaleY = obj.gscaleY * self.scaleY;
			obj.rotation = obj.grotation + self.rotation;
			obj.opacity = obj.gopacity * self.opacity;
		}
	}
	
	stage.addEventListener("pretick", this.update);
}