var levelsScripts = [
	
/********************************************************* 
*							Level 1
*********************************************************/
	{
		init: function() {
			var self = levelsScripts[0];

			// Состояние полета
			var fly = addBobState('fly', 50, 900/18, 18);
			fly.animDelay = 1;
			fly.setZIndex(15);
			fly.gotoAndPlay(0);
			fly.onenterframe = function(e) {
				if (e.target.currentFrame == 14) {
					e.target.gotoAndPlay(3);
				}
			};
			
			var lever = getObjectByInfo('Lever1');
			addHint.call(lever, lever.x, lever.y - 7);
			lever.onclick = self.lever1Action;
			
			self.yellow_element = getObjectByInfo('yellow_element');

			self.DoorLevel01 = getObjectByInfo('DoorLevel01');
			
			self.spring = getObjectByInfo('Spring');
			
			var button = getObjectByInfo('button_red');
			attachMouseEvents.call(button);
			addHint.call(button, button.x, button.y);
			button.onclick = self.buttonHandler;
			
			self.stopWall = getObjectByCustomInfo('stop');

			getObjectByInfo('Hint1_Level10001').setStatic(true);
			getObjectByInfo('Hint2_Level10001').setStatic(true);
		},
		
		lever1Action: function(e) {
			var obj = e.target;
			if (isSoundOn) mixer.play('snd_lever_double', false);
			if (isSoundOn) mixer.play('snd_door_left', false);
			
			obj.gotoAndPlay(0);
			obj.onenterframe = function(e) { 
				var obj = e.target;
				if (obj.currentFrame == 5) {
					obj.gotoAndStop(5);
					obj.hint.removeHint();
					obj.setStatic(true);
				}
			}
			
			var door = levelsScripts[0].DoorLevel01;
			
			world.DestroyBody(door.box2dBody);
			door.moveTo(door.x, door.y - 100, Math.floor(fps * 0.8), 
				Math.floor(fps * 0.8), function(){
					levelsScripts[0].yellow_element.setStatic(true);
					door.setStatic(true);
			});
			
			obj.onclick = null;
		},
		
		buttonHandler: function() {
			var self = levelsScripts[0],
				spr = self.spring,
				ANGLE = -1.4835, // 85 градусов
				IMPULSE = 4500000 * 1.2 * 0.55;
				
			if (isSoundOn) mixer.play('snd_spring', false);
			spr.gotoAndPlay(0);
			spr.onenterframe = function(e) { 
				if (e.target.currentFrame == 8) {
					e.target.gotoAndStop(0);
				}
			}
			
			var bob = field.bob;
			
			// Проверка столкновения пружины и Боба
			if (stage.hitTest(bob, self.spring)) {

				if (bob.state != 'hide') {
					// Изменение изображения
					bob.selectedState = bob.state;
					bob.changeState('fly');
					field.turning = true; //для запрета клика на Бобе
					if (bob.isAsleep) {bob.forceWakeUp();}
				};
				// "Подбросить Боба"
				bob.box2dBody.ApplyImpulse(new b2Vec2(Math.cos(ANGLE) * IMPULSE, 
					Math.sin(ANGLE) * IMPULSE), new b2Vec2(bob.x, bob.y));	
				if (isSoundOn) mixer.play('bob_flying');
				
				// Установка прежней скорости после "приземления"
				var int1 = stage.setInterval(function() {
					if (bob.box2dBody.m_linearVelocity.y > 0) {
						var int2 = stage.setInterval(function() {
							if (bob.box2dBody.m_linearVelocity.y < 0) {
								if(bob.selectedState) bob.changeState(bob.selectedState);
								field.turning = false;
								stage.clearInterval(int2);						
							}
						},1);
						stage.clearInterval(int1);
					}
				}, 1);
			}		
		},
		ifCancelSpeed: function(){
			var self = levelsScripts[0];
			if(stage.hitTest(field.bob, self.stopWall)) field.cancelSpeed = true;	
			else field.cancelSpeed = false;
		},

		pretick: function(){
			var self = levelsScripts[0];
			self.ifCancelSpeed();
		}
	},

/********************************************************* 
*							Level 2
*********************************************************/

	{
		init: function() {
			var self = levelsScripts[1],
				shocked,
				shocked2;

			self.bobIsShocked = false;
			addStateBobShocked();

			self.conveyor = getObjectByInfo('conveyor');
			self.conveyor.setStatic(true);

			self.crossbar = getObjectByInfo('crossbar');
			self.elec = getObjectByInfo('electricity_10');
			self.elec.play();
			self.btn = getObjectByInfo('btn02');
			var lever = getObjectByInfo('Lever2');
			lever.setStatic(true);
			addHint.call(lever, lever.x, lever.y+7);
			lever.onclick = self.lever2Action;

			self.hint1 = getObjectByInfo('HintMc1_Level20001');
			var arrow1 = getObjectByInfo('ArrowAnim0001');
			var tween1 = stage.createTween(arrow1, "y", 55, 70, 
				Math.floor(fps*0.8), Easing.linear.easeIn);
			var tween2 = stage.createTween(arrow1, "y", 70, 55, 
				Math.floor(fps*0.8), Easing.linear.easeIn);
			tween1.play();
			tween1.onfinish = tween2.play;
			tween2.onfinish = tween1.play;
			self.arrow1 = arrow1;

			self.hint3 = getObjectByInfo('HintMc3_Level20001');
		},

		lever2Action: function(e){
			if (isSoundOn) mixer.play('snd_lever_double', false);
			if (isSoundOn) {
				mixer.play('snd_conveyor', true, true, 1);
			}
			// loopSound = 'snd_conveyor';
			var obj = e.target;
			obj.setStatic(false);
			obj.gotoAndPlay(0);
			obj.onenterframe = function(e) { 
				var obj = e.target;
				if (obj.currentFrame == 5) {
					obj.gotoAndStop(5);
					obj.hint.removeHint();
					obj.setStatic(true);
				}
			}
			var conveyor = levelsScripts[1].conveyor;
			conveyor.setStatic(false);
			conveyor.gotoAndPlay(0);
			conveyor.enabled = true;
			obj.onclick = null;
		},

		checkIfBobOnConveyer: function() {
			var bob = field.bob,
				self = levelsScripts[1],
				conveyor = self.conveyor,
				conveyor_speed = -fps*4.5;


			if (stage.hitTest(bob, conveyor)){
				if (!self.arrow1.disappear){
					self.arrow1.disappear = true;
					self.hint1.fadeTo(0, fps, Easing.linear.easeIn, function(){self.hint1.destroy = true});
					self.arrow1.fadeTo(0, fps, Easing.linear.easeIn, function(){self.arrow1.destroy = true});
				}
		
				if (conveyor.enabled) {
					switch (bob.state){
						case 'walk': 
							bob.box2dBody.m_linearVelocity.x = SPEED_WALK + conveyor_speed;
						break;
						case 'run': 
							bob.box2dBody.m_linearVelocity.x = SPEED_RUN + conveyor_speed;
						break;
						case 'hide': case 'show':
							bob.box2dBody.m_linearVelocity.x = conveyor_speed;
						break;
					}					
				};
			}
		},
		
		ifBobPressBtn: function(){
			var bob = field.bob,
				self = levelsScripts[1],
				btn = self.btn;

			if (!stage.hitTest(bob, btn) || bob.x < btn.x-25 || bob.x > btn.x+25) {
				if (btn.groundOn) {
					btn.gotoAndStop(0);
					btn.groundOn = false;
					if(isSoundOn) mixer.play('snd_button_ground_on', false);
				} else return;
			}

			if(!btn.press){
				
				var hint2 = createObject({type: "HintClickBob_Level20001", 
					x: bob.x-90, y: bob.y-15, rotation: 0});
				var arrow2 = createObject({type: "ArrowAnim_yellow0001", 
					x: bob.x-50, y: bob.y-8, rotation: -0.1});
				arrow2.c = 0;

				function inc(){
					arrow2.c++;
				}
				function dec(){
					arrow2.c--;
				}

				var func = inc;

				var hintInt = stage.setInterval(function(){
					
					if (arrow2.c > 10) func = dec;
					if (arrow2.c < 0) func = inc;
					func();
					
					arrow2.x = bob.x - 50 + arrow2.c;
					hint2.x = bob.x - 90;
					
					if (bob.state == 'hide' || btn.currentFrame == 0) {
						var duration = Math.floor(fps/4);
						hint2.fadeTo(0, duration, Easing.linear.easeIn, function(){hint2.destroy = true});
						arrow2.fadeTo(0, duration, Easing.linear.easeIn, function(){arrow2.destroy = true});
						stage.clearInterval(hintInt);
					}
				},1);

				btn.gotoAndStop(1);
				if (isSoundOn) mixer.play('snd_button', false);

				var body = self.crossbar.box2dBody;
				var oldPos = body.m_position;
					oldPos.y +=35;
				var newPos = {};

				var int = stage.setInterval(function(){
					var rot = body.m_rotation-0.015;
					var vec = new Vector(-35, 0);
					vec.rotate(-rot);

					newPos.x = oldPos.x + vec.x;
					newPos.y = oldPos.y + vec.y;
					body.SetOriginPosition(newPos, rot);

					if (rot <= 0 || btn.currentFrame == 0) {
						if (rot <= 0 && bob.state == 'hide') {
							var duration = Math.floor(fps/4);
							self.hint1.moveTo(self.hint1.x, self.hint1.y-50, duration, Easing.linear.easeIn, 
								function(){
									self.hint1 = createObject({type: "HintMc2_Level20001", 
										x: self.hint1.x, y: -20, rotation: 0});
									self.hint1.moveTo(self.hint1.x, self.hint1.y+45,
										duration, Easing.linear.easeIn);
								}
							)
						};
						stage.clearInterval(int);
						stage.setTimeout(function(){
							self.crossbar.setStatic(true);
							getObjectByInfo('electric_detail').setStatic(true);
						},2)
					}
				}, 1);
				btn.press = true;	
				btn.groundOn = true;
			}
		},

		// Столкновение Боба и электричества
		ifBobShocked: function() {		
			var self = levelsScripts[1];
			if (!self.bobIsShocked && stage.hitTest(self.elec, field.bob)) {
				self.bobIsShocked = true;
				// self.btn.setStatic(true);

				if(isSoundOn) mixer.play('snd_bob_die_radiation', false);
				stage.setTimeout(function(){
					if(isSoundOn) mixer.play('snd_electro_shock', false);
					
					field.bob.forceSleep();
					field.bob.speed = 0;
	
					var pos = field.bob.box2dBody.GetCenterPosition();
					pos.y = pos.y - 20; //для смещения анимации
					field.bob.box2dBody.SetCenterPosition(pos, 0);		
					field.bob.box2dBody.Freeze();

					field.bob.changeState('shocked');
					field.bob.shocked.gotoAndPlay(0);
					field.bob.onclick = null;

				}, fps/4);
			}
		},

		checkIfAddLastHint: function(){
			var self = levelsScripts[1];
			if (field.bob.y < 220 || self.hint3.appeared) return;

			self.hint3.appeared = true;

			self.hint3.moveTo(self.hint3.x, self.hint3.y+100, fps, Easing.linear.easeIn, function(){	
				self.hint3.setStatic(true);		
				var arrow3 = createObject({type: "ArrowAnim0001", x: 135, y: 50, rotation: 2.15});
				var duration = Math.floor(fps*0.8);
				var tween3_1 = stage.createTween(arrow3, "y", 50, 38, duration, Easing.linear.easeIn);
				var tween3_3 = stage.createTween(arrow3, "x", 135-SPRITE_OFFSET_X, 115-SPRITE_OFFSET_X, duration, Easing.linear.easeIn);
				var tween3_2 = stage.createTween(arrow3, "y", 38, 50, duration, Easing.linear.easeIn);
				var tween3_4 = stage.createTween(arrow3, "x", 115-SPRITE_OFFSET_X, 135-SPRITE_OFFSET_X, duration, Easing.linear.easeIn);
				tween3_1.onfinish = function(){
					tween3_2.play();
					tween3_4.play();
				};
				tween3_2.onfinish = function(){
					tween3_1.play();
					tween3_3.play();
				};

				tween3_1.play();
				tween3_3.play();
			});

		},

		pretick: function() {
			var self = levelsScripts[1];
			self.checkIfBobOnConveyer();
			self.ifBobPressBtn();
			self.ifBobShocked();
			self.checkIfAddLastHint();
		},
	},	
	
/********************************************************* 
*							Level 3
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[2],
				bob = field.bob;

			var platform = getObjectByInfo('Baraban');
			platform.animDelay = 2;
			self.platform = platform;
			
			var slider = getObjectByInfo('slider');
			processSlider.call(slider, platform);

			var lift = getObjectByInfo('Lift_lv3').box2dBody;
			var buttonDown = getObjectByInfo('button_blue_down');
			addHint.call(buttonDown, buttonDown.x, buttonDown.y+1);
			var buttonUp = getObjectByInfo('button_blue_up');
			addHint.call(buttonUp, buttonUp.x, buttonUp.y-1);
			var buttonMid = getObjectByInfo('button_blue_mid_lvl3');

			// lift.sprite.setStatic(true);
			buttonDown.setStatic(true);
			buttonUp.setStatic(true);
			buttonMid.setStatic(true);
			slider.setStatic(true);

			getObjectByInfo('Hint1_Level30001').setStatic(true);
			getObjectByInfo('HoldText0001').setStatic(true);
			
			self.liftHandler.call(lift, buttonDown, 290);
			self.liftHandler.call(lift, buttonUp, 130);
		},

		liftHandler : function(but, restriction){
			var lift = this,
				bob = field.bob,
				block,
				up,
				int;
			but.onmousedown = function(){
				// Перемещение лифта
				if (block) return;
				if (but.info.indexOf('up') != -1) up = true;
				if (up) {
					if (lift.GetCenterPosition().y <= restriction) return;
				} else {
					if (lift.GetCenterPosition().y >= restriction) return;
				}
				block = true;
				// lift.sprite.setStatic(false);	
				var oldPos = lift.GetCenterPosition().y;	
				var bob_pos;
				int = stage.setInterval(function(){
					var pos = lift.GetCenterPosition();
					if (up) pos.y -= 2;
					else pos.y += 2;
					lift.SetCenterPosition(pos, 0);

					if (checkIfBobOnLift(lift.sprite)) {
						bob_pos = bob.box2dBody.GetCenterPosition();
						if (up) bob_pos.y -= 2;
						else bob_pos.y += 2;
						bob.box2dBody.SetCenterPosition(bob_pos, 0);
					}
					if ((up && pos.y <= restriction) || 
						(!up && pos.y >= restriction)) stopMove();
				},1);
			}
			but.onmouseup = stopMove;
			but.onmouseout = stopMove;
			function stopMove(){
				stage.clearInterval(int);
				block = false;
			}
		},
	},	

/********************************************************* 
*							Level 4
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[3];

			var lever = getObjectByInfo('Lever4');

			addHint.call(lever, lever.x+6, lever.y+1);
			lever.setStatic(true);
			var stone = getObjectByInfo('stone_lvl4');
			stone.box2dBody.GoToSleep();
			var mechanism = getObjectByInfo('mechanism');
			mechanism.onenterframe = function(e){
				if (e.target.currentFrame == 7) {
					e.target.stop();
					e.target.setStatic(true);
				};
			};

			var latch = getObjectByInfo('Latch_lvl4');
			addHint.call(latch, latch.x-17, latch.y+2);
			latch.position = 'left';
			latchMove.call(latch, 22);

			moveMechanism.call(lever, mechanism, stone);
		},

		ifBobFalls: function(){
			if(field.bob.y > 210) {
				bobFalls();
			}
		},

		//Чтоб не переворачивал деревяшки, когда бежит, а только с помощью камня
		//хз, может это убрать) и придумать что-то лучше
		bobDontTurnWoodenCross: function(){
			if(field.bob.x > 215 && field.bob.x <219 && field.bob.y > 160){
				field.bob.box2dBody.m_linearVelocity.x = Math.floor(field.bob.speed/9);
				// field.bob.box2dBody.m_linearVelocity.x = 0;
			}
		},

		pretick: function() {
			var self = levelsScripts[3];
			self.ifBobFalls();
			self.bobDontTurnWoodenCross();
		},
	},	

/********************************************************* 
*							Level 5
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[4];

			var buttonLeft = getObjectByInfo('button_blue_left');
			buttonLeft.setStatic(true);
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);
			var buttonRight = getObjectByInfo('button_blue_right');
			buttonRight.setStatic(true);
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);
			var buttonMid = getObjectByInfo('button_blue_mid');
			buttonMid.setStatic(true);
			
			var lever = getObjectByInfo('Lever1');
			lever.side = 'left';
			var	wagon = getObjectByInfo('wagon_lvl5');
			wagon.setZIndex(16);
			self.wagon = wagon;
			var wagonWhel = getObjectByInfo('wagon_whel_lvl5');
			wagonWhel[0].setZIndex(17);
			wagonWhel[1].setZIndex(17);

			self.leftWood = getObjectByCustomInfo('leftWood');
			self.rightWood = getObjectByCustomInfo('rightWood');
			self.leftWood.setStatic(true);
			self.leftWood.setZIndex(1);
			self.rightWood.setStatic(true);
			self.block = false;

			addHint.call(lever, lever.x, lever.y-5);
			lever.onclick = self.lever5Action;
			var bridge = getObjectByInfo('Bridge_lvl5').box2dBody;
			bridge.sprite.setStatic(true);
			self.bridge = bridge;
			rotateHandler.call(bridge, buttonLeft, -2.05);
			rotateHandler.call(bridge, buttonRight, 0);

			self.pit = getObjectByCustomInfo('pit');
			//чтоб в каждый уровень не добавлять - запихнул в game.js
			addStateBobGrowl();
			var tube = getObjectByInfo('tube5');
			var BackTube = getObjectByInfo('BackTube');
			tube.setZIndex(16);
			tube.setStatic(false);

			stage.setTimeout(function(){
				tube.setStatic(true);
				BackTube.setStatic(true);
			}, fps);

		},
		
		lever5Action: function(e){
			var self = levelsScripts[4];
			var obj = e.target;
			if(self.block) return;
			if (isSoundOn) mixer.play('snd_lever_double', false);

			self.block = true;
			if (obj.side == 'left'){
				if(isSoundOn) mixer.play('snd_door_left', false);
				obj.side = 'right';
				obj.gotoAndPlay(0);
				obj.onenterframe = function(ev) { 
					var obj = ev.target;
					if (obj.currentFrame == 5) {
						obj.stop();
					}
				}
				self.moveWood(self.leftWood.box2dBody, true);
				self.moveWood(self.rightWood.box2dBody, false);

			} else {
				if(isSoundOn) mixer.play('snd_door_right', false);
				obj.side = 'left';
				obj.rewindAndStop(5);

				self.moveWood(self.leftWood.box2dBody, false);
				self.moveWood(self.rightWood.box2dBody, true);
			}
		},
		moveWood: function(wood, up){
			var self = levelsScripts[4];

			wood.sprite.setStatic(false);
			var oldPos = wood.GetCenterPosition();
			var int1 = stage.setInterval(function(){
				var pos = wood.GetCenterPosition();
				if (up) pos.y -= 3;
				else pos.y += 3;
				
				wood.SetOriginPosition(pos, 0);

				if (Math.abs(oldPos.y - pos.y) >= 75) {
					stage.setTimeout(function(){wood.sprite.setStatic(true);},1); 
					stage.clearInterval(int1);
					self.block = false;
				}
			}, 1);
		},
		ifCancelSpeed: function(){
			var self = levelsScripts[4];
			if(getDistance(field.bob, self.wagon) < 35 ||
				(stage.hitTest(field.bob, self.bridge.sprite) && self.bridge.sprite.rotation < -Math.PI/4)){
					field.cancelSpeed = true;	
			} else field.cancelSpeed = false;
		},
		ifBobFalls: function(){
			if(field.bob.y > 260 && field.bob.x < 300) bobFalls();
		},
		ifBobInPit: function(){
			if (!field.bob.inPit && stage.hitTest(field.bob, levelsScripts[4].pit)) {
				field.bob.changeState('BobGrowl');
				field.bob.BobGrowl.gotoAndPlay(0);
				field.bob.inPit = true;
			};
		},

		pretick: function() {
			var self = levelsScripts[4];
			self.ifCancelSpeed();
			self.ifBobFalls();
			self.ifBobInPit();
		}
	},	

/********************************************************* 
*							Level 6
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[5];			
			
			var button_red = getObjectByInfo('button_red');
			button_red.onclick = self.buttonRedAction;
			attachMouseEvents.call(button_red);
			addHint.call(button_red, button_red.x, button_red.y);

			var button_blue = getObjectByInfo('button_blue');
			button_blue.onclick = self.buttonBlueAction;
			addHint.call(button_blue, button_blue.x, button_blue.y);

			var buttonLeft = getObjectByInfo('button_blue_left');
			addHint.call(buttonLeft, buttonLeft.x-1, buttonLeft.y);
			buttonLeft.setStatic(true);
			var buttonRight = getObjectByInfo('button_blue_right');
			addHint.call(buttonRight, buttonRight.x+1, buttonRight.y);
			buttonRight.setStatic(true);

			var brig = getObjectByInfo('brig').box2dBody;
			brig.sprite.setStatic(true);
			
			var earth = getObjectByInfo('earth_lvl6');
			earth.setStatic(true);

			rotateHandler.call(brig, buttonLeft, 0.01, earth);
			rotateHandler.call(brig, buttonRight, Math.PI/2 - 0.01, earth);

			self.spring = getObjectByInfo('spring');
			self.spring.onenterframe = function(e){
				if (e.target.currentFrame == 11) {
					e.target.gotoAndStop(0);
				};
			};
			var mechanism = getObjectByInfo('mechanism');
			// mechanism.animDelay = 2;
			mechanism.onenterframe = function(e){
				if (e.target.currentFrame == 7) {
					e.target.stop();
					e.target.rewindAndStop(6);
				};
			};
			self.mechanism = mechanism;

			self.tube = getObjectByInfo('tube_lvl6');
			self.tube.setStatic(true);


			self.btn = getObjectByInfo('btn_lvl6');
			self.btn.setZIndex(1);
			self.btn.onenterframe = function(e){
				if (e.target.currentFrame == 3) {
					e.target.stop();
					e.target.setStatic(true);
				};
			};
		
			//чтоб при рестарте старый камень не взрывался
			self.stone = undefined;

		},
		
		buttonRedAction: function(){
			var self = levelsScripts[5];
			if (self.spring.currentFrame != 0) return;
			self.spring.play();
			if (isSoundOn) mixer.play('snd_spring');
			
			if (self.stone && stage.hitTest(self.stone, self.spring)) {
				stage.setTimeout(function(){
					self.stone.box2dBody.ApplyImpulse(new b2Vec2(-200000, -20000/*-170000, -25000*/), 
						self.stone.box2dBody.GetCenterPosition());	
				}, 2);
			};
		},
		
		buttonBlueAction: function(){
			var self = levelsScripts[5];		
			if (self.mechanism.currentFrame != 0) return;			
			self.mechanism.gotoAndPlay(0);
			if (isSoundOn) mixer.play('snd_bridge');
			if (self.stone) {
				var mc = new Sprite(bitmaps.BasketballDestroying, 60, 60, 11);
				mc.x = self.stone.x;
				mc.y = self.stone.y;
				mc.onenterframe = function(e){
					if (e.target.currentFrame == 9) e.target.destroy = true;
				};
				stage.addChild(mc);
				self.stone.destroy = true;
				world.DestroyBody(self.stone.box2dBody);
			};
			self.stone = createObject({type: "stone_lvl6", x: 387, y: 116, rotation: 0});
			self.stone.setZIndex(2);
		},

		ifBtnPress: function(){
			var self = levelsScripts[5];
			if (!self.stone || self.btn.pressed) return;
			if (stage.hitTest(self.stone, self.btn)){
				self.tube.setStatic(false);
				if (isSoundOn) mixer.play('snd_lever_double');
				var tube = self.tube.box2dBody;
				stage.setTimeout(function(){
					self.btn.play();
					if (isSoundOn) mixer.play('snd_door_right');
					var int = stage.setInterval(function(){
						var pos = tube.GetCenterPosition();
						pos.y -= 2;
						
						tube.SetOriginPosition(pos, 0);

						if (pos.y <= -43) {
							tube.sprite.destroy = true;
							world.DestroyBody(tube);
							stage.clearInterval(int);
							// self.block = false;
						}
					}, 1);
				},2);
				self.btn.pressed = true;
			}
		},
		pretick: function() {
			var self = levelsScripts[5];
			self.ifBtnPress();
		}
	},

/********************************************************* 
*							Level 7
*********************************************************/
	{
		init: function() {
			var self = levelsScripts[6],
				chick_speed = -fps*2,
				bob = field.bob,
				temp_bob_handler = bob.onclick,
				buttonsArr = [];
				
			bob.onclick = null;

			field.speedHandler.forEach(function(el) {el.locked = true;});
			
			// Влюбленный Боб
			var BobFallsInLove = new TilesSprite(bitmaps.BobFallsInLove, 72, 68, 20, 5, 4);
	
			BobFallsInLove.setPosition(bob.x, bob.y);
			BobFallsInLove.animDelay = 2;
			BobFallsInLove.opacity = 0;
			BobFallsInLove.gotoAndStop(0);
			bob.BobFallsInLove = BobFallsInLove;
			bob.states.push(BobFallsInLove);
			stage.addChild(BobFallsInLove);

			BobFallsInLove.onenterframe = function(e) {
				if (e.target.currentFrameX == 19 && e.target.animated) {
					e.target.stop();
					bob.changeState('inLove');
					bob.inLove.gotoAndPlay(0);
					bob.forceWakeUp();
					bob.speed = chick_speed;
					bob.direction = 'left';
				}
			};
			
			var BobFalls = addBobState('BobFalls', 64, 568/7, 7);
			BobFalls.forbidScale = true;
			BobFalls.onenterframe = function(e) {
				if (e.target.currentFrame == 6 && e.target.animated) {
					bob.changeState('walk');
					bob.onclick = temp_bob_handler;
					field.speedHandler[1].locked = false;
					e.target.stop();
					field.bob.speed = -SPEED_WALK;
				}
			};
			
			var inLove = addBobState('inLove', 64, 254/5, 5);
			inLove.animDelay = 3;
			
			var chick = getObjectByInfo('Girlfriend');
			chick.box2dBody.m_invI = 0;
			chick.animDelay = 3;
			chick.gotoAndPlay(0);
			chick.setZIndex(0);
			stage.setInterval(function(){
				chick.box2dBody.m_linearVelocity.x = chick_speed;
			},1);
			self.chick = chick;

			var lift = getObjectByInfo('Lift_lv7').box2dBody;

			var buttonsArr = getObjectByInfo('Btn_lv7');
			if (buttonsArr.length == 2) {
				addLiftHandlers.call(lift, buttonsArr);
			}
			
			self.fence = getObjectByInfo('fence');
			
			var platform = getObjectByInfo('Baraban');
			platform.animDelay = 2;
			self.platform = platform;
			
			self.stove = getObjectByInfo('Stove');
			
			var oven_lever = getObjectByInfo('oven_lever');
			self.ovenHandler.call(oven_lever);
			
			var ice = getObjectByInfo('ice');
			ice.animDelay = 4;
			ice.onenterframe = function(e) {
				if (e.target.currentFrame == 9) {
					deleteObject(ice);
				}
			}
			self.ice = ice;

			var slider = getObjectByInfo('slider');
			processSlider.call(slider, platform);
			for (var i = 0; i < stage.objects.length; i++) {
				if (stage.objects[i].lvlNum) {
					self.level = stage.objects[i];
					self.level.static = false;
				}
			};
			addStateBobGrowl();
		}, 		
		ovenHandler: function() {
			var self = levelsScripts[6],
				ANGLE = 3.3161, // 190 градусов
				IMPULSE = 2000000,
				// IMPULSE = 4500000,
				oven_int,
				bob = field.bob,
				burnt = false;
			
			this.anchor.x += 2;
			this.anchor.y += 1;
			this.isOff = true;
			this.rotateTo(5, 1, 1);
			this.static = true;
			this.onclick = function(e) {
				if (e.target.locked) return;
				e.target.locked = true;
				e.target.setStatic(false);
				if (!e.target.isOff) {
					if (isSoundOn) mixer.play('snd_button');
					var int1 = stage.setInterval(function() {
						e.target.rotation -= 0.53;
						// e.target.rotation -= 0.7;
						if (e.target.rotation <= 5) {
							stage.clearInterval(int1);
							self.stove.gotoAndStop(0);
							e.target.setStatic(true);
							e.target.locked = false;
							
							// Тание льда
							self.ice.gotoAndStop(self.ice.currentFrame);
						}
					}, 1);
					
					stage.clearInterval(oven_int);
					
					e.target.isOff = true;
				} else {
					if (isSoundOn) mixer.play('snd_button_ground_on');
					var int2 = stage.setInterval(function() {
						e.target.rotation += 0.53;
						if (e.target.rotation >= 8) {
							stage.clearInterval(int2);
							self.stove.gotoAndStop(2);
							e.target.setStatic(true);
							e.target.locked = false;
							
							// Тание льда
							self.ice.gotoAndPlay(self.ice.currentFrame);
						}
					}, 1);
					
					// Обжигание Боба
					oven_int = stage.setInterval(function(){
						if ((bob.x - self.stove.x) < 20 && (bob.x - self.stove.x) > -20 
							&& stage.hitTest(bob, self.stove) && !burnt) {
							burnt = true;
							bob.forceSleep();
				
							field.bob.changeState('BobGrowl');
							field.bob.BobGrowl.gotoAndPlay(0);
				
							bob.box2dBody.ApplyImpulse(
								new b2Vec2(Math.cos(ANGLE) * IMPULSE, 
								Math.sin(ANGLE) * IMPULSE), 
								new b2Vec2(bob.x, bob.y));
							
							stage.setTimeout(function(){
								// bob.forceWakeUp();
								burnt = false;
							}, 30);
						}
					}, 1);
					
					e.target.isOff = false;
				}
			}					
		},

		ifBobInLove: function() {
			var bob = field.bob,	
				self = levelsScripts[6];
			if (!bob.isInLove && bob.x >= self.chick.x) {
				bob.isInLove = true;
				bob.forceSleep();
				bob.changeState('BobFallsInLove');
				bob.BobFallsInLove.gotoAndPlay(0);
				if(isSoundOn) mixer.play('snd_whistle_to_girl');
				// закомментил, иначе блымает)
				// self.fence.setStatic(true);
				// self.level.setStatic(true);
			}	
		},	

		ifNeedFall: function() {
			var bob = field.bob,	
				self = levelsScripts[6];
			if (!bob.hasFallen && bob.x <= 130) {
				bob.changeState('BobFalls');
				bob.BobFalls.gotoAndPlay(0);
				bob.hasFallen = true;
			}
		},
		
		pretick: function() {
			var self = levelsScripts[6];
			self.ifBobInLove();	
			self.ifNeedFall();	
		}
	},
	
/********************************************************* 
*							Level 8
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[7];

			var latch = getObjectByInfo('latch_lvl8');
			addHint.call(latch, latch.x-35, latch.y);
			latch.position = 'left';
			latchMove.call(latch, 60);

			var lever = getObjectByInfo('Lever2');
			addHint.call(lever, lever.x, lever.y+5);
			lever.side = 'left';
			lever.onclick = self.lever8Action;
			self.lever = lever;

			self.bridge = getObjectByInfo('bridge_lvl8').box2dBody;

			var button_red = getObjectByInfo('button_red');
			button_red.onclick = self.buttonRedAction;
			attachMouseEvents.call(button_red);
			addHint.call(button_red, button_red.x, button_red.y);

			self.spring = getObjectByInfo('spring_up');
			self.spring.onenterframe = function(e){
				if (e.target.currentFrame == 11) {
					e.target.gotoAndStop(0);
				};
			};
			self.cS = getObjectByCustomInfo('cancelSpeed');
			self.cS2 = getObjectByCustomInfo('cancelSpeed2');
		},

		lever8Action: function(e){
			var self = levelsScripts[7];
			var obj = e.target;
			if(self.block) return;
			if (isSoundOn) mixer.play('snd_lever_double');
			self.block = true;
			if (obj.side == 'left'){
				if (isSoundOn) mixer.play('snd_door_left');
				obj.side = 'right';
				obj.gotoAndPlay(0);
				obj.onenterframe = function(e) {if(e.target.currentFrame == 5) e.target.stop();}
				self.moveBridge(true);
			} else {
				if (isSoundOn) mixer.play('snd_door_right');
				obj.side = 'left';
				obj.rewindAndStop(5);
				self.moveBridge(false);
			}
		},


		moveBridge: function(toRight){
				var self = levelsScripts[7],
					bridge = self.bridge;
				bridge.sprite.setStatic(false);
				var oldPos = bridge.GetCenterPosition();
				var int1 = stage.setInterval(function(){
					var pos = bridge.GetCenterPosition();
					// if (toRight) pos.x += 10.06;
					// else pos.x -= 10.06;
					if (toRight) pos.x += 15.5;
					else pos.x -= 15.5;
					
					bridge.SetOriginPosition(pos, 0);

					if (Math.abs(oldPos.x - pos.x) > 151) {
						stage.setTimeout(function(){bridge.sprite.setStatic(true);},1); 
						stage.clearInterval(int1);
						self.block = false;
					}
				}, 1);
		},

		buttonRedAction: function(){
			var self = levelsScripts[7];
			if (self.spring.currentFrame != 0) return;
			self.spring.play();
			if (isSoundOn) mixer.play('snd_spring');
	
			if (stage.hitTest(field.bob, self.spring)) {
				stage.setTimeout(function(){
					field.bob.box2dBody.ApplyImpulse(new b2Vec2(0, -3200000), 
						field.bob.box2dBody.GetCenterPosition());	
				}, 1);
			};
		},

		ifCancelSpeed: function(){
			var	self = levelsScripts[7];
			if(stage.hitTest(field.bob, self.cS) ||	stage.hitTest(field.bob, self.cS2)){
				field.bob.box2dBody.m_linearVelocity.x = 0;
			}
		},

		ifBobFalls: function(){
			if(field.bob.y > 250) bobFalls();
		},

		pretick: function() {
			var self = levelsScripts[7];
			self.ifBobFalls();
			self.ifCancelSpeed();
		},
	},

/********************************************************* 
*							Level 9
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[8];

			var bridges = getObjectByInfo('bridge_lvl9');
			var lamps = getObjectByInfo('lamp');
			var buts = getObjectByInfo('button_lvl9');
			var earths = getObjectByInfo('earth_lvl9');
			self.bridges = bridges;
			self.lamps = lamps;
			self.buts = buts;
			self.earths = earths;
			self.wire = getObjectByInfo('wire');
			self.wire.setStatic(true);

			//порядок ламп и другого зависит от расположения в levels.js
			for (var i = 0; i < 4; i++) {
				lamps[i].gotoAndStop(1);
				buts[i].gotoAndStop(2);
				addHint.call(buts[i], buts[i].x, buts[i].y);
				self.buttonHandler.call(buts[i]);
				bridges[i].setZIndex(3);
				earths[i].setZIndex(4);
				bridges[i].setStatic(true);
				earths[i].setStatic(true);
				lamps[i].setStatic(true);
			};
		},
		
		buttonHandler: function() {
			var self = levelsScripts[8];

			this.onmousedown = function() {
				if (self.block) return;
				for (var i = 0; i < 4; i++) {
					if (self.buts[i] == this) {
						if(!self.bridges[i].show) {
							self.lamps[i].gotoAndStop(0);
							self.buts[i].gotoAndStop(1);
							self.moveBridge(self.bridges[i], self.earths[i], true);
						}
					} else {
						if(self.bridges[i].show) {
							self.moveBridge(self.bridges[i], self.earths[i], false);
							self.lamps[i].gotoAndStop(1);
							self.buts[i].gotoAndStop(2);
						}
					}
				};
			}	
			
			this.onmouseup = function(e) {
				e.target.gotoAndStop(0);
			}
		},

		moveBridge: function(bridge, earth, show){
			var self = levelsScripts[8];

			if(show) {
				bridge.show = true;
				if (isSoundOn) mixer.play('snd_button_ground_on');
			} else {
				bridge.show = false;
				if (isSoundOn) mixer.play('snd_button_ground_off');
			}
			self.block = true;
			bridge.setStatic(false);
			earth.setStatic(false);
			self.wire.setStatic(false);

			var oldPos = bridge.box2dBody.GetCenterPosition();
			var int1 = stage.setInterval(function(){
				var pos = bridge.box2dBody.GetCenterPosition();
				if (show) pos.x -= 8;
				else pos.x += 8;
				
				bridge.box2dBody.SetOriginPosition(pos, 0);

				if (Math.abs(oldPos.x - pos.x) >= bridge.width-8) {
					stage.setTimeout(function(){
						bridge.setStatic(true);
						earth.setStatic(true);
						self.wire.setStatic(true);
						self.block = false;
					},2); 
					stage.clearInterval(int1);
				}
			}, 1);
		},

		ifBobFalls: function(){
			if(field.bob.y > 220) bobFalls();
		},
		pretick: function() {
			var self = levelsScripts[8];
			self.ifBobFalls();
		}
	},

/********************************************************* 
*							Level 11
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[9];
			
			getObjectByInfo('lever_cover_down').setStatic(true);
			self.int = stage.setInterval(function(){
				self.createLava(4);
			}, Math.floor(fps/2));
			var bridge = getObjectByInfo('bridge_lvl11');
			self.bridge = bridge;
			var smokes = getObjectByInfo('smoke');
			for(var i = 0; i<smokes.length; i++){
				smokes[i].animDelay = 2;
				smokes[i].play();
			}
			
			var fire = getObjectByInfo('fire_lvl11');
			for(var f = 0; f<fire.length; f++){
				(function(ff){
					//для рассинхрона
					stage.setTimeout(function(){fire[ff].play();}, ff);
				})(f);
			}

			var buttonLeft = getObjectByInfo('button_blue_left');
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);
			var buttonRight = getObjectByInfo('button_blue_right');
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);
			self.buttonRight = buttonRight;
			var buttonMid = getObjectByInfo('button_blue_mid');
			// buttonLeft.setStatic(true);
			// buttonRight.setStatic(true);
			// buttonMid.setStatic(true);

			var button1 = getObjectByCustomInfo('button1');
			var button2 = getObjectByCustomInfo('button2');
			var button3 = getObjectByCustomInfo('button3');
			addHint.call(button1, button1.x, button1.y);
			addHint.call(button2, button2.x, button2.y);
			addHint.call(button3, button3.x, button3.y);

			button1.onmousedown = self.onButtonDown;
			button2.onmousedown = self.onButtonDown;
			button3.onmousedown = self.onButtonDown;
			button1.onmouseup = self.onButtonUp;
			button3.onmouseup = self.onButtonUp;
			button2.onmouseup = self.onButton2Up;

			self.button1 = button1;
			self.button2 = button2;
			self.button3 = button3;

			moveBridge.call(bridge.box2dBody, buttonLeft, 87);
			moveBridge.call(bridge.box2dBody, buttonRight, 138);

			var pliers = getObjectByInfo('pliers_down');
			pliers.animDelay = 1;
			pliers.onenterframe = function(e){
				if(e.target.currentFrame == 5) e.target.stop();
			}
			self.pliers = pliers;
			self.rope = getObjectByInfo('rope_lvl11');
			self.cover = getObjectByInfo('block_lvl11');
			self.tube = getObjectByInfo('tube_lvl11');
		
			if (isSoundOn) mixer.play('snd_boil');
			stage.setInterval(function(){
				if (isSoundOn) mixer.play('snd_boil');
			}, fps*6);
		},
		
		onButtonDown: function(e){
			if (e.target.currentFrame != 1) {
				e.target.gotoAndStop(1);
				if (isSoundOn) mixer.play('snd_crane');
			};
		},
		onButtonUp: function(e){
			e.target.gotoAndStop(0);

		},
		onButton1Up: function(e){
			var self = levelsScripts[9],
				pliers = self.pliers;
			e.target.hint.removeHint();
			pliers.bitmap = bitmaps.pliers_catch;
			pliers.totalFrames = 3;
			pliers.onenterframe = function(e){
				if (e.target.currentFrame == 2) {
					e.target.stop();
				};
			}
			pliers.gotoAndPlay(0);
			self.button1.onmouseup = null;
			self.button2.onmouseup = null;
			self.button3.onmouseup = self.onButton3Up2;
			self.button1.setStatic(true);
			self.button2.setStatic(true);
		},
		onButton2Up: function(e){
			var self = levelsScripts[9];
			e.target.hint.removeHint();
			self.movePliers(true, 170);
			self.pliers.play();
			self.button1.onmouseup = self.onButton1Up;
			self.button3.onmouseup = self.onButton3Up;
		},
		onButton3Up: function(e){
			var self = levelsScripts[9];
			addHint.call(self.button2, self.button2.x, self.button2.y);
			e.target.gotoAndStop(0);
			self.button2.gotoAndStop(0);
			self.movePliers(false, 110);
			self.pliers.rewindAndStop(5);
			self.button1.onmouseup = self.onButtonUp;
			self.button3.onmouseup = self.onButtonUp;
		},
		onButton3Up2: function(e){
			var self = levelsScripts[9];
			e.target.hint.removeHint();
			e.target.setStatic(true);
			self.movePliers(false, 90, self.cover.box2dBody);
			self.button1.onmouseup = null;
			self.button2.onmouseup = null;
			self.button3.onmouseup = null;
			moveBridge.call(self.bridge.box2dBody, self.buttonRight, 370);
		},

		createLava: function(amount){
			if (amount <=0) return;
			var rand = Math.random() * 185 + 219;
			var mc = createObject({type: "lava", x: rand, y: 35, rotation: 0});
			mc.onenterframe = lavaOnEnter;
			mc.setZIndex(5);
			if(gameState != STATE_GAME) stage.clearInterval(levelsScripts[9].int);
			
			function lavaOnEnter(e){
				var c = e.target.box2dBody.GetContactList();
				if (c && c.other.sprite.info != 'lava') {
					//проверка, Боб ли это ("state" есть только у Боба)
					if (c.other.sprite.state) bobBurns();
					e.target.destroy = true;
					world.DestroyBody(e.target.box2dBody);
				}
			}

			amount--;
			levelsScripts[9].createLava(amount);
		},
		movePliers: function(down, restriction, cover){
			var self = levelsScripts[9];
			if ((down && self.pliers.y >= restriction) || (!down && self.pliers.y <= restriction)) return;

			var int = stage.setInterval(function(){
				if (down){
					self.rope.y += 6;
					self.pliers.y += 6;
				} else {
					self.rope.y -= 6;
					self.pliers.y -= 6;
				}

				if (cover){
					var pos = cover.GetCenterPosition();
					if (down) pos.y += 6;
					else pos.y -= 6;
					
					cover.SetOriginPosition(pos, 0);
				}
				if ((down && self.pliers.y >= restriction) || (!down && self.pliers.y <= restriction)) {
					stage.clearInterval(int);
				}
			},1);
		},
		
		pretick: function() {
		}
	},

/********************************************************* 
*							Level 12
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[10];

			var button = getObjectByInfo('button_lvl12');
			self.prop = getObjectByInfo('prop_lvl12');
			self.buttonAction.call(button);
			addHint.call(button, button.x, button.y);
		},

		buttonAction: function(){
			var but = this,
				prop = levelsScripts[10].prop.box2dBody,
				int;
			but.onmousedown = function(e){
				e.target.gotoAndStop(2);
				int = stage.setInterval(function(){
					pos = prop.GetCenterPosition();
					pos.x += 4;

					prop.SetOriginPosition(pos, 0);
					if (pos.x >440) stopMove();
				}, 1);
			}
			but.onmouseup = function(e){
				e.target.gotoAndStop(1);
				stopMove();	
			} 
			but.onmouseout = function(e){
				e.target.gotoAndStop(0);
				stopMove();
			}

			but.onmouseover = function(e) {
				e.target.gotoAndStop(1);
			}	
	
			function stopMove(){
				stage.clearInterval(int);
			}
		},

		ifBobFalls: function(){
			if(field.bob.y > 230) bobFalls();
		},
		
		pretick: function() {
			var self = levelsScripts[10];
			self.ifBobFalls();
		
		},
	},

/********************************************************* 
*							Level 13
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[11];

			var press = getObjectByInfo('press');
			press.up = true;
			self.press = press;

			var buttonLeft = getObjectByInfo('button_blue_left');
			buttonLeft.setStatic(true);
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);
			var buttonRight = getObjectByInfo('button_blue_right');
			buttonRight.setStatic(true);
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);
			var buttonMid = getObjectByInfo('button_blue_mid');
			buttonMid.setStatic(true);

			var bridge = getObjectByInfo('bridge_lvl13');
			bridge.setStatic(true);
			self.bridge = bridge;
			rotateHandler.call(bridge.box2dBody, buttonLeft);
			rotateHandler.call(bridge.box2dBody, buttonRight);

			var propLeft = getObjectByCustomInfo('propLeft');
			propLeft.position = 'down';
			var buttonLeft_prop = getObjectByCustomInfo('buttonLeft_prop');
			addHint.call(buttonLeft_prop, buttonLeft_prop.x, buttonLeft_prop.y);
			self.moveProp.call(buttonLeft_prop, propLeft.box2dBody);

			var propRight = getObjectByCustomInfo('propRight');
			propRight.position = 'down';
			var buttonRight_prop = getObjectByCustomInfo('buttonRight_prop');
			addHint.call(buttonRight_prop, buttonRight_prop.x, buttonRight_prop.y);
			self.moveProp.call(buttonRight_prop, propRight.box2dBody);
			self.buttonRight_prop = buttonRight_prop;
			self.buttonLeft_prop = buttonLeft_prop;
			self.propRight = propRight;
			self.propLeft = propLeft;
			
			self.downSticks = getObjectByCustomInfo('downSticks');
			self.downSticks.visible = false;
			self.rope2 = getObjectByInfo('rope2');
			self.rope2.visible = false;
			self.rope3 = getObjectByInfo('rope3');
			self.rope3.visible = false;
			self.rope4 = getObjectByInfo('rope4');
			self.rope4.visible = false;
			self.rope5 = getObjectByInfo('rope5');
			self.rope5.visible = false;
			self.rope6 = getObjectByInfo('rope6');
			self.rope6.visible = false;
			addStateBobFlatten();
			
			self.movePress();
		},

		movePress: function(){
			var self = levelsScripts[11],
				body = self.press.box2dBody;

			stage.setTimeout(self.movePress, fps*2.5);
			if (self.propRight.position == 'up' || self.propLeft.position == 'up') return;
			self.buttonRight_prop.gotoAndStop(1);
			self.buttonLeft_prop.gotoAndStop(1);
			move(true);

			function move(down){
				if (field.bob.gameOver) return;
				var oldPos = body.GetCenterPosition();
				var int = stage.setInterval(function(){
					var pos = body.GetCenterPosition();
					if (down) pos.y += 8;
					else pos.y -= 8;
					changeVisible(pos, self.downSticks);
					changeVisible(pos, self.rope2);
					changeVisible(pos, self.rope3);
					changeVisible(pos, self.rope4);
					changeVisible(pos, self.rope5);
					changeVisible(pos, self.rope6);

					body.SetOriginPosition(pos, 0);

					if(down) self.ifBobFlatten();
					if (Math.abs(oldPos.y - pos.y) > 70) {
						stage.clearInterval(int);
						if(down) {
							if (isSoundOn) mixer.play('snd_press');
							var mc = new Sprite(bitmaps.smoke_lvl13, 220, 56, 11);
							mc.x = 192;
							mc.y = 150;
							// mc.animDelay = 2;
							mc.onenterframe = function(e){
								if(e.target.currentFrame == 9) e.target.destroy = true;
							}
							stage.addChild(mc);

							stage.setTimeout(function(){move(false)}, Math.floor(fps*0.6));
						} else {
							self.buttonRight_prop.gotoAndStop(0);
							self.buttonLeft_prop.gotoAndStop(0);	
						}
					}

				}, 1);
				function changeVisible(pos, elem){
					if(pos.y > elem.y){
						if (!elem.visible) elem.visible = true;
					} else {
						if (elem.visible) elem.visible = false;
					}
				};
			};
		},

		moveProp: function(prop){
			var self = levelsScripts[11],
				but = this;
			but.onclick = function(){
				if(but.block || but.currentFrame == 1) return;
				if (prop.sprite.position == 'up') {
					prop.sprite.position = 'down';
					var up = false;
				} else {
					prop.sprite.position = 'up';
					var up = true;
				}
				but.block = true;
				prop.sprite.setStatic(false);
				var oldPos = prop.GetCenterPosition();
				var int1 = stage.setInterval(function(){
					var pos = prop.GetCenterPosition();
					if (up) pos.y -= 8;
					else pos.y += 8;
					
					prop.SetOriginPosition(pos, 0);

					if (Math.abs(oldPos.y - pos.y) > 70) {
						stage.setTimeout(function(){
							prop.sprite.setStatic(true);
							but.block = false;
						},2); 
						stage.clearInterval(int1);
					}
				}, 1);
			}
		},
		ifBobFlatten: function(){
			var press = levelsScripts[11].press,
				bob = field.bob;
			if (!press.crushedBob && stage.hitTest(bob, press)) {
				bob.changeState('BobFlatten');
				bob.BobFlatten.gotoAndPlay(0);
				bob.box2dBody.Freeze();
				stage.setTimeout(function(){bob.gameOver = true;}, fps); 
				bob.onclick = null;
				press.crushedBob = true;
			};
		},
		ifBobFalls: function(){
			if(field.bob.y > 210) bobFalls();
		},
		pretick: function() {
			var self = levelsScripts[11];
			self.ifBobFalls();
			// self.ifBobFlatten();
		},
		
		posttick: function() {
		
		}
	},

/********************************************************* 
*							Level 14
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[12];
			
			var carriage1 = getObjectByInfo('carriage1_lvl14');
			var carriage2 = getObjectByInfo('carriage2_lvl14');
			var carriage3 = getObjectByInfo('carriage3_lvl14');
			var carriage4 = getObjectByInfo('carriage4_lvl14');

			var button_left_down = getObjectByCustomInfo('button_left_down');
			addHint.call(button_left_down, button_left_down.x, button_left_down.y);
			var button_left_up = getObjectByCustomInfo('button_left_up');
			addHint.call(button_left_up, button_left_up.x, button_left_up.y);
			var button_right_down = getObjectByCustomInfo('button_right_down');
			addHint.call(button_right_down, button_right_down.x, button_right_down.y);
			var button_right_up = getObjectByCustomInfo('button_right_up');
			addHint.call(button_right_up, button_right_up.x, button_right_up.y);

			self.moveCarriage.call(button_left_down, carriage3, carriage1, 143);
			self.moveCarriage.call(button_left_up, carriage1, carriage3, 143);
			self.moveCarriage.call(button_right_down, carriage4, carriage2, 145);
			self.moveCarriage.call(button_right_up, carriage2, carriage4, 133);
		},

		// не делаю setStatic, иначе слишком часто перерисовывается статика
		moveCarriage: function(carUp, carDown, minHeight){
				var but = this,
					int,
					bob = field.bob;

			but.onmousedown = function(e){
				if (carUp.box2dBody.GetCenterPosition().y < minHeight) return;
				int = stage.setInterval(function(){
					var posUp = carUp.box2dBody.GetCenterPosition();
					posUp.y -= 4;
					var posDown = carDown.box2dBody.GetCenterPosition();
					posDown.y += 4;

					if (carUp.box2dBody.GetContactList()){
						var bob_pos = field.bob.box2dBody.GetCenterPosition();
						bob_pos.y -= 4;
						field.bob.box2dBody.SetOriginPosition(bob_pos, 0);
					}
					if (carDown.box2dBody.GetContactList()){
						var bob_pos = field.bob.box2dBody.GetCenterPosition();
						bob_pos.y += 4;
						field.bob.box2dBody.SetOriginPosition(bob_pos, 0);
					}
					carUp.box2dBody.SetOriginPosition(posUp, 0);
					carDown.box2dBody.SetOriginPosition(posDown, 0);
					if (posUp.y < minHeight) stopMove();
				}, 1);
			}
			but.onmouseup = stopMove;	
			but.onmouseout = stopMove;

			function stopMove(){
				stage.clearInterval(int);
			}
		},		
		ifBobFalls: function(){
			if(field.bob.y > 267) bobFalls();
		},
		pretick: function() {
			var self = levelsScripts[12];
			self.ifBobFalls();
		},
		
		posttick: function() {
		
		}
	},

/********************************************************* 
*							Level 15
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[13];

			var buttonLeft = getObjectByInfo('button_blue_left');
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);
			var buttonRight = getObjectByInfo('button_blue_right');
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);
		
			var lever = getObjectByInfo('Lever4');
			lever.onenterframe = function(e){
				if (e.target.currentFrame == 5) {e.target.stop();};
			}
			lever.side = 'up';
			var bridge = getObjectByInfo('bridge_lvl15');
			bridge.setStatic(true);
			addHint.call(lever, lever.x+6, lever.y+1);
			
			var mechanism = getObjectByInfo('mechanism_lvl15');
			mechanism.onenterframe = function(e){
				if (e.target.currentFrame == 8) e.target.stop();
			};
			// mechanism.animDelay = 2;
			self.mechanism = mechanism;
			self.mechanismBody = getObjectByCustomInfo('mechanismBody').box2dBody;

			lever.onclick = self.leverAction;

			var circle = getObjectByInfo('circle_lvl15');
			circle.setStatic(true);
			var prop = getObjectByInfo('prop_lvl15');
			prop.setStatic(true);

			moveBridge.call(bridge.box2dBody, buttonLeft, 85, circle, prop, true);
			moveBridge.call(bridge.box2dBody, buttonRight, 268, circle, prop, true);

			//чтоб при рестарте не было box
			self.box = null;
			self.addBox();

			addStateBobFlatten();
		},

		leverAction: function(e){
			var obj = e.target,
				self = levelsScripts[13];
			if (self.mechanism.block) return;
			self.mechanism.block = true;
			var pos = self.mechanismBody.GetCenterPosition();
			if (isSoundOn) mixer.play('snd_lever_double');
			if (obj.side == 'up'){
				if (isSoundOn) mixer.play('snd_door_left');
				obj.side = 'down';
				obj.gotoAndPlay(0);
				self.mechanism.gotoAndPlay(0);
				pos.x -= 150;
			} else {
				if (isSoundOn) mixer.play('snd_door_right');
				obj.side = 'up';
				obj.rewindAndStop(5);
				self.mechanism.rewindAndStop(8);
				pos.x += 150;
			}
			stage.setTimeout(function(){
				self.mechanismBody.SetOriginPosition(pos, 0);
				stage.setTimeout(function(){self.mechanism.block = false}, Math.floor(fps/8));	
			}, Math.floor(fps/4));
		},
		addBox: function(){
			var self = levelsScripts[13];
			stage.setInterval(function(){
				if (!self.box) {
					self.box = createObject({type: "box_lvl15", x: 270, y: -16, rotation: 0});
					self.box.setZIndex(14);
				};
			}, fps);
		},
		
		destroyBox: function(){
			var self = levelsScripts[13];
			if (self.box && self.box.y > 350) {
				self.box.destroy = true;
				world.DestroyBody(self.box.box2dBody);
				self.box = null;
			};
		},

		ifBobFalls: function(){
			if(field.bob.y > 260) bobFalls();
		},

		ifBobFlatten: function(){
			var box = levelsScripts[13].box,
				bob = field.bob;
			if (box && !box.crushedBob && stage.hitTest(bob, box) && 
				(box.y+box.height/2)<bob.y) {

				bob.changeState('BobFlatten');
				bob.BobFlatten.gotoAndPlay(0);
				bob.box2dBody.Freeze();
				stage.setTimeout(function(){box.box2dBody.Freeze();}, 3); 
				bob.onclick = null;
				box.crushedBob = true;
			};
		},
		ifBoxLetSmoke: function(){
			var self = levelsScripts[13],
				box = self.box;
			if (!box || box.letSmoke) return;
			var c = box.box2dBody.GetContactList();
			if (c && c.other.sprite.custom == 'mechanismBody') {
				if (isSoundOn) mixer.play('snd_box_dropped');
				var mc = new Sprite(bitmaps.smoke_lvl15, 117, 30, 22);
				mc.x = box.x;
				mc.y = box.y;
				mc.onenterframe = function(e){
					if(e.target.currentFrame == 21) e.target.destroy = true;
				}
				stage.addChild(mc);
				box.letSmoke = true;
			};	
		},
		pretick: function() {
			var self = levelsScripts[13];
			self.destroyBox();
			self.ifBobFalls();
			self.ifBobFlatten();
			self.ifBoxLetSmoke();
		}
	},

/********************************************************* 
*							Level 16
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[14];

			var bridge1 = getObjectByCustomInfo('bridge1');
			bridge1.setStatic(true);
			var bridge2 = getObjectByCustomInfo('bridge2');
			bridge2.setStatic(true);
			
			var button1_left = getObjectByCustomInfo('button1_left');
			var button1_right = getObjectByCustomInfo('button1_right');
			var button2_left = getObjectByCustomInfo('button2_left');
			var button2_right = getObjectByCustomInfo('button2_right');
			
			addHint.call(button1_left, button1_left.x, button1_left.y);
			addHint.call(button1_right, button1_right.x, button1_right.y);
			addHint.call(button2_left, button2_left.x, button2_left.y);
			addHint.call(button2_right, button2_right.x, button2_right.y);
		
			rotateHandler.call(bridge1.box2dBody, button1_left);
			rotateHandler.call(bridge1.box2dBody, button1_right);
			rotateHandler.call(bridge2.box2dBody, button2_left);
			rotateHandler.call(bridge2.box2dBody, button2_right);

			var latch = getObjectByInfo('latch_lvl16');
			addHint.call(latch, latch.x+25, latch.y+2);
			latch.position = 'right';
			latchMove.call(latch, 32);
			self.latch = latch;

			var pump = getObjectByInfo('pump_up');
			addHint.call(pump, pump.x, pump.y-6);
			pump.position = 'up';
			pump.onclick = self.pumpAction;

			var ball = getObjectByInfo('ball');
			ball.number = 1;
			ball.setZIndex(14);
			//запрет на вращение шарика с корзиной
			ball.box2dBody.m_invI = 0;

			ball.onenterframe = function(e){
				var obj = e.target;
				if (obj.currentFrame == 6) {
					if (obj.number<6) {
						obj.bitmap = bitmaps['ball'+obj.number];
						obj.gotoAndStop(0);
					} else {
						obj.stop();
						if (obj.number == 6) self.flyBall();
					}
				}
				if(obj.number == 7 && obj.currentFrame == 5){
					obj.bitmap = bitmaps.ball7;
					obj.totalFrames = 7;
					obj.number++;					
					obj.gotoAndPlay(0);
				}
			}
			self.ball = ball;
			self.basket = getObjectByInfo('basket_invisible');
		},
		
		flyBall: function(){
			var body = levelsScripts[14].ball.box2dBody,
				pos = body.GetCenterPosition(),
				force = -1600000*obstacle_density;
			if (!body.sprite.burst) body.ApplyForce(new b2Vec2(0, force), new b2Vec2(pos.x, pos.y));
		},
		pumpAction: function(e){
			var obj = e.target,
				self = levelsScripts[14];

			if (self.ball.currentFrame !== 0) return;
			if (isSoundOn) mixer.play('snd_pump');
			self.ball.play();
			self.ball.number++;

			if (obj.position == 'up') {
				obj.position = 'down';
				obj.y += 23;
				obj.hint.y += 23;
			} else {
				obj.position = 'up';
				obj.y -=23;
				obj.hint.y -= 23;
			}
		},

		ifBobFalls: function(){
			var x = field.bob.x,
				y = field.bob.y;
			if(y > 270) bobFalls();
			if ((y < -50 || x < -50 || x > 530) && !field.bob.gameOver) {
				field.bob.gameOver = true;
				showGameOverScreen();
			}
		},
		controlBobSpeed: function(){
			var bob = field.bob,
			basket = levelsScripts[14].basket;
			if (stage.hitTest(bob, basket)) {
				bob.box2dBody.m_linearVelocity.x = bob.speed + 
					basket.box2dBody.m_linearVelocity.x;	
			}
		},
		ifBallBurst: function(){
			var self = levelsScripts[14],
				latch = self.latch,
				ball = self.ball,
				basket = self.basket,
				bob = field.bob;
			if (latch.position == 'left' && stage.hitTest(ball, latch) && !ball.burst1) {
				ball.burst1 = true; //чтоб лопнуло 1 раз
				//задержка для реалистичности, чтоб не сразу падал шар
				stage.setTimeout(function(){
					if (isSoundOn) mixer.play('snd_baloon_pop');
					ball.burst = true;
					ball.bitmap = bitmaps['ball'+ball.number];
					ball.totalFrames = 6;
					ball.number++;
					ball.gotoAndPlay(0);
				}, Math.floor(fps/5));

				// костыль, чтоб Боб после лопанья шара сильно не подпрыгивал
				stage.setInterval(function(){
						console.log('dsgj');
					if(bob.box2dBody.m_linearVelocity.y < 0 &&
						bob.box2dBody.m_linearVelocity.y < basket.box2dBody.m_linearVelocity.y){
						bob.box2dBody.m_linearVelocity.y = basket.box2dBody.m_linearVelocity.y;
					}
				},1);
			};
		},
		pretick: function() {
			var self = levelsScripts[14];
			self.ifBobFalls();
			self.controlBobSpeed();
			self.ifBallBurst();
		}
	},

/********************************************************* 
*							Level 17
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[15];

			var buttonLeft = getObjectByInfo('button_blue_left');
			buttonLeft.setStatic(true);
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);
			var buttonRight = getObjectByInfo('button_blue_right');
			buttonRight.setStatic(true);
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);
			var buttonMid = getObjectByInfo('button_blue_mid');
			buttonMid.setStatic(true);

			var leftFire = getObjectByCustomInfo('leftFire');
			var middleFire = getObjectByCustomInfo('middleFire');
			var rightFire = getObjectByCustomInfo('rightFire');


			leftFire.visible = false;
			middleFire.visible = false;
			rightFire.visible = false;

			leftFire.setZIndex(16);
			middleFire.setZIndex(16);
			rightFire.setZIndex(16);

			leftFire.play();
			middleFire.play();
			rightFire.play();

			self.leftFire = leftFire;
			self.middleFire = middleFire;
			self.rightFire = rightFire;

			var leftSmallFire = getObjectByCustomInfo('leftSmallFire');
			var middleSmallFire = getObjectByCustomInfo('middleSmallFire');
			leftSmallFire.visible = false;
			middleSmallFire.visible = false;
			leftSmallFire.play();
			middleSmallFire.play();
			self.leftSmallFire = leftSmallFire;
			self.middleSmallFire = middleSmallFire;

			self.fires = getObjectByInfo('fire_lvl17');

			var fireTimeAnim = getObjectByInfo('FireTimeAnim');
			fireTimeAnim.animDelay = Math.floor(2.2*fps);
			fireTimeAnim.onenterframe = function(e){
				if (e.target.currentFrame == 3 && !e.target.fire) {
					e.target.fire = true;
					rightFire.visible = true;
					if (isSoundOn && gameState == STATE_GAME) {
						mixer.play('snd_fire_gas', false, false, 3);
					}
					e.target.stop();
					stage.setTimeout(function(){
						e.target.gotoAndPlay(0);
						e.target.fire = false;
						rightFire.visible = false;
					}, Math.floor(2.5*fps));
				};
			}
			fireTimeAnim.play();
			self.fireTimeAnim = fireTimeAnim;
			var bridge = getObjectByInfo('bridge_lvl17');
			self.bridge = bridge;

			moveBridge.call(bridge.box2dBody, buttonLeft, 55/*, circle, prop*/);
			moveBridge.call(bridge.box2dBody, buttonRight, 237/*, circle, prop*/);
	
			self.leftButton = getObjectByCustomInfo('leftButton');
			self.rightButton = getObjectByCustomInfo('rightButton');

		},

		buttonPress: function(but, fire, smallFire){
			var bob = field.bob,
				self = levelsScripts[15];
			
			//если Боб на кнопке
			if (bob.x < but.x + 25 && bob.x > but.x-20) {
				if (but.currentFrame === 0) {
					if (isSoundOn) mixer.play('snd_button_ground_on');
					but.gotoAndStop(1);
				}
				if (isSoundOn && !fire.soundPlayed) {
					mixer.play('snd_fire_gas', false, false, 4);
					fire.soundPlayed = true;
				}
				var bridgeX = self.bridge.box2dBody.GetCenterPosition().x;
				if (bridgeX+22 < fire.x || bridgeX-22> fire.x) {
					//большой огонь
					fire.visible = true;
					smallFire.visible = false;
				} else {
					//маленький огонь
					fire.visible = false;
					smallFire.visible = true;
				};

			} else {
				if (but.currentFrame == 1) {
					mixer.stop(4);
					if (isSoundOn) mixer.play('snd_button_ground_off');
					but.gotoAndStop(0);
				}
				fire.visible = false;
				smallFire.visible = false;
			};
		},
		bobOnFire: function(fire){
			var bob = field.bob;
			if (!fire.visible || !stage.hitTest(bob, fire)) return;
			bobBurns(fire);
		},
		
		checkIfBobOnFire: function(){
			var fires = levelsScripts[15].fires;
			for (var i = 0; i < fires.length; i++) {
				levelsScripts[15].bobOnFire(fires[i]);
			};
		},
		pretick: function() {
			var self = levelsScripts[15];
			self.buttonPress(self.leftButton, self.leftFire, self.leftSmallFire);
			self.buttonPress(self.rightButton, self.middleFire, self.middleSmallFire);
			self.checkIfBobOnFire();
		},
		
		posttick: function() {
		
		}
	},

/********************************************************* 
*							Level 10
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[16];

			var lever1 = getObjectByCustomInfo('Lever1');
			addHint.call(lever1, lever1.x+6, lever1.y+1);
			lever1.setStatic(true);

			var lever2 = getObjectByCustomInfo('Lever2');
			lever2.scaleX = -1;
			addHint.call(lever2, lever2.x-6, lever2.y+1);
			lever2.side = 'up';
			lever2.onclick = self.lever2Action;
			self.lever2 = lever2;

			var energy_box = getObjectByInfo('energy_box');
			energy_box.box2dBody.GoToSleep();
			self.energy_box = energy_box;
			self.minus_plus = getObjectByInfo('minus_plus');
			self.minus_plus.setStatic(true);

			var mechanism = getObjectByInfo('mechanism');
			mechanism.onenterframe = function(e){
				if (e.target.currentFrame == 7) {
					e.target.stop();
					e.target.setStatic(true);
				};
			};

			var button = getObjectByInfo('button_red');
			attachMouseEvents.call(button);
			button.onclick = self.buttonAction;

			self.bridge = getObjectByInfo('bridge_lvl10');
			self.pillar = getObjectByInfo('pillar_lvl10');
			self.bridge.setStatic(true);
			self.pillar.setStatic(true);

			self.barrier = getObjectByInfo('barrier_lvl10');
			self.barrier.setStatic(true);

			self.lantern = getObjectByInfo('lantern');
			self.lantern.gotoAndStop(1);
			self.lantern.setStatic(true);
			self.small_tube = getObjectByInfo('small_tube_lvl10');
			self.small_tube.setStatic(true);

			self.radiationAnim = getObjectByInfo('radiationAnim1');

			moveMechanism.call(lever1, mechanism, energy_box);
			addStateBobGrowl();
		},

		lever2Action: function(){
			var self = levelsScripts[16],
				obj = self.lever2;
			if (obj.block) return;
			obj.block = true;
			if (isSoundOn) mixer.play('snd_lever_double');
			if (obj.side == 'up'){
				obj.side = 'down';
				obj.gotoAndPlay(0);
				obj.onenterframe = function(e){if(e.target.currentFrame == 5) e.target.stop();}

				self.moveBridge(true);
			} else {
				obj.side = 'up';
				obj.rewindAndStop(5);

				self.moveBridge(false);
			}
		},
		
		moveBridge: function(up){
			var	self = levelsScripts[16], 
				body = self.bridge.box2dBody,
				oldPos,
				newPos = {};
			if (isSoundOn) mixer.play('snd_bridge');
			
			self.pillar.setStatic(false);
			self.bridge.setStatic(false);

			oldPos = {x: body.GetCenterPosition().x, y: body.GetCenterPosition().y};

			if(up) oldPos.x +=35;
			else oldPos.y +=35;


			var int = stage.setInterval(function(){
				var rot, vec;

				if(up){
					self.flip(field.bob.box2dBody, oldPos);
					self.flip(self.energy_box.box2dBody, oldPos);
				}
				
				vec = new Vector(35, 0);

				if(up) rot = body.m_rotation+0.1;
				else rot = body.m_rotation-0.1;

				vec.rotate(-rot);

				newPos.x = oldPos.x - vec.x;
				newPos.y = oldPos.y - vec.y;
				body.SetOriginPosition(newPos, rot);

				if ((up && rot >= Math.PI/2) || (!up && rot <= 0)) {
					stage.clearInterval(int);

					//для коррекции небольшого смещения
					if(!up) body.SetOriginPosition(new b2Vec2(236, 177), 0);

					stage.setTimeout(function(){
						self.bridge.setStatic(true);
						self.pillar.setStatic(true);
						self.lever2.block = false;
					}, 2)
				}
			}, 1);
		},
		
		flip: function(body, d){
			if(body.sprite.x < 195 || !stage.hitTest(levelsScripts[16].bridge, body.sprite)) return;
			// var force = body.m_mass*getDistance(body.sprite, d)/4.8;
			var force = body.m_mass*getDistance(body.sprite, d)/3.2;
			if (body.sprite.info == "energy_box") {
				body.ApplyImpulse(new b2Vec2(force*0.7, -force*1.3), body.GetCenterPosition());
			} else {
				//без setTimeout - кажется как-будто не перекладина Боба толкает, а он сам прыгает
				stage.setTimeout(function(){
					if (!stage.hitTest(levelsScripts[16].bridge, body.sprite)) return;
					body.ApplyImpulse(new b2Vec2(force*0.6, -force*1.4), body.GetCenterPosition());
				}, Math.floor(fps/10));
			}

				
		},
		ifCancelSpeed: function(){
			var self = levelsScripts[16];
			if ((stage.hitTest(field.bob, self.bridge) && self.lever2.block)){
				field.cancelSpeed = true;
			} else field.cancelSpeed = false;
		},

		ifBobFalls: function(){
			if (field.bob.y <190 || field.bob.inPit) return;
			if (field.bob.x > 272) {
				bobFalls();
			} else {
				field.bob.inPit = true;
				stage.setTimeout(function(){
					field.bob.changeState('BobGrowl');
					field.bob.BobGrowl.gotoAndPlay(0);
				}, Math.floor(fps/3));
			}; 
		},
		switchOnElectricity: function(){
			var self = levelsScripts[16];
			if (self.minus_plus.currentFrame == 1 || 
				!stage.hitTest(self.energy_box, self.minus_plus)) return;

			if (isSoundOn) mixer.play('snd_battery');
			if (isSoundOn) stage.setTimeout(function(){
				mixer.play('snd_door_left');
			}, Math.floor(fps/4));
			self.lantern.setStatic(false);
			self.small_tube.setStatic(false);
			self.barrier.setStatic(false);
			
			self.minus_plus.gotoAndStop(1)		
			self.lantern.gotoAndStop(0);
			
			var int = stage.setInterval(function(){
				var pos = self.barrier.box2dBody.GetCenterPosition();
				pos.y -= 1;

				self.barrier.box2dBody.SetOriginPosition(pos, 0);

				if (pos.y < 20) {
					stage.clearInterval(int);

					stage.setTimeout(function(){
						self.lantern.setStatic(true);
						self.small_tube.setStatic(true);
						self.barrier.setStatic(true);
					}, 1)
				}
			}, 1);
		},
		buttonAction: function(e){
			if(e.target.done) return;
			e.target.done = true;
			var bob = field.bob;
			var radiationAnim = levelsScripts[16].radiationAnim;

			if (isSoundOn) mixer.play('snd_button');
			if (isSoundOn) mixer.play('snd_gas_hiss');
			if (isSoundOn) mixer.play('snd_bob_die_radiation');
		
			bob[bob.state].opacity = 0;
			field.bob.forceSleep();	
			bob.onclick = null;
			var mc = new Sprite(bitmaps.Radiation1, 94, 66, 11);
			mc.x = bob.x-5;
			mc.y = bob.y-5;
			mc.animDelay = 2;
			mc.setZIndex(1);
			mc.onenterframe = function(e){
				if (e.target.currentFrame == 10) {
					e.target.destroy = true;

					var mc = new Sprite(bitmaps.Radiation2, 94, 66, 8);
					mc.x = e.target.x;
					mc.y = e.target.y;
					mc.animDelay = 2;
					mc.setZIndex(1);
					mc.onenterframe = function(e){
						if (e.target.currentFrame == 7 && !e.target.block) {
							e.target.stop();
							e.target.block = true;
							var mc = new Sprite(bitmaps.spirit, 75, 100);
							mc.x = e.target.x;
							mc.y = e.target.y;
							mc.setZIndex(1);
							stage.addChild(mc);

					        var tween = stage.createTween(mc, "y", e.target.y, -50, fps*1.5, Easing.linear.easeIn);
					        tween.play();
					        tween.onfinish = showGameOverScreen;
						}
					}
					stage.addChild(mc);
				}
			}
			stage.addChild(mc);
			radiationAnim.setStatic(false);
			radiationAnim.num = 1;
			radiationAnim.animDelay = 1;
			radiationAnim.onenterframe = function(e){
				var obj = e.target;
				if(gameState != STATE_GAME) obj.stop();
				if(obj.currentFrame == 5){
					if(obj.num<3) obj.num++;
					else obj.num = 1;
					obj.bitmap = bitmaps['radiationAnim' + obj.num];
					obj.gotoAndPlay(0);
				}
			}
			radiationAnim.play();
		},

		pretick: function() {
			var self = levelsScripts[16];
			self.ifCancelSpeed();
			self.ifBobFalls();
			self.switchOnElectricity();
		}
	},

/********************************************************* 
*							Level 18
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[17],
				bob = field.bob;
			
			addStateBobShocked();

			var platform = getObjectByInfo('Baraban');
			platform.animDelay = 2;
			
			var slider = getObjectByInfo('slider');
			processSlider.call(slider, platform);

			var current = getObjectByCustomInfo('currentDown');
			current.visible = false;
			self.current = current;
			self.bobIsShocked = false;

			var currentTrans = getObjectByCustomInfo('currentUp');
			currentTrans.visible = false;
			currentTrans.scaleX = 0.5;
			currentTrans.scaleY = 0.5;
			// self.currentTrans = currentTrans;
			var smoke = getObjectByInfo('smoke');
			for (var i = 0; i < smoke.length; i++) {
				smoke[i].visible = false;
				smoke[i].animDelay = i+2;
				smoke[i].scaleY = 0.7;
				smoke[i].scaleX = 0.7;
				smoke[i].play();
			};

			var lift = getObjectByInfo('lift_lvl18').box2dBody;
			lift.sprite.setStatic(true);
			lift.restrict = [231, 323];

			var btnLeft = getObjectByCustomInfo('btnLeft');
			var btnMiddle = getObjectByCustomInfo('btnMiddle');
			btnMiddle.gotoAndStop(1);
			var btnRight = getObjectByCustomInfo('btnRight');			

			var redLeft = getObjectByCustomInfo('redLeft');
			var redMiddle = getObjectByCustomInfo('redMiddle');
			var redRight = getObjectByCustomInfo('redRight');
			redLeft.gotoAndStop(1);
			redMiddle.gotoAndStop(1);
			redRight.gotoAndStop(1);

			var greenLeft = getObjectByCustomInfo('greenLeft');
			var greenMiddle = getObjectByCustomInfo('greenMiddle');
			var greenRight = getObjectByCustomInfo('greenRight');
			greenLeft.gotoAndStop(1);
			greenMiddle.gotoAndStop(1);
			greenRight.gotoAndStop(1);

			var lanternLeft = getObjectByCustomInfo('lanternLeft');
			var lanternMiddle = getObjectByCustomInfo('lanternMiddle');
			var lanternRight = getObjectByCustomInfo('lanternRight');
			lanternLeft.gotoAndStop(2);
			lanternMiddle.gotoAndStop(2);
			lanternRight.gotoAndStop(2);

			var bridgeLeft = getObjectByInfo('bridge1_lvl18').box2dBody;
			bridgeLeft.restrict = [121, 175];
			var bridgeRight = getObjectByInfo('bridge2_lvl18').box2dBody;
			bridgeRight.restrict = [207, 280];

			self.buttonAction.call(btnLeft, greenLeft, redLeft, 
				lanternLeft, self.moveBridge, bridgeLeft);
			self.buttonAction.call(btnMiddle, greenMiddle, redMiddle, 
				lanternMiddle, self.moveLift, lift, current);
			self.buttonAction.call(btnRight, greenRight, redRight, 
				lanternRight, self.moveBridge, bridgeRight);

			
			var trans = getObjectByInfo('trans1');
			addHint.call(trans, trans.x-29, trans.y+27);
			trans.onclick = function(e){
				var obj = e.target;
				
				var cp = new Vector(e.x+obj.x, e.y+obj.y);				
				var rect1 = new Rectangle(obj.x-27+SPRITE_OFFSET_X, obj.y+27, 36, 30, 0);
				// self.rect1 = rect1;
				if(!rect1.hitTestPoint(cp)) return;

				obj.play();
				obj.hint.removeHint();
				self.moveLift(lift, true);
				current.visible = true;
				current.play();
				
				greenMiddle.gotoAndStop(0);
				redLeft.gotoAndStop(0);
				redRight.gotoAndStop(0);
				lanternLeft.gotoAndStop(1);
				lanternMiddle.gotoAndStop(0);
				lanternRight.gotoAndStop(1);

				delete obj.onclick;
			};
			trans.num = 1;
			// trans.animDelay = 2;
			trans.onenterframe = function(e){
				var obj = e.target;
				if(obj.currentFrame == 7){
					if (obj.num == 3) {
						currentTrans.play();
						currentTrans.visible = true;
						smoke[1].visible = true;						
					};
					if(obj.num == 4){
						smoke[0].visible = true;
						obj.stop();
						return;
					}
					obj.num++;
					obj.bitmap = bitmaps['trans' + obj.num];
					obj.gotoAndPlay(0);
				}
			};
			self.trans = trans;
			
			//вначале - запрет клика и прячется
			var func = bob.onclick;
			delete bob.onclick;
			stage.setTimeout(function(){
				bob.changeState('hide');
				bob.hide.gotoAndPlay(0);
				bob.forceSleep();

				stage.setTimeout(function(){
					bob.onclick = func;

					//временно, пока нет крышки для трубы
					var wall = createObject({type: "invisible_wall_small", x: 36, y: 216, rotation: Math.PI/2});
					wall.visible = false;
				}, 3 * 12);
			}, 2*fps);

		},

		buttonAction: function(green, red, lantern, func, bridge, current){
			var btn = this,
				self = levelsScripts[17];


			btn.onclick = btnOnClick;

			function btnOnClick(){
				if (self.trans.num == 1) return;
				if (btn.currentFrame == 0) {

					btn.gotoAndStop(1);					
					green.gotoAndStop(0);
					red.gotoAndStop(1);
					lantern.gotoAndStop(0);
					func(bridge, true);
					if(current)	current.visible = true;
				} else {
					btn.gotoAndStop(0);
					green.gotoAndStop(1);
					red.gotoAndStop(0);
					lantern.gotoAndStop(1);
					func(bridge, false);
					if(current)	current.visible = false;
				}
				return false;
			}
		},
		moveLift: function(lift, down){
			stage.clearInterval(lift.int);

			lift.sprite.setStatic(false);
			if (isSoundOn) {
				if (down) mixer.play('snd_door_left');
				else mixer.play('snd_door_right');
			};
			lift.int = stage.setInterval(function(){
				var pos = lift.GetCenterPosition();
				if (down) pos.y += 2;
				else pos.y -= 2;
				
				lift.SetOriginPosition(pos, 0);

				if ((down && (pos.y > lift.restrict[1])) ||
					(!down && (pos.y < lift.restrict[0]))) {
					stage.setTimeout(function(){lift.sprite.setStatic(true);},2); 
					stage.clearInterval(lift.int);
				}
			}, 1);
		},		
		moveBridge: function(bridge, toLeft){
			stage.clearInterval(bridge.int);

			bridge.sprite.setStatic(false);
			if (isSoundOn) {
				if (toLeft) mixer.play('snd_door_left');
				else mixer.play('snd_door_right');
			};
			if (bridge.sprite.info == 'bridge2_lvl18') toLeft = !toLeft;
			bridge.int = stage.setInterval(function(){
				var pos = bridge.GetCenterPosition();
				if (toLeft) pos.x -= 2;
				else pos.x += 2;
				
				bridge.SetOriginPosition(pos, 0);

				if ((toLeft && (pos.x < bridge.restrict[0])) ||
					(!toLeft && (pos.x > bridge.restrict[1]))) {
					stage.setTimeout(function(){bridge.sprite.setStatic(true);},2); 
					stage.clearInterval(bridge.int);
				}
			}, 1);
		},
		ifBobShocked: function() {		
			var self = levelsScripts[17];
			if (!self.bobIsShocked && self.current.visible && stage.hitTest(self.current, field.bob)) {
				self.bobIsShocked = true;
				// self.btn.setStatic(true);
				if(isSoundOn) mixer.play('snd_bob_die_radiation', false);

				stage.setTimeout(function(){
					if(isSoundOn) mixer.play('snd_electro_shock', false);
					field.bob.forceSleep();
					field.bob.speed = 0;
	
					var pos = field.bob.box2dBody.GetCenterPosition();
					pos.y = pos.y - 20; //для смещения анимации
					field.bob.box2dBody.SetCenterPosition(pos, 0);		
					field.bob.box2dBody.Freeze();

					field.bob.changeState('shocked');
					field.bob.shocked.gotoAndPlay(0);
					field.bob.onclick = null;

				}, Math.floor(fps/4));
			}
		},

		ifBobFalls: function(){
			if(field.bob.y > 240) {
				bobFalls();
			}
		},
		pretick: function() {
			var self = levelsScripts[17];
			self.ifBobShocked();
			self.ifBobFalls();
		},
		
		posttick: function() {
			// var self = levelsScripts[17];
			// if(self.rect1)
			// {
			// 	console.log('rect!!!');
			// 	stage.drawLine(self.rect1.vertices[0].x, self.rect1.vertices[0].y, self.rect1.vertices[1].x, self.rect1.vertices[1].y, 1, '#f00', 1, false);
			//  	stage.drawLine(self.rect1.vertices[1].x, self.rect1.vertices[1].y, self.rect1.vertices[2].x, self.rect1.vertices[2].y, 1, '#f00', 1, false);
			//  	stage.drawLine(self.rect1.vertices[2].x, self.rect1.vertices[2].y, self.rect1.vertices[3].x, self.rect1.vertices[3].y, 1, '#f00', 1, false);
			//  	stage.drawLine(self.rect1.vertices[3].x, self.rect1.vertices[3].y, self.rect1.vertices[0].x, self.rect1.vertices[0].y, 1, '#f00', 1, false);
			// }
		}
	},

/********************************************************* 
*							Level 19
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[18];

			var foundation = getObjectByInfo('foundation');
			foundation.scaleY = -1;
			var buttonLeft = getObjectByCustomInfo('buttonLeft');
			attachMouseEvents.call(buttonLeft);
			addHint.call(buttonLeft, buttonLeft.x, buttonLeft.y);

			var buttonDown = getObjectByCustomInfo('buttonDown');
			attachMouseEvents.call(buttonDown);
			addHint.call(buttonDown, buttonDown.x, buttonDown.y);
			
			var buttonRight = getObjectByCustomInfo('buttonRight');
			attachMouseEvents.call(buttonRight);
			addHint.call(buttonRight, buttonRight.x, buttonRight.y);

			var springLeft = getObjectByCustomInfo('springLeft');
			var springDown = getObjectByCustomInfo('springDown');
			var springRight = getObjectByCustomInfo('springRight');
			springLeft.onenterframe = springOnEnterFrame;
			springDown.onenterframe = springOnEnterFrame;
			springRight.onenterframe = springOnEnterFrame;

			self.bridge = getObjectByInfo('bridge_lvl19');
			self.bridge.setStatic(true);
			self.circle = getObjectByInfo('circle_lvl19');
			self.circle.setStatic(true);

			var buttonBridge = getObjectByCustomInfo('buttonBridge');
			addHint.call(buttonBridge, buttonBridge.x, buttonBridge.y);
			attachMouseEvents.call(buttonBridge);
			buttonBridge.onclick = self.moveBridge;

			self.btn = getObjectByInfo('btn02');
			self.btn.setStatic(true);
			self.cover = getObjectByInfo('cover_lvl19');
			self.cover.setStatic(true);
			self.earth = getObjectByInfo('earth_lvl19');
			self.earth.setStatic(true);
			
			self.slip = getObjectByCustomInfo('slip');
			self.slip2 = getObjectByCustomInfo('slip2');
			self.buttonRedAction.call(buttonRight, springRight, new b2Vec2(-2500000, 0));
			self.buttonRedAction.call(buttonLeft, springLeft, new b2Vec2(/*4000000*/4500000, 0));
			self.buttonRedAction.call(buttonDown, springDown, new b2Vec2(0, -3000000));
			
			function springOnEnterFrame(e){
				if(e.target.currentFrame == 11) e.target.gotoAndStop(0);
			};
		},

		moveBridge: function(e){
			var bridge = levelsScripts[18].bridge,
				circle = levelsScripts[18].circle;
			if (isSoundOn) mixer.play('snd_button');
			bridge.setStatic(false);
			circle.setStatic(false);
			stage.setTimeout(function(){
				if (bridge.up) {
					bridge.up = false;
					bridge.box2dBody.SetOriginPosition(new b2Vec2(268, 123), -0.55);
				} else {
					bridge.up = true;
					bridge.box2dBody.SetOriginPosition(new b2Vec2(234.5, 104.5), -Math.PI/2);
				}
				stage.setTimeout(function(){
					circle.setStatic(true);
					bridge.setStatic(true);
				}, 2);
			}, 1);
		},

		ifBobPressBtn: function(){
			var self = levelsScripts[18];
			if (self.btn.currentFrame == 1 || !stage.hitTest(field.bob, self.btn)) return;
			if (isSoundOn) mixer.play('snd_door_left');
			self.cover.setStatic(false);
			self.earth.setStatic(false);
			self.btn.gotoAndStop(1);
			var pos = self.cover.box2dBody.GetCenterPosition();
			
			var int = stage.setInterval(function(){
				pos.y +=2;
				self.cover.box2dBody.SetOriginPosition(pos, 0);
				if (pos.y > 276) {
					self.cover.setStatic(true);
					self.earth.setStatic(true);
					stage.clearInterval(int);
				}
			}, 1);
		},

		
		buttonRedAction: function(spring, vec){
			var self = levelsScripts[18],
				but = this, 
				int;
			but.onclick = function(){
				if (spring.currentFrame !== 0) return;
				spring.play();
				if (isSoundOn) mixer.play('snd_spring');
				if (stage.hitTest(field.bob, spring)) {
					field.bob.inertia = true;
					stage.clearTimeout(field.bob.timeout);

					field.bob.timeout = stage.setTimeout(function(){
						field.bob.inertia = false;
					}, Math.floor(fps*0.8));

					stage.setTimeout(function(){
						field.bob.box2dBody.ApplyImpulse(vec, 
							field.bob.box2dBody.GetCenterPosition());
					}, 2);
				};
			}
		},

		ifCancelSpeed: function(){
			var self = levelsScripts[18],
				bob = field.bob;
			var c = bob.box2dBody.GetContactList();
			if ((bob.state == 'hide' && 
					(stage.hitTest(self.slip, bob) || stage.hitTest(self.slip2, bob))) ||
				bob.inertia || stage.hitTest(self.cover, bob) ||
				(c && c.other.sprite.info == 'bridge_lvl19' && c.other.m_rotation < -Math.PI/4)){
				field.cancelSpeed = true;
			} else field.cancelSpeed = false;
		},

		pretick: function() {
			var self = levelsScripts[18];
			self.ifBobPressBtn();
			self.ifCancelSpeed();
		}
	},

/********************************************************* 
*							Level 20
*********************************************************/	
	{
		init: function() {
			var self = levelsScripts[19];

			var boxRed = getObjectByInfo('boxRed');
			boxRed.box2dBody.GoToSleep();
			self.boxRed = boxRed;

			var boxGreen = getObjectByInfo('boxGreen');
			boxGreen.box2dBody.GoToSleep();
			self.boxGreen = boxGreen;

			var mechanism = getObjectByInfo('mechanism');

			// mechanism.animDelay = 2;
			mechanism.onenterframe = function(e){
				var obj = e.target;
				if (obj.currentFrame == 7) {
					obj.stop();
					obj.rewindAndStop(6);
					stage.setTimeout(function(){obj.setStatic(true);}, 6*obj.animDelay+1);
				};
			};
			self.mechanism = mechanism;
			mechanism.setStatic(true);

			var buttonMechanism = getObjectByCustomInfo('buttonMechanism');
			attachMouseEvents.call(buttonMechanism);
			addHint.call(buttonMechanism, buttonMechanism.x, buttonMechanism.y);
			buttonMechanism.onclick = self.buttonMechanismHandler;
			buttonMechanism.num = 0;


			var leftBaraban = getObjectByCustomInfo('leftBaraban');
			leftBaraban.animDelay = 2;
			self.leftBaraban = leftBaraban;
			
			var turnBtnLeft = getObjectByCustomInfo('turnBtnLeft');
			processSlider.call(turnBtnLeft, leftBaraban);

			var rightBaraban = getObjectByCustomInfo('rightBaraban');
			rightBaraban.animDelay = 2;
			self.rightBaraban = rightBaraban;
			
			var turnBtnRight = getObjectByCustomInfo('turnBtnRight');
			processSlider.call(turnBtnRight, rightBaraban);


			var lever = getObjectByInfo('Lever2');
			addHint.call(lever, lever.x, lever.y+3);
			lever.side = 'left';
			lever.onclick = self.lever19Action;
			self.lever = lever;

			self.lanternDown = getObjectByCustomInfo('lanternDown');
			self.lanternUp = getObjectByCustomInfo('lanternUp');
			self.lanternUp.gotoAndStop(1);
			self.lanternDown.setStatic(true);
			self.lanternDown.setStatic(true);

			self.bridgeUp = getObjectByInfo('bridgeUp_lvl20');
			self.bridgeUp.setStatic(true);
			self.bridgeDown = getObjectByInfo('bridgeDown_lvl20');
			self.bridgeDown.setStatic(true);
			self.bridgeDown.setZIndex(3);

			self.minus_plus_red = getObjectByInfo('minus_plus_red');
			self.minus_plus_red.setStatic(true);
			self.minus_plus_green = getObjectByInfo('minus_plus_green');
			self.minus_plus_green.setStatic(true);

			self.lift_cover1 = getObjectByInfo('lift_cover1');
			self.lift_cover1.setStatic(true);
			self.lift_cover2 = getObjectByInfo('lift_cover2');
			self.lift_cover2.setStatic(true);
			self.buttonLift = getObjectByCustomInfo('buttonLift');
			self.buttonLift.setStatic(true);
			
			self.lift = getObjectByInfo('lift_lvl20');
			self.lift.setStatic(true);
			self.lift.position = 'down';

			self.earthUp = getObjectByInfo('earthUp_lvl20');
			self.earthUp.setStatic(true);
			self.earthDown = getObjectByInfo('earthDown_lvl20');
			self.earthDown.setStatic(true);
			self.earthDown.setZIndex(4);

			addStateBobGrowl();

			var tube = getObjectByInfo('entrance');
			var int = stage.setInterval(function(){
				if(!stage.hitTest(tube, field.bob)){
					//временно, пока нет крышки для трубы
					var wall = createObject({type: "invisible_wall_small", x: 45, y: 166, rotation: Math.PI/2});
					wall.visible = false;
					stage.clearInterval(int);
				}
			}, fps);
		},

		lever19Action: function(e){
			var self = levelsScripts[19];
			var obj = e.target;
			if(self.block) return;
			self.block = true;
			self.lanternUp.setStatic(false);
			self.lanternDown.setStatic(false);
			if (isSoundOn) mixer.play('snd_lever_double');
			if (obj.side == 'left'){
				if (isSoundOn) mixer.play('snd_door_left');
				obj.side = 'right';
				obj.gotoAndPlay(0);
				obj.onenterframe = function(e) {if(e.target.currentFrame == 5) e.target.stop();}
				self.moveBridge(true, self.bridgeUp.box2dBody, 44, self.earthUp, self.lanternUp);
				self.moveBridge(false, self.bridgeDown.box2dBody, 66, self.earthDown, self.lanternDown);
				self.lanternUp.gotoAndStop(0);
				self.lanternDown.gotoAndStop(1);
			} else {
				if (isSoundOn) mixer.play('snd_door_right');
				obj.side = 'left';
				obj.rewindAndStop(5);
				self.moveBridge(false, self.bridgeUp.box2dBody, 44, self.earthUp, self.lanternUp);
				self.moveBridge(true, self.bridgeDown.box2dBody, 66, self.earthDown, self.lanternDown);
				self.lanternUp.gotoAndStop(1);
				self.lanternDown.gotoAndStop(0);
			}
		},

		moveBridge: function(toRight, bridge, distance, earth, lantern){
			bridge.sprite.setStatic(false);
			earth.setStatic(false);
			var oldPos = bridge.GetCenterPosition();
			var int1 = stage.setInterval(function(){
				var pos = bridge.GetCenterPosition();
				if (toRight) pos.x += 11;
				else pos.x -= 11;
				
				bridge.SetOriginPosition(pos, 0);

				if (Math.abs(oldPos.x - pos.x) > distance) {
					stage.setTimeout(function(){
						bridge.sprite.setStatic(true);
						earth.setStatic(true);
						lantern.setStatic(true);
						if(bridge.sprite.info == 'bridgeDown_lvl20') {
							levelsScripts[19].block = false;
						}
					},2); 
					stage.clearInterval(int1);
				}
			}, 1);
		},

		buttonMechanismHandler: function(e){
			var self = levelsScripts[19];
			if (self.mechanism.currentFrame !== 0) return;
			if (isSoundOn) mixer.play('snd_lever_double');
			self.mechanism.setStatic(false);
			self.mechanism.play();

			var but = e.target;
			if (but.num === 0){
				but.num++;
				self.boxGreen.box2dBody.WakeUp();
				var oldPos = self.boxRed.box2dBody.m_position.y;

				stage.setTimeout(function(){
					var int = stage.setInterval(function(){
						var pos = self.boxRed.box2dBody.GetCenterPosition();
						pos.y += 2;
						self.boxRed.box2dBody.SetOriginPosition(pos, 0);
						if ((pos.y - oldPos)>33) stage.clearInterval(int);
					},1);
				}, Math.floor(fps/4));

			} else {
				self.boxRed.box2dBody.WakeUp();
				but.onclick = null;
				but.hint.removeHint();
				but.gotoAndStop(0);
				but.setStatic(true);
			}
		},

		ifBobInPit: function(){
			if (!field.bob.inPit && 
				((field.bob.y > 210) || (field.bob.y <100 && field.bob.x < 70))) {
				field.bob.changeState('BobGrowl');
				field.bob.BobGrowl.gotoAndPlay(0);
				field.bob.inPit = true;
			};
		},
		turnOnElectricity: function(){
			var self = levelsScripts[19];
			if (self.minus_plus_red.currentFrame != 1 && 
				stage.hitTest(self.boxRed, self.minus_plus_red)){
				if (isSoundOn) mixer.play('snd_battery');
				self.minus_plus_red.setStatic(false);
				self.minus_plus_red.gotoAndStop(1);
			}
			if (self.minus_plus_green.currentFrame != 1 && 
				stage.hitTest(self.boxGreen, self.minus_plus_green)){
				if (isSoundOn) mixer.play('snd_battery');

				self.minus_plus_green.setStatic(false);
				self.minus_plus_green.gotoAndStop(1);
			}
			if(self.lift_cover2.position != 'down' && self.minus_plus_red.currentFrame == 1 && 
				self.minus_plus_green.currentFrame == 1){
				if (isSoundOn) mixer.play('snd_beep');
				self.lift_cover2.position = 'down';

				self.lift_cover2.setStatic(false);
				var int = stage.setInterval(function(){
					self.lift_cover2.y += 4;
					if (self.lift_cover2.y >= 330) {
						self.lift.setStatic(false);
						self.lift_cover1.setStatic(false);
						self.buttonLift.setStatic(false);
						stage.clearInterval(int);
						addHint.call(self.buttonLift, self.buttonLift.x, self.buttonLift.y);
						attachMouseEvents.call(self.buttonLift);
						self.buttonLift.onclick = self.buttonLiftAction;
					}
				},1);
			}
		},
		buttonLiftAction: function(){
			var self = levelsScripts[19],
				down;
			if (self.lift.position == 'down') {
				self.lift.position = 'up';
				self.moveLift(false);
			} else {
				self.lift.position = 'down';
				self.moveLift(true);
			}
		},
		moveLift: function(down){
			var self = levelsScripts[19];
			stage.clearInterval(self.lift.int);

			self.lift.int = stage.setInterval(function(){
				var pos = self.lift.box2dBody.GetCenterPosition();
				if (down) pos.y += 4;
				else pos.y -= 4;

				self.lift.box2dBody.SetOriginPosition(pos, 0);

				if (checkIfBobOnLift(self.lift)){
					var bob_pos = field.bob.box2dBody.GetCenterPosition();
					if (down) bob_pos.y += 4;
					else bob_pos.y -= 4;
					field.bob.box2dBody.SetCenterPosition(bob_pos, 0);
				}
				if (pos.y<235 || (self.lever.side == 'right' && 
									stage.hitTest(field.bob, self.bridgeUp)) ||
					pos.y > 300) stage.clearInterval(self.lift.int);
			},1);
		},

		pretick: function() {
			var self = levelsScripts[19];
			self.ifBobInPit();
			self.turnOnElectricity();
		},
	},

];