var NONE = 0;
var BOX = 1;
var CIRCLE = 2;
var POLY = 3;

var NORMAL = 0;
var BOB = 1;
var PLATFORM = 4;

function spritesSync(e, x, y) {
	var p = new Vector(-e.target.syncX, -e.target.syncY);
	p.rotate(-e.target.rotation);
	e.target.x += p.x; 
	e.target.y += p.y;
}

var stone_density = 6.0;	// Плотность
var stone_restitution = 0;	// Упругость
var stone_friction = 1;		// Трение

var platform_density = 300.0 * 10000;
var platform_restitution = -10;
var platform_friction = 0;

var obstacle_density = 10000.0;
var obstacle_restitution = 0;
var obstacle_friction = 0;

var BOB_density = 10;
var BOB_restitution = 0;
var BOB_friction = 0;

var objects = [

	{
        name: "Bob",
        image: "Bob.png",
        type: BOX,
        width: 48,
        height: 39,
        bodyWidth: 35,
        bodyHeight: 39,
        frames: 1,
        bodyType: CIRCLE,
        bodyPosCorrect: {x: 0, y: -1},
        remove: false,
        fixed: false,
        density: BOB_density,
        restitution: BOB_restitution,
        friction: BOB_friction		
	},	
	
/*****************************
*	Общие элементы
******************************/
	
	// Pipes
	{
        name: "tube1",
        image: "tube1.png",
        type: BOX,
        width: 74,
        height: 47,
        bodyWidth: 55,
        bodyHeight: 5,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 8, y: 20},
        remove: false,
        fixed: true,
		info: 'entrance',
        density: 0,
        restitution: 0,
        friction: 0		
	},	
	
	{
        name: "tube2",
        image: "tube2.png",
        type: BOX,
        width: 74,
        height: 47,
        bodyWidth: 55,
        bodyHeight: 5,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 24.5},
        remove: false,
        fixed: true,
		info: 'destination',
        density: 0,
        restitution: 0,
        friction: 0		
	},			
	
	{
        name: "BackTube",
        image: "BackTube.png",
        type: BOX,
        width: 4,
        height: 47,
        bodyWidth: 4,
        bodyHeight: 47,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 22},
        remove: false,
        fixed: true,
		info: 'BackTube',
        density: 0,
        restitution: 0,
        friction: 0		
	},			
	
	{
        name: "TubeCoverMc",
        image: "TubeCoverMc.png",
        type: BOX,
        width: 8,
        height: 47,
        bodyWidth: 8,
        bodyHeight: 46,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 25},
        remove: false,
        fixed: true,
		info: 'TubeCoverMc',
        density: 0,
        restitution: 0,
        friction: 0		
	},		

	// Floor	
    {
        name: "invisible_wall_small",
        image: "invisible_wall_small.png",
        type: PLATFORM,
        width: 50,
        height: 5,
        bodyWidth: 50,
        bodyHeight: 5,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'invisible',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },	   

	{
        name: "invisible_wall_big",
        image: "invisible_wall_big.png",
        type: PLATFORM,
        width: 150,
        height: 5,
        bodyWidth: 150,
        bodyHeight: 5,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'invisible',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },	 		
	
	{
        name: "Hint",
        image: "Hint.png",
        type: CIRCLE,
        width: 30,
        height: 30,
        bodyWidth: 30,
        bodyHeight: 30,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'hint',
        density: 0,
        restitution: 0,
        friction: 0
    },	
	
    {
        name: "slider",
        // image: 'slider_lv7.png',
        image: 'slider.png',
        type: BOX,
        width: 24,
        height: 23,
        bodyWidth: 24,
        bodyHeight: 23,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
        info: 'slider',
        density: 0,
        restitution: 0,
        friction: 0     
    },

    {
        name: "Baraban",
        // image: 'Baraban.png',
        image: 'Baraban.png',
        type: BOX,
        width: 75,
        height: 30,
        bodyWidth: 75,
        bodyHeight: 30,
        frames: 14,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: 3},
        remove: false,
        fixed: true,
        info: 'Baraban',
        density: 0,
        restitution: 0,
        friction: 0     
    },

    {
        name: "button_blue_left",
        image: 'button_blue_left.png',
        width: 28,
        height: 26,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_left',
    },
    
    {
        name: "button_blue_mid",
        image: 'button_blue_mid.png',
        width: 15,
        height: 31,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_mid',
    },
    
    {
        name: "button_blue_right",
        image: 'button_blue_right.png',
        width: 28,
        height: 26,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_right',
    },
    {
        name: "button_blue_down",
        image: 'button_blue_down.png',
        width: 26,
        height: 28,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_down',
    },
    {
        name: "button_blue_up",
        image: 'button_blue_up.png',
        width: 26,
        height: 28,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_up',
    },
    // Кнопка
    {
        name: "button_red",
        image: "button_red.png",
        width: 25,
        height: 25,
        frames: 3,
        bodyType: NONE,
        info: 'button_red',
    },
    {
        name: "button_blue",
        image: "button_blue.png",
        width: 24,
        height: 24,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue',
    },
    {
        name: "lever_cover_down",
        image: "lever_cover_down.png",
        width: 29,
        height: 6,
        frames: 1,
        bodyType: NONE,
        info: 'lever_cover_down',
    },
    {
        name: "lever_cover_up",
        image: "lever_cover_up.png",
        width: 29,
        height: 6,
        frames: 1,
        bodyType: NONE,
        info: 'lever_cover_up',
    },
    {
        name: "lever_cover_left",
        image: "lever_cover_left.png",
        width: 6,
        height: 29,
        frames: 1,
        bodyType: NONE,
        info: 'lever_cover_left',
    },
    {
        name: "lever_cover_right",
        image: "lever_cover_right.png",
        width: 6,
        height: 29,
        frames: 1,
        bodyType: NONE,
        info: 'lever_cover_right',
    },
    {
        name: "mechanism",
        image: 'mechanism.png',
        width: 116,
        height: 12,
        frames: 8,
        bodyType: NONE,
        info: 'mechanism',
    },
/***************************************************
*					Уровень 1
****************************************************/	

	// Obstacle lvl1
	{
        name: "DoorLevel01",
        // image: "DoorLevel01.png",
        image: "levels/01/DoorLevel01.png",
        type: PLATFORM,
        width: 18,
        height: 340,
        bodyWidth: 18,
        bodyHeight: 340,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'DoorLevel01',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },	 	
	
	{
        name: "yellow_element",
        // image: "yellow_element.png",
        image: "levels/01/yellow_element.png",
        type: PLATFORM,
        width: 23,
        height: 19,
        bodyWidth: 23,
        bodyHeight: 19,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'yellow_element',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },	 					
				
	// Рычаг
	{
        name: "Lever1",
        // image: "Lever1.png",
        image: "levels/01/Lever1.png",
        type: BOX,
        width: 40,
        height: 39,
        bodyWidth: 40,
        bodyHeight: 39,
        frames: 6,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'Lever1',
        density: 0,
        restitution: 0,
        friction: 0		
	},	


	// Пружина
	{
        name: "Spring",
        // image: "Spring.png",
        image: "levels/01/Spring.png",
        type: BOX,
		width: 94,
        height: 80,
        bodyWidth: 50,
        bodyHeight: 10,
        frames: 9,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'Spring',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction		
	},		

    {
        name: "Hint1_Level10001",
        image: 'levels/01/Hint1_Level10001.png',
        width: 125,
        height: 7,
        frames: 1,
        bodyType: NONE,
        info: 'Hint1_Level10001',
    },
    {
        name: "Hint2_Level10001",
        image: 'levels/01/Hint2_Level10001.png',
        width: 125,
        height: 34,
        frames: 1,
        bodyType: NONE,
        info: 'Hint2_Level10001',
    },
/***************************************************
*					Уровень 2
****************************************************/	

    // Рычаг
    {
        name: "Lever2",
        image: "levels/02/Lever2.png",
        type: BOX,
        width: 40,
        height: 39,
        bodyWidth: 40,
        bodyHeight: 39,
        frames: 6,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
        info: 'Lever2',
        density: 0,
        restitution: 0,
        friction: 0     
    },                  
    // Перекладина
    {
        name: "crossbar",
        image: "levels/02/perekladina.png",
        // type: BOX,
        width: 95,
        height: 13,
        bodyWidth: 95,
        bodyHeight: 10,
        frames: 1,
        bodyType: BOX,
        // bodyPosCorrect: {x: -10, y: 0},
        remove: false,
        fixed: true,
        info: 'crossbar',
        density: 0.1,
        restitution: 0,
        friction: 0     
    },  

    //конвейер
    {       
        name: "conveyor",
        image: 'levels/02/conveyor.png',
        // type: PLATFORM,
        width: 364,
        height: 20,
        bodyWidth: 354,
        bodyHeight: 14,
        frames: 13,
        bodyType: BOX,
        // bodyPosCorrect: {x: 0, y: -3},
        remove: false,
        fixed: true,
        info: 'conveyor',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction      
    },
    
    {       
        name: "electric_detail",
        image: 'levels/02/electric_detail.png',
        // type: PLATFORM,
        width: 32,
        height: 36,
        bodyHeight:32,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'electric_detail',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },
    
    {       
        name: "electricity_10",
        image: 'levels/02/electricity_10.png',
        width: 44,
        height: 42,
        frames: 10,
        bodyType: NONE,
        info: 'electricity_10'
    },
    {       
        name: "btn02",
        image: 'levels/02/btn.png',
        width: 37,
        height: 12,
        frames: 2,
        bodyType: NONE,
        info: 'btn02'
    },

    {
        name: "earth_lvl2",
        image: 'levels/02/earth_lvl2.png',
        width: 53,
        height: 25,
        frames: 1,
        bodyType: NONE,
        info: 'earth_lvl2',
    },
    {
        name: "ArrowAnim_yellow0001",
        image: 'levels/02/ArrowAnim_yellow0001.png',
        width: 29,
        height: 16,
        frames: 1,
        bodyType: NONE,
        info: 'ArrowAnim_yellow0001',
    },
    {
        name: "ArrowAnim0001",
        image: 'levels/02/ArrowAnim0001.png',
        width: 20,
        height: 33,
        frames: 1,
        bodyType: NONE,
        info: 'ArrowAnim0001',
    },
    {
        name: "HintClickBob_Level20001",
        image: 'levels/02/HintClickBob_Level20001.png',
        width: 45,
        height: 8,
        frames: 1,
        bodyType: NONE,
        info: 'HintClickBob_Level20001',
    },
    {
        name: "HintMc1_Level20001",
        image: 'levels/02/HintMc1_Level20001.png',
        width: 130,
        height: 16,
        frames: 1,
        bodyType: NONE,
        info: 'HintMc1_Level20001',
    },
    {
        name: "HintMc2_Level20001",
        image: 'levels/02/HintMc2_Level20001.png',
        width: 80,
        height: 17,
        frames: 1,
        bodyType: NONE,
        info: 'HintMc2_Level20001',
    },
    {
        name: "HintMc3_Level20001",
        image: 'levels/02/HintMc3_Level20001.png',
        width: 100,
        height: 38,
        frames: 1,
        bodyType: NONE,
        info: 'HintMc3_Level20001',
    },
/***************************************************
*                   Уровень 3
****************************************************/   
    {
        name: "button_blue_mid_lvl3",
        image: 'levels/03/button-blue-mid-lvl3.png',
        width: 31,
        height: 15,
        frames: 1,
        bodyType: NONE,
        info: 'button_blue_mid_lvl3',
    },
    {
        name: "Lift_lv3",
        image: 'levels/03/Lift_lv3.png',
        type: BOX,
        width: 111,
        height: 24,
        bodyWidth: 100,
        bodyHeight: 20,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'Lift_lv3',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    }, 
    {
        name: "Hint1_Level30001",
        image: 'levels/03/Hint1_Level30001.png',
        width: 114,
        height: 22,
        frames: 1,
        bodyType: NONE,
        info: 'Hint1_Level30001',
    },
    {
        name: "HoldText0001",
        image: 'levels/03/HoldText0001.png',
        width: 37,
        height: 14,
        frames: 1,
        bodyType: NONE,
        info: 'HoldText0001',
    },

/***************************************************
*                   Уровень 4
****************************************************/   

    {
        name: "Latch_lvl4",
        image: 'levels/04/Latch_lvl4.png',
        width: 56,
        height: 19,
        frames: 1,
        bodyType: POLY,
        info: 'Latch_lvl4',
        fixed: false,
        density: 10,
        restitution: 0.1,
        friction: 1,
        points: [
            [[-28, -9], [28, -9], [28, -3], [-28, -3]],
            [[-28, -3], [-7, -3], [-7, 9], [-28, 9]]
        ]
    },

    {
        name: "wooden_cross_lvl4",
        image: 'levels/04/wooden_cross_lvl4.png',
        width: 209,
        height: 210,
        frames: 1,
        bodyType: POLY,
        info: 'wooden_cross_lvl4',
        fixed: false,
        density: 4,
        restitution: 0.1,
        friction: 0.6,
        points: [
            [[-104, -5], [104, -5], [104, 5], [-104, 5]],
            [[-3, -104], [7, -104], [7, 104], [-3, 104]]
        ]
    },

    {
        name: "stone_lvl4",
        image: 'levels/04/stone_lvl4.png',
        width: 38,
        height: 38,
        frames: 1,
        bodyType: CIRCLE,
        info: 'stone_lvl4',
        fixed: false,
        density: 5.5,
        restitution: 0.1,
        friction: 5
    },

    {
        name: "Lever4",
        image: "levels/04/Lever4.png",
        type: BOX,
        width: 40,
        height: 41,
        frames: 6,
        bodyType: NONE,
        fixed: true,
        info: 'Lever4',
    },  

/***************************************************
*                   Уровень 5
****************************************************/   

    {
        name: "Bridge_lvl5",
        image: 'levels/05/Bridge_lvl5.png',
        type: BOX,
        width: 134,
        height: 19,
        bodyWidth: 130,
        bodyHeight: 15,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'Bridge_lvl5',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    },
    {
        name: "wagon_whel_lvl5",
        image: 'levels/05/wagon_whel_lvl5.png',
        type: BOX,
        width: 19,
        height: 19,
        frames: 1,
        bodyType: CIRCLE,
        fixed: false,
        info: 'wagon_whel_lvl5',
        density: 10,
        restitution: 0.1,
        friction: 0.6     
    },
    {
        name: "wagon_lvl5",
        image: 'levels/05/wagon_lvl5.png',
        type: BOX,
        width: 59,
        height: 46,
        frames: 1,
        bodyType: POLY,
        fixed: false,
        info: 'wagon_lvl5',
        density: 10,
        restitution: 0.1,
        friction: 0.6,
        points: [
            [[-29, -23], [-25, -23], [-13, -6], [-21, 6]],
            [[25, -23], [29, -23], [21, 6], [13, -6]],
            [[-21, -8], [21, -8], [21, 9.5], [-21, 9.5]]
        ]
    },
    // {
    //     name: "up_cover_lvl5",
    //     image: "levels/05/up_cover_lvl5.png",
    //     type: BOX,
    //     width: 29,
    //     height: 6,
    //     frames: 1,
    //     bodyType: NONE,
    //     // fixed: true,
    //     info: 'up_cover_lvl5',
    // },

    {
        name: "wood_on_rope_lvl5",
        image: "levels/05/wood_on_rope_lvl5.png",
        type: PLATFORM,
        width: 23,
        height: 204,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'wood_on_rope_lvl5',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
        // Pipes
    {
        name: "tube5",
        image: "tube1.png",
        width: 74,
        height: 47,
        frames: 1,
        bodyType: NONE,
        info: 'tube5',
    },  
    {
        name: "peregorodka_lvl5",
        image: "levels/05/peregorodka_lvl5.png",
        width: 15,
        height: 31,
        frames: 1,
        bodyType: NONE,
        info: 'peregorodka_lvl5',
    },  
/***************************************************
*                   Уровень 6
****************************************************/   
    {
        name: "btn_lvl6",
        image: "levels/06/btn_lvl6.png",
        width: 42,
        height: 14,
        frames: 4,
        bodyType: NONE,
        info: 'btn_lvl6',
    },
    {
        name: "cable_lvl6",
        image: "levels/06/cable_lvl6.png",
        width: 19,
        height: 136,
        frames: 1,
        bodyType: NONE,
        info: 'cable_lvl6',
    },
    {
        name: "earth_lvl6",
        image: "levels/06/earth_lvl6.png",
        width: 210,
        height: 108,
        frames: 1,
        bodyType: NONE,
        info: 'earth_lvl6',
    },
    {
        name: "spring",
        image: "levels/06/spring.png",
        width: 46,
        height: 38,
        frames: 12,
        bodyType: NONE,
        info: 'spring',
    },
    {
        name: "ball_falls_lvl6",
        image: "levels/06/ball_falls_lvl6.png",
        width: 90,
        height: 36,
        frames: 1,
        bodyType: NONE,
        info: 'ball_falls_lvl6',
    },
    {
        name: "tube_lvl6",
        image: "levels/06/tube_lvl6.png",
        type: PLATFORM,
        width: 15,
        height: 86,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'tube_lvl6',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "brig",
        image: "levels/06/brig.png",
        type: PLATFORM,
        width: 210,
        height: 25,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'brig',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "stone_lvl6",
        image: 'levels/06/stone_lvl6.png',
        width: 26,
        height: 26,
        frames: 1,
        bodyType: CIRCLE,
        info: 'stone_lvl6',
        fixed: false,
        density: 0.6,
        restitution: 0,
        friction: 0
    },
    
/***************************************************
*                   Уровень 7
****************************************************/   
				
	{
        name: "entrance_lvl7",
        image: 'invisible_wall_small.png',
        type: BOX,
        width: 66,
        height: 41,
        bodyWidth: 50,
        bodyHeight: 5,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 5, y: 5},
        remove: false,
        fixed: true,
		info: 'invisible_entrance',
        density: 0,
        restitution: 0,
        friction: 0		
	},

	{
        name: "fence",
        // image: 'fence.png',
        image: 'levels/07/fence.png',
        type: BOX,
        width: 88,
        height: 52,
        bodyWidth: 88,
        bodyHeight: 52,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'fence',
        density: 0,
        restitution: 0,
        friction: 0		
	},		
	
	{
        name: "Girlfriend",
        // image: 'Girlfriend.png',
        image: 'levels/07/Girlfriend.png',
        type: BOX,
        width: 52,
        height: 43.5,
        bodyWidth: 30,
        bodyHeight: 30,
        frames: 14,
        bodyType: CIRCLE,
        bodyPosCorrect: {x: 0, y: 3},
        remove: false,
        fixed: false,
		info: 'Girlfriend',
        density: 0,
        restitution: 0,
        friction: 0		
	},

	{
        name: "ice",
        // image: 'ice.png',
        image: 'levels/07/ice.png',
        type: BOX,
        width: 79,
        height: 66,
        bodyWidth: 24,
        bodyHeight: 55,
        frames: 10,
        bodyType: BOX,
        bodyPosCorrect: {x: 2, y: -5},
        remove: false,
        fixed: false,
		info: 'ice',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction		
	},

	{
        name: "Stove",
        // image: 'Stove.png',
        image: 'levels/07/Stove.png',
        type: BOX,
        width: 96,
        height: 144/3,
        bodyWidth: 96,
        bodyHeight: 143/3,
        frames: 3,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'Stove',
        density: 0,
        restitution: 0,
        friction: 0		
	},	
	
	{
        name: "oven_lever",
        // image: 'oven_lever.png',
        image: 'levels/07/oven_lever.png',
        type: BOX,
        width: 42,
        height: 38,
        bodyWidth: 42,
        bodyHeight: 38,
        frames: 1,
        bodyType: NONE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'oven_lever',
        density: 0,
        restitution: 0,
        friction: 0		
	},	
	

	{
        name: "Lift_lv7",
        // image: "Lift_lv7.png",
        image: "levels/07/Lift_lv7.png",
        type: BOX,
		width: 67,
        height: 30,
        bodyWidth: 67,
        bodyHeight: 12,
        frames: 1,
        bodyType: BOX,
        bodyPosCorrect: {x: 0, y: -5},
        remove: false,
        fixed: true,
		info: 'Lift_lv7',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction		
	},	
	
	{
        name: "Btn_lv7",
        // image: "Btn_lv7.png",
        image: "levels/07/Btn_lv7.png",
        type: BOX,
		width: 25,
        height: 24,
        bodyWidth: 25,
        bodyHeight: 24,
        frames: 2,
        bodyType: CIRCLE,
        bodyPosCorrect: {x: 0, y: 0},
        remove: false,
        fixed: true,
		info: 'Btn_lv7',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction		
	},

/***************************************************
*                   Уровень 8
****************************************************/   

    {
        name: "latch_lvl8",
        image: 'levels/08/latch_lvl8.png',
        width: 96,
        height: 26,
        frames: 1,
        bodyType: POLY,
        info: 'latch_lvl8',
        fixed: true,
        density: 10,
        restitution: 0.1,
        friction: 1,
        points: [
            [[-47, -12], [47, -12], [47, 0], [-47, 0]],
            [[-47, 0], [-29, 0], [-29, 12], [-47, 12]]
        ]
    },
    {
        name: "before_bridge_lvl8",
        image: "levels/08/before_bridge_lvl8.png",
        width: 112,
        height: 33,
        frames: 1,
        bodyType: NONE,
        info: 'before_bridge_lvl8',
    },
    {
        name: "bridge_lvl8",
        image: "levels/08/bridge_lvl8.png",
        type: PLATFORM,
        width: 61,
        height: 22,
        bodyHeight: 18,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl8',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "spring_up",
        image: "levels/08/spring_up.png",
        width: 64,
        height: 60,
        frames: 12,
        bodyType: NONE,
        info: 'spring_up',
    },
	
/***************************************************
*                   Уровень 9
****************************************************/   

    {
        name: "button_lvl9",
        image: "levels/09/button_lvl9.png",
        width: 28,
        height: 28,
        frames: 3,
        bodyType: NONE,
        info: 'button_lvl9',
    },
    {
        name: "bridge_lvl9",
        image: "levels/09/bridge_lvl9.png",
        type: PLATFORM,
        width: 39,
        height: 17,
        bodyHeight: 14,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl9',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "earth1_lvl9",
        image: "levels/09/earth1_lvl9.png",
        width: 57,
        height: 48,
        bodyWidth: 51,
        frames: 1,
        bodyType: BOX,
        info: 'earth_lvl9',
        fixed: true,
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },
    {
        name: "earth2_lvl9",
        image: "levels/09/earth2_lvl9.png",
        width: 57,
        height: 40,
        bodyWidth: 51,
        frames: 1,
        bodyType: BOX,
        info: 'earth_lvl9',
        fixed: true,
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },
    {
        name: "earth3_lvl9",
        image: "levels/09/earth3_lvl9.png",
        width: 56,
        height: 46,
        bodyWidth: 50,
        frames: 1,
        bodyType: BOX,
        info: 'earth_lvl9',
        fixed: true,
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },
    {
        name: "earth4_lvl9",
        image: "levels/09/earth4_lvl9.png",
        width: 64,
        height: 75,
        bodyWidth: 58,
        bodyHeight: 71,
        frames: 1,
        bodyType: BOX,
        info: 'earth_lvl9',
        fixed: true,
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction
    },
    {
        name: "lamp",
        image: "levels/09/lamp.png",
        width: 76,
        height: 58,
        frames: 1,
        bodyType: NONE,
        info: 'lamp',
    },
    {
        name: "wire",
        image: "levels/09/wire.png",
        width: 376,
        height: 166,
        frames: 1,
        bodyType: NONE,
        info: 'wire',
    },
/***************************************************
*                   Уровень 10
****************************************************/   

    {
        name: "energy_box",
        image: 'levels/10/energy_box.png',
        type: BOX,
        width: 29,
        height: 27,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'energy_box',
        density: 5,
        restitution: 0,
        friction: 0.6     
    },
    {
        name: "lantern",
        image: "levels/10/lantern.png",
        width: 18,
        height: 14,
        frames: 2,
        bodyType: NONE,
        info: 'lantern',
    },
    {
        name: "pillar_lvl10",
        image: "levels/10/pillar_lvl10.png",
        width: 18,
        height: 54,
        frames: 1,
        bodyType: NONE,
        info: 'pillar_lvl10',
    },
    {
        name: "small_tube_lvl10",
        image: "levels/10/small_tube_lvl10.png",
        width: 18,
        height: 17,
        frames: 1,
        bodyType: NONE,
        info: 'small_tube_lvl10',
    },
    {
        name: "up_cover_lvl10",
        image: "levels/10/up_cover_lvl10.png",
        width: 2,
        height: 18,
        frames: 1,
        bodyType: NONE,
        info: 'up_cover_lvl10',
    },
    {
        name: "radiationAnim1",
        image: "levels/10/radiationAnim1.png",
        width: 172,
        height: 100,
        frames: 6,
        bodyType: NONE,
        info: 'radiationAnim1',
    },
    {
        name: "bridge_lvl10",
        image: 'levels/10/bridge_lvl10.png',
        width: 76,
        height: 12,
        bodyHeight: 10,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl10',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction 
    },
    {
        name: "barrier_lvl10",
        image: "levels/10/barrier_lvl10.png",
        type: PLATFORM,
        width: 16,
        height: 167,
        bodyWidth: 12,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'barrier_lvl10',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "minus_plus",
        image: "levels/10/minus_plus.png",
        width: 41,
        height: 22,
        frames: 2,
        bodyType: NONE,
        info: 'minus_plus',
    },

/***************************************************
*                   Уровень 11
****************************************************/   

    {
        name: "block_lvl11",
        image: 'levels/11/block_lvl11.png',
        width: 25,
        height: 108,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'block_lvl11',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    },
    {
        name: "bridge_lvl11",
        image: "levels/11/bridge_lvl11.png",
        width: 70,
        height: 17,
        frames: 1,
        bodyType: BOX,
        info: 'bridge_lvl11',
        fixed: true,
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "button_lvl11",
        image: "levels/11/button_lvl11.png",
        width: 30,
        height: 30,
        frames: 2,
        bodyType: NONE,
        info: 'button_lvl11',
    },
    {
        name: "fire_lvl11",
        image: "levels/11/fire_lvl11.png",
        width: 12,
        height: 16,
        frames: 11,
        bodyType: NONE,
        info: 'fire_lvl11',
    },
    {
        name: "fire_small",
        image: "levels/11/fire_small.png",
        width: 52,
        height: 32,
        frames: 24,
        bodyType: NONE,
        info: 'fire_small',
    },
    {
        name: "lava",
        image: "levels/11/lava.png",
        width: 6,
        height: 9,
        frames: 1,
        bodyType: CIRCLE,
        fixed: false,
        info: 'lava',
        density: 10,
        restitution: 0.1,
        friction: 0.5
    },
    {
        name: "pliers_down",
        image: "levels/11/pliers_down.png",
        width: 60,
        height: 36,
        frames: 6,
        bodyType: NONE,
        info: 'pliers_down',
    },
    {
        name: "rope_lvl11",
        image: "levels/11/rope_lvl11.png",
        width: 12,
        height: 232,
        frames: 1,
        bodyType: NONE,
        info: 'rope_lvl11',
    },
    {
        name: "smoke1_lvl11",
        image: "levels/11/smoke1_lvl11.png",
        width: 50,
        height: 110,
        frames: 9,
        bodyType: NONE,
        info: 'smoke',
    },
    {
        name: "smoke2_lvl11",
        image: "levels/11/smoke2_lvl11.png",
        width: 50,
        height: 110,
        frames: 9,
        bodyType: NONE,
        info: 'smoke',
    },
    {
        name: "tube_lvl11",
        image: "levels/11/tube_lvl11.png",
        width: 25,
        height: 17,
        frames: 6,
        bodyType: NONE,
        info: 'tube_lvl11',
    },

/***************************************************
*                   Уровень 12
****************************************************/
    {
        name: "circle_lvl12",
        image: "levels/12/circle_lvl12.png",
        width: 16,
        height: 16,
        frames: 1,
        bodyType: NONE,
        info: 'circle_lvl12',
    },
    {
        name: "button_lvl12",
        image: "levels/12/button_lvl12.png",
        width: 34,
        height: 30,
        frames: 3,
        bodyType: NONE,
        info: 'button_lvl12',
    },
    {
        name: "bridge_lvl12",
        image: "levels/12/bridge_lvl12.png",
        width: 134,
        height: 16,
        bodyHeight: 12,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'bridge_lvl12',
        density: 10,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "prop_lvl12",
        image: "levels/12/prop_lvl12.png",
        width: 37,
        height: 73,
        bodyWidth: 22,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'prop_lvl12',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },

/***************************************************
*                   Уровень 13
****************************************************/   

    {
        name: "bridge_lvl13",
        image: "levels/13/bridge_lvl13.png",
        width: 105,
        height: 15,
        bodyWidth: 101,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl13',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "button_lvl13",
        image: "levels/13/button_lvl13.png",
        width: 26,
        height: 26,
        frames: 2,
        bodyType: NONE,
        info: 'button_lvl13',
    },
    {
        name: "press",
        image: "levels/13/press.png",
        width: 128,
        height: 55,
        bodyHeight: 25,
        bodyPosCorrect: {x: 0, y: 15},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'press',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "sticks",
        image: "levels/13/sticks.png",
        width: 109,
        height: 45,
        frames: 1,
        bodyType: NONE,
        info: 'sticks',
    },
    {
        name: "rope",
        image: "levels/13/rope.png",
        width: 13,
        height: 64,
        frames: 1,
        bodyType: NONE,
        info: 'rope',
    },
    {
        name: "rope1",
        image: "levels/13/rope1.png",
        width: 6,
        height: 13,
        frames: 1,
        bodyType: NONE,
        info: 'rope1',
    },
    {
        name: "rope2",
        image: "levels/13/rope2.png",
        width: 10,
        height: 18,
        frames: 1,
        bodyType: NONE,
        info: 'rope2',
    },
    {
        name: "rope3",
        image: "levels/13/rope3.png",
        width: 13,
        height: 19,
        frames: 1,
        bodyType: NONE,
        info: 'rope3',
    },
    {
        name: "rope4",
        image: "levels/13/rope4.png",
        width: 9,
        height: 14,
        frames: 1,
        bodyType: NONE,
        info: 'rope4',
    },
    {
        name: "rope5",
        image: "levels/13/rope5.png",
        width: 8,
        height: 12,
        frames: 1,
        bodyType: NONE,
        info: 'rope5',
    },
    {
        name: "rope6",
        image: "levels/13/rope6.png",
        width: 7,
        height: 13,
        frames: 1,
        bodyType: NONE,
        info: 'rope6',
    },
    {
        name: "prop_lvl13",
        image: "levels/13/prop_lvl13.png",
        width: 19,
        height: 84,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'prop_lvl13',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },

/***************************************************
*                   Уровень 14
****************************************************/
    {
        name: "circle_exit",
        image: "levels/14/circle_exit.png",
        width: 46,
        height: 66,
        frames: 1,
        bodyType: NONE,
        info: 'circle_exit',
    },
    {
        name: "circle_lvl14",
        image: "levels/14/circle_lvl14.png",
        width: 19,
        height: 19,
        frames: 1,
        bodyType: NONE,
        info: 'circle_lvl14',
    },
    {
        name: "pc1",
        image: "levels/14/pc1.png",
        width: 28,
        height: 114,
        frames: 1,
        bodyType: NONE,
        info: 'pc1',
    },
    {
        name: "pc2",
        image: "levels/14/pc2.png",
        width: 29,
        height: 67,
        frames: 1,
        bodyType: NONE,
        info: 'pc2',
    },
    {
        name: "pc3",
        image: "levels/14/pc3.png",
        width: 49,
        height: 115,
        frames: 1,
        bodyType: NONE,
        info: 'pc3',
    },
    {
        name: "pc4",
        image: "levels/14/pc4.png",
        width: 36,
        height: 65,
        frames: 1,
        bodyType: NONE,
        info: 'pc4',
    },
    {
        name: "carriage1_lvl14",
        image: "levels/14/carriage1_lvl14.png",
        type: PLATFORM,
        width: 64,
        height: 178,
        bodyWidth: 60,
        bodyHeight: 10,
        bodyPosCorrect: {x: 0, y: 78},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'carriage1_lvl14',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "carriage2_lvl14",
        image: "levels/14/carriage2_lvl14.png",
        type: PLATFORM,
        width: 64,
        height: 209,
        bodyWidth: 60,
        bodyHeight: 10,
        bodyPosCorrect: {x: 0, y: 93.5},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'carriage2_lvl14',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "carriage3_lvl14",
        image: "levels/14/carriage3_lvl14.png",
        type: PLATFORM,
        width: 65,
        height: 191,
        bodyWidth: 60,
        bodyHeight: 10,
        bodyPosCorrect: {x: 0, y: 84.5},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'carriage3_lvl14',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "carriage4_lvl14",
        image: "levels/14/carriage4_lvl14.png",
        type: PLATFORM,
        width: 63,
        height: 232,
        bodyWidth: 60,
        bodyHeight: 10,
        bodyPosCorrect: {x: 0, y: 104},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'carriage4_lvl14',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },

/***************************************************
*                   Уровень 15
****************************************************/   

    {
        name: "box_lvl15",
        image: "levels/15/box_lvl15.png",
        type: PLATFORM,
        width: 44,
        height: 43,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'box_lvl15',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "bridge_lvl15",
        image: "levels/15/bridge_lvl15.png",
        type: PLATFORM,
        width: 320,
        height: 17,
        bodyWidth: 86,
        bodyPosCorrect: {x: -117, y: 0},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl15',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "circle_lvl15",
        image: "levels/15/circle_lvl15.png",
        // width: 120,
        // height: 25,
        width: 157.5,
        height: 31,
        frames: 1,
        bodyType: NONE,
        info: 'circle_lvl15',
    },
    {
        name: "earth1_lvl15",
        image: "levels/15/earth1_lvl15.png",
        width: 51,
        height: 66,
        frames: 1,
        bodyType: NONE,
        info: 'earth1_lvl15',
    },
    {
        name: "earth2_lvl15",
        image: "levels/15/earth2_lvl15.png",
        width: 51,
        height: 66,
        frames: 1,
        bodyType: NONE,
        info: 'earth2_lvl15',
    },
    {
        name: "prop_lvl15",
        image: "levels/15/prop_lvl15.png",
        width: 30,
        height: 131,
        frames: 1,
        bodyType: NONE,
        info: 'prop_lvl15',
    },
    {
        name: "mechanism_lvl15",
        image: 'levels/15/mechanism_lvl15.png',
        width: 132,
        height: 14,
        frames: 9,
        bodyType: NONE,
        info: 'mechanism_lvl15',
    },

/***************************************************
*                   Уровень 16
****************************************************/   

    {
        name: "latch_lvl16",
        image: "levels/16/latch_lvl16.png",
        type: PLATFORM,
        width: 73,
        height: 26,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'latch_lvl16',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "bridge_lvl16",
        image: "levels/16/bridge_lvl16.png",
        type: PLATFORM,
        width: 96,
        height: 15,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl16',
        density: obstacle_density,
        restitution: 0.3,
        friction: 0.1
    },
    {
        name: "pump_down",
        image: 'levels/16/pump_down.png',
        width: 78,
        height: 54,
        frames: 1,
        bodyType: NONE,
        info: 'pump_down',
    },
    {
        name: "pump_up",
        image: 'levels/16/pump_up.png',
        width: 45,
        height: 60,
        frames: 1,
        bodyType: NONE,
        info: 'pump_up',
    },
    {
        name: "circle_lvl16",
        image: 'levels/16/circle_lvl16.png',
        width: 14,
        height: 13,
        frames: 1,
        bodyType: NONE,
        info: 'circle_lvl16',
    },
    {
        name: "ball1",
        image: "levels/16/ball1.png",
        // width: 64,
        width: 68,
        // height: 128,
        height: 142,
        bodyWidth: 42,
        bodyHeight: 42,
        bodyPosCorrect: {x: 0, y: -37},
        frames: 7,
        bodyType: CIRCLE,
        fixed: false,
        info: 'ball',
        density: obstacle_density,
        restitution: 0.3,
        friction: 0.1      
    },
    {
        name: "baloon_1",
        image: "levels/16/baloon_1.png",
        width: 68,
        height: 142,
        bodyWidth: 42,
        bodyHeight: 42,
        bodyPosCorrect: {x: 0, y: -43},
        frames: 7,
        bodyType: CIRCLE,
        fixed: true,
        info: 'baloon_1',
        density: obstacle_density,
        restitution: 0.3,
        friction: 0.1      
    },  
    {
        name: "basket_invisible",
        image: "levels/16/basket_invisible.png",
        width: 64,
        height: 17,
        bodyHeight: 14,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'basket_invisible',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    }, 

/***************************************************
*                   Уровень 17
****************************************************/   

    {
        name: "bridge_lvl17",
        image: "levels/17/bridge_lvl17.png",
        width: 227,
        height: 15,
        bodyWidth: 44,
        bodyPosCorrect: {x: -91, y: 0},
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl17',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "btn_Fire",
        image: 'levels/17/btn_Fire.png',
        width: 30,
        height: 134,
        frames: 2,
        bodyType: NONE,
        info: 'btn_Fire',
    },
    {
        name: "FireTimeAnim",
        image: 'levels/17/FireTimeAnim.png',
        width: 16,
        height: 18,
        frames: 4,
        bodyType: NONE,
        info: 'FireTimeAnim',
    },
    {
        name: "fire_lvl17",
        image: 'levels/17/fire_lvl17.png',
        width: 30,
        height: 122,
        frames: 21,
        rows: 7,
        columns: 3,
        bodyType: NONE,
        info: 'fire_lvl17',
    },
    {
        name: "earth_lvl17",
        image: 'levels/17/earth_lvl17.png',
        width: 224,
        height: 24,
        frames: 1,
        bodyType: NONE,
        info: 'earth_lvl17',
    },
 

/***************************************************
*                   Уровень 18
****************************************************/   

    {
        name: "bridge1_lvl18",
        image: "levels/18/bridge1_lvl18.png",
        width: 53,
        height: 16,
        bodyHeight: 14,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge1_lvl18',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "bridge2_lvl18",
        image: "levels/18/bridge2_lvl18.png",
        width: 75,
        height: 18,
        bodyHeight: 16,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge2_lvl18',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "btnForTrans",
        image: 'levels/18/btnForTrans.png',
        width: 26,
        height: 50,
        frames: 2,
        bodyType: NONE,
        info: 'btnForTrans',
    },
    {
        name: "current_lvl18",
        image: 'levels/18/current_lvl18.png',
        width: 26,
        height: 46,
        frames: 20,
        bodyType: NONE,
        info: 'current_lvl18',
    },
    {
        name: "earth_lvl18",
        image: 'levels/18/earth_lvl18.png',
        width: 176,
        height: 106,
        frames: 1,
        bodyType: NONE,
        info: 'earth_lvl18',
    },
    {
        name: "green_lvl18",
        image: 'levels/18/green_lvl18.png',
        width: 14,
        height: 8,
        frames: 2,
        bodyType: NONE,
        info: 'green_lvl18',
    },
    {
        name: "lantern_lvl18",
        image: 'levels/18/lantern_lvl18.png',
        width: 14,
        height: 22,
        frames: 3,
        bodyType: NONE,
        info: 'lantern_lvl18',
    },
    {
        name: "lift_lvl18",
        image: "levels/18/lift_lvl18.png",
        width: 51,
        height: 186,
        bodyHeight: 184,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'lift_lvl18',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "red_lvl18",
        image: 'levels/18/red_lvl18.png',
        width: 14,
        height: 8,
        frames: 2,
        bodyType: NONE,
        info: 'red_lvl18',
    },
    {
        name: "trans1",
        image: 'levels/18/trans1.png',
        width: 245,
        height: 114,
        frames: 8,
        bodyType: NONE,
        info: 'trans1',
    },
    {
        name: "turnBtn_lvl18",
        image: 'levels/18/turnBtn_lvl18.png',
        width: 27,
        height: 25,
        frames: 1,
        bodyType: NONE,
        info: 'turnBtn_lvl18',
    },
    {
        name: "zemlaUp",
        image: 'levels/18/zemlaUp.png',
        width: 134,
        height: 162,
        frames: 1,
        bodyType: NONE,
        info: 'zemlaUp',
    },

/***************************************************
*                   Уровень 19
****************************************************/   

    {
        name: "bridge_lvl19",
        image: "levels/19/bridge_lvl19.png",
        width: 81,
        height: 17,
        bodyHeight: 15,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridge_lvl19',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "circle_lvl19",
        image: 'levels/19/circle_lvl19.png',
        width: 20,
        height: 20,
        frames: 1,
        bodyType: NONE,
        info: 'circle_lvl19',
    },
    {
        name: "cover_lvl19",
        image: "levels/19/cover_lvl19.png",
        width: 20,
        height: 65,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'cover_lvl19',
        density: obstacle_density,
        restitution: obstacle_restitution,
        friction: obstacle_friction
    },
    {
        name: "earth_lvl19",
        image: 'levels/19/earth_lvl19.png',
        width: 22,
        height: 77,
        frames: 1,
        bodyType: NONE,
        info: 'earth_lvl19',
    },
    {
        name: "foundation",
        image: 'levels/19/foundation.png',
        width: 16,
        height: 48,
        frames: 1,
        bodyType: NONE,
        info: 'foundation',
    },
    {
        name: "foundation2",
        image: 'levels/19/foundation2.png',
        width: 60,
        height: 20,
        frames: 1,
        bodyType: NONE,
        info: 'foundation2',
    }, 

/***************************************************
*                   Уровень 20
****************************************************/   

    {
        name: "boxGreen",
        image: 'levels/20/boxGreen.png',
        type: BOX,
        width: 34,
        height: 34,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'boxGreen',
        density: 5,
        restitution: 0,
        friction: 0.6     
    },
    {
        name: "boxRed",
        image: 'levels/20/boxRed.png',
        type: BOX,
        width: 34,
        height: 34,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'boxRed',
        density: 5,
        restitution: 0,
        friction: 0.6     
    },
    {
        name: "bridgeDown_lvl20",
        image: 'levels/20/bridgeDown_lvl20.png',
        width: 75,
        height: 19,
        bodyHeight: 17,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridgeDown_lvl20',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    },
    {
        name: "bridgeUp_lvl20",
        image: 'levels/20/bridgeUp_lvl20.png',
        width: 68,
        height: 15,
        bodyHeight: 13,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'bridgeUp_lvl20',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    },
    {
        name: "earthDown_lvl20",
        image: 'levels/20/earthDown_lvl20.png',
        width: 110,
        height: 29,
        frames: 1,
        bodyType: NONE,
        info: 'earthDown_lvl20',
    },
    {
        name: "earthUp_lvl20",
        image: 'levels/20/earthUp_lvl20.png',
        width: 117,
        height: 30,
        frames: 1,
        bodyType: NONE,
        info: 'earthUp_lvl20',
    },
    {
        name: "lift_cover1",
        image: 'levels/20/lift_cover1.png',
        width: 268,
        height: 92,
        frames: 1,
        bodyType: NONE,
        info: 'lift_cover1',
    },
    {
        name: "lift_cover2",
        image: 'levels/20/lift_cover2.png',
        width: 35,
        height: 88,
        frames: 1,
        bodyType: NONE,
        info: 'lift_cover2',
    },
    {
        name: "lift_lvl20",
        image: 'levels/20/lift_lvl20.png',
        width: 65,
        height: 240,
        bodyHeight: 238,
        frames: 1,
        bodyType: BOX,
        fixed: true,
        info: 'lift_lvl20',
        density: platform_density,
        restitution: platform_restitution,
        friction: platform_friction     
    },
    {
        name: "minus_plus_green",
        image: 'levels/20/minus_plus_green.png',
        width: 48,
        height: 26,
        frames: 2,
        bodyType: NONE,
        info: 'minus_plus_green',
    },
    {
        name: "minus_plus_red",
        image: 'levels/20/minus_plus_red.png',
        width: 48,
        height: 26,
        frames: 2,
        bodyType: NONE,
        info: 'minus_plus_red',
    },
    {
        name: "tube_cover_lvl20",
        image: 'levels/20/tube_cover_lvl20.png',
        width: 10,
        height: 60,
        frames: 1,
        bodyType: BOX,
        fixed: false,
        info: 'tube_cover_lvl20',
        density: 5,
        restitution: 0,
        friction: 0.6     
    },

];