function SimpleText(font, width, height)
{
	this.ALIGN_LEFT = 0;
	this.ALIGN_RIGHT = 1;
	this.ALIGN_CENTER = 2;

	this.font = font;
	this.x = 0;
	this.y = 0;
	this.width = width;
	this.height = height;
	this.align = this.ALIGN_LEFT;
	this.rotation = 0;
	this.charSpacing = 0;
	this.scale = 1;
	this.static = false;

	this.charMap = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
    this.charWidth = [];

	this.sprites = [];

	this.text = "";

	this.manageSprites = function(text)
	{
		var i, char;
		var len = text.length;
		var sp_len = this.sprites.length;
		if(sp_len < len)
		{
			for(i=0; i<len-sp_len; i++)
			{
				char = new Sprite(this.font, this.width, this.height, this.charMap.length);
				this.sprites.push(char);
				stage.addChild(char);
			}
		}

		if(sp_len > len)
		{
			for(i=0; i<sp_len-len; i++) stage.removeChild(this.sprites[i]);
			this.sprites.splice(0, sp_len-len);
		}
	}

    this.getCharIx = function(char)
    {
        for(var i=0; i<this.charMap.length; i++)
        {
            if(this.charMap[i] == char) return i;
        }
        return -1;
    }

    this.getCharWidth = function(char)
    {
        var i = this.getCharIx(char);

        if(i >= 0) return this.charWidth[i] ? this.charWidth[i] : this.width;
        else return this.width;
    }

    this.getWidth = function()
    {
        var w = 0;
        for(var i=0; i<this.text.length; i++)
        {
            w += this.getCharWidth(this.text.substr(i, 1)) + this.charSpacing;
        }

        return w;
    }

	this.write = function(text)
	{
		var curX, curY, p, p2, n;

		text = text + "";

		this.text = text;

		this.manageSprites(text);

		curX = this.x;
		curY = this.y;

		//if(this.align == this.ALIGN_CENTER) curX = this.x - (text.length-1)/2*(this.width+this.charSpacing)*this.scale;
		//if(this.align == this.ALIGN_RIGHT) curX = this.x - (text.length-1)*(this.width+this.charSpacing)*this.scale;

//        console.log('this.getWidth() = ', this.getWidth());

        if(this.align == this.ALIGN_CENTER) curX = this.x - this.getWidth()/2 * this.scale + (this.getCharWidth(this.text.substr(0, 1))/2);

//        console.log('1) curX = ', curX);

		if(this.align == this.ALIGN_RIGHT) curX = this.x - this.getWidth() * this.scale;

		p = new Vector(curX-this.x, 0);
		p.rotate(-this.rotation);
		curX = p.x + this.x;
		curY = p.y + this.y;

		p = new Vector(0, 0);
		for(var i=0; i<text.length; i++)
		{
			this.sprites[i].visible = true;
			n = this.charMap.indexOf(text.substr(i, 1));
			if(n < 0) this.sprites[i].visible = false;
			else
			{
                var chw = this.getCharWidth(this.text.substr(i, 1));

//                console.log('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> char = ', this.text.substr(i, 1));
//                console.log('width = ', chw);
//                console.log('this.sprites[i] = ', this.sprites[i]);

				this.sprites[i].scaleX = this.sprites[i].scaleY = this.scale;
				this.sprites[i].gotoAndStop(n);
				p2 = p.clone();
				p2.x *= this.scale;
				p2.rotate(-this.rotation);
				this.sprites[i].x = p2.x + (this.text.substr(i, 1) == ',' ? curX - (chw / 2) : curX);

//                console.log('2) curX = ', curX);
//                console.log('this.sprites[i].x = ', this.sprites[i].x);

				this.sprites[i].y = p2.y + curY;
				this.sprites[i].rotation = this.rotation;
				this.sprites[i].static = this.static;
				p.x += chw + this.charSpacing;// + (this.text.substr(i, 1) == ',' ? -(wch / 20) : 0);


			}
		}
	}

	this.refresh = function()
	{
		this.write(this.text);
	}

	this.addToGroup = function(group)
	{
		for(var i=0; i<this.sprites.length; i++)
		{
			this.sprites[i].gx = this.sprites[i].x/2;
			this.sprites[i].gy = this.sprites[i].y;
			group.addChild(this.sprites[i], false);
		}
	}
}