function TilesSprite(img, width, height, frames, rows, columns)
{
	TilesSprite.superclass.constructor.call(this, img, width, height, rows, columns);
	
	this.framesCount = frames;
	this.currentFrameX = 0;
	
	this.gotoAndStop = function(frame)
	{
		this.currentFrameX = frame;
		this.stop();
	};

	this.gotoAndPlay = function(frame)
	{
		this.currentFrameX = frame;
		this.play();
	};
	
	this.changeStep = function(e)
	{
		var self = e.target;
		
		if(self.animated && self.animStep + 1 >= self.animDelay)
		{
			self.currentFrameX++;
			if(self.currentFrameX >= self.framesCount) self.currentFrameX = 0;
		}
	};
	
	this.sync = function(e)
	{
		var self = e.target;
		
		self.currentLayer = Math.floor(self.currentFrameX / self.totalFrames);
		self.currentFrame = self.currentFrameX - self.currentLayer * self.totalFrames;
	};
	
	this.addEventListener("enterframe", this.changeStep);
	this.addEventListener("prerender", this.sync);
}

Utils.extend(TilesSprite, Sprite);